/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.14.2 on Sat Mar 23 21:54:52 2013
 */

#include "sipAPIqti.h"

#line 2188 "src/scripting/qti.sip"
#include "../src/core/ApplicationWindow.h"
#line 12 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"

#line 83 "src/scripting/qti.sip"
#include "../src/table/Table.h"
#include <QDate>
#include <QTime>
#include <QDateTime>
#include <datetime.h> // python include
#define CHECK_TABLE_COL(arg)\
    int col;\
    if (PyInt_Check(arg)) {\
      col = (int)PyInt_AsLong(arg) - 1;\
		if (col < 0 || col >= sipCpp->numCols()) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_ValueError, "There's no column %d in table %s!", col+1, sipCpp->name().ascii());\
		}\
	 } else {\
      PyObject *tmp = PyObject_Str(arg);\
		if (!tmp) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_TypeError, "Column argument must be either int or string.");\
		} else {\
			col = sipCpp->colIndex(PyString_AsString(tmp));\
			if (col < 0) {\
				sipIsErr = 1;\
				PyErr_Format(PyExc_ValueError, "There's no column named %s in table %s!", PyString_AsString(tmp),\
						sipCpp->name().ascii());\
				Py_DECREF(tmp);\
			}\
		}\
	 }

#define CHECK_TABLE_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in table %s!", row+1, sipCpp->name().ascii());\
	}

static int setCellDataHelper(Table* table, int row, int col, PyObject* item) {
  PyTypeObject* item_type = item->ob_type;
  if (item == Py_None) {
    table->clearCell(row, col);
    return 0;
  }
  switch (table->columnType(col)) {
  case Table::Numeric:
    item = PyNumber_Float(item);
    if (item) {
      table->setCell(row, col, PyFloat_AsDouble(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a float!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Text:
    item = PyObject_Str(item);
    if (item) {
      table->setText(row, col, PyString_AsString(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a string!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Date:
    if (sipCanConvertToType(item, sipType_QDateTime, 0)) {
      int isErr = 0;
      QDateTime* dateTime = reinterpret_cast<QDateTime*>(sipConvertToType(item, sipType_QDateTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, dateTime->toString(table->columnFormat(col)));
      delete dateTime;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a datetime!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Time:
    if (sipCanConvertToType(item, sipType_QTime, 0)) {
      int isErr = 0;
      QTime* time = reinterpret_cast<QTime*>(sipConvertToType(item, sipType_QTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, time->toString(table->columnFormat(col)));
      delete time;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a time!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Month:
    item = PyNumber_Int(item);
    if (item) {
      int m = PyInt_AS_LONG(item) % 12; // no type checking required since we casted above
      if (!m)
        m = 12;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "M")
          table->setText(row, col, QDate::shortMonthName(m).left(1));
      else if (format == "MMM")
          table->setText(row, col, QDate::shortMonthName(m));
      else if (format == "MMMM")
          table->setText(row, col, QDate::longMonthName(m));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Day:
    item = PyNumber_Int(item);
    if (item) {
      int day = PyInt_AS_LONG(item) % 7; // no type checking required since we casted above
      if (!day)
        day = 7;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "d")
          table->setText(row, col, QDate::shortDayName(day).left(1));
      else if (format == "ddd")
          table->setText(row, col, QDate::shortDayName(day));
      else if (format == "dddd")
          table->setText(row, col, QDate::longDayName(day));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  default:
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}

static int cellDataHelper(Table* table, int row, int col, PyObject** item) {
  switch (table->columnType(col)) {
  case Table::Numeric:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else
      *item = PyFloat_FromDouble(table->cell(row, col));
    break;
  case Table::Text:
    *item = PyString_FromString(table->text(row, col));
    break;
  case Table::Date:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QDateTime dateTime = QDateTime::fromString(table->text(row, col), table->columnFormat(col));
      QDate date = dateTime.date();
      QTime time = dateTime.time();
      *item = PyDateTime_FromDateAndTime(date.year(), date.month(), date.day(),
                                         time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Time:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QTime time = QTime::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyTime_FromTime(time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Month:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.month());
    }
    break;
  case Table::Day:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.dayOfWeek());
    }
    break;
  default:
    *item = NULL;
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}
#line 224 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 36 "/usr/share/sip/PyQt4/QtCore/qstring.sip"
#include <qstring.h>
#line 227 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 39 "/usr/share/sip/PyQt4/QtGui/qmdiarea.sip"
#include <qmdiarea.h>
#line 230 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qlineedit.sip"
#include <qlineedit.h>
#line 233 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qtextedit.sip"
#include <qtextedit.h>
#line 236 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 914 "src/scripting/qti.sip"
#include "../src/matrix/Matrix.h"
#define CHECK_MATRIX_COL(arg)\
	int col = arg-1;\
   if (col < 0 || col >= sipCpp->numCols()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no column %d in matrix %s!", col+1, sipCpp->name().ascii());\
	}
#define CHECK_MATRIX_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in matrix %s!", row+1, sipCpp->name().ascii());\
	}
#line 251 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 57 "src/scripting/qti.sip"
#include "../src/core/MdiSubWindow.h"
#line 254 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 1752 "src/scripting/qti.sip"
#include "../src/plot2D/Graph.h"
#include "../src/plot2D/LegendWidget.h"
#line 258 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 3470 "src/scripting/qti.sip"
#include "../src/core/Folder.h"
#line 261 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 264 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 2075 "src/scripting/qti.sip"
#include "../src/plot3D/Graph3D.h"
#line 267 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 1985 "src/scripting/qti.sip"
#include "../src/plot2D/MultiLayer.h"
#line 270 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 2041 "src/scripting/qti.sip"
#include "../src/scripting/Note.h"
#line 273 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 276 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qdockwidget.sip"
#include <qdockwidget.h>
#line 279 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 282 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qtabwidget.sip"
#include <qtabwidget.h>
#line 285 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 288 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qtoolbar.sip"
#include <qtoolbar.h>
#line 291 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qmainwindow.sip"
#include <qmainwindow.h>
#line 294 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qwidget.sip"
#include <qwidget.h>
#line 297 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qpoint.sip"
#include <qpoint.h>
#line 300 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 303 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 627 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 306 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qsize.sip"
#include <qsize.h>
#line 309 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qmenu.sip"
#include <qmenu.h>
#line 312 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 37 "/usr/share/sip/PyQt4/QtCore/qbytearray.sip"
#include <qbytearray.h>
#line 315 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qstatusbar.sip"
#include <qstatusbar.h>
#line 318 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qmenubar.sip"
#include <qmenubar.h>
#line 321 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 324 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 39 "/usr/share/sip/PyQt4/QtCore/qmargins.sip"
#include <qmargins.h>
#line 327 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 330 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 39 "/usr/share/sip/PyQt4/QtGui/qgraphicseffect.sip"
#include <qgraphicseffect.h>
#line 333 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 33 "/usr/share/sip/PyQt4/QtGui/qgraphicsproxywidget.sip"
#include <qgraphicsproxywidget.h>
#line 336 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qlocale.sip"
#include <qlocale.h>
#line 339 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qpaintdevice.sip"
#include <qpaintdevice.h>
#line 342 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qregion.sip"
#include <qregion.h>
#line 345 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qwidget.sip"
#include <qwidget.h>
#line 348 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qpainter.sip"
#include <qpainter.h>
#line 351 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qrect.sip"
#include <qrect.h>
#line 354 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qfontinfo.sip"
#include <qfontinfo.h>
#line 357 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qfontmetrics.sip"
#include <qfontmetrics.h>
#line 360 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qfont.sip"
#include <qfont.h>
#line 363 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 366 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qpalette.sip"
#include <qpalette.h>
#line 369 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 274 "/usr/share/sip/PyQt4/QtCore/qvariant.sip"
#include <qvariant.h>
#line 372 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 656 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 375 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 616 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 378 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 605 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 381 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 748 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 384 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 801 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 387 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 774 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 390 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 790 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 393 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 863 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 396 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 412 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 399 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 583 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 402 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 570 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 405 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 557 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 408 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 533 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 411 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 514 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 414 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 483 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 417 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 356 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 420 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 261 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 423 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 33 "/usr/share/sip/PyQt4/QtGui/qinputcontext.sip"
#include <qinputcontext.h>
#line 426 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 61 "/usr/share/sip/PyQt4/QtGui/qpaintengine.sip"
#include <qpaintengine.h>
#line 429 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 39 "/usr/share/sip/PyQt4/QtGui/qx11info_x11.sip"
#include <qx11info_x11.h>
#line 432 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 435 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qaction.sip"
#include <qaction.h>
#line 438 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qlayout.sip"
#include <qlayout.h>
#line 441 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qsizepolicy.sip"
#include <qsizepolicy.h>
#line 444 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 447 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qkeysequence.sip"
#include <qkeysequence.h>
#line 450 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qcursor.sip"
#include <qcursor.h>
#line 453 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qicon.sip"
#include <qicon.h>
#line 456 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qbitmap.sip"
#include <qbitmap.h>
#line 459 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qstyle.sip"
#include <qstyle.h>
#line 462 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 355 "/usr/share/sip/PyQt4/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 465 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 338 "/usr/share/sip/PyQt4/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 468 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 34 "/usr/share/sip/PyQt4/QtCore/qobject.sip"
#include <qobject.h>
#line 471 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 33 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 474 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 477 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtCore/qthread.sip"
#include <qthread.h>
#line 480 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qregexp.sip"
#include <qregexp.h>
#line 483 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
#line 31 "/usr/share/sip/PyQt4/QtCore/qobjectdefs.sip"
#include <qobjectdefs.h>
#line 486 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"


extern "C" {static PyObject *meth_ApplicationWindow_table(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_table(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Table *sipRes = 0;

#line 2200 "src/scripting/qti.sip"
  sipRes = sipCpp->current_folder->table(*a0, false);
  if(!sipRes)
    sipRes = sipCpp->projectFolder()->table(*a0, true);
#line 507 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Table,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_table, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_newTable(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_newTable(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            Table *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->newTable();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_Table,NULL);
        }
    }

    {
        const QString * a0;
        int a0State = 0;
        int a1 = 30;
        int a2 = 2;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1|ii", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State, &a1, &a2))
        {
            Table *sipRes = 0;

#line 2208 "src/scripting/qti.sip"
  sipRes = sipCpp->newTable(*a0, a1, a2);
#line 554 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Table,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_newTable, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_currentTable(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_currentTable(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            Table *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->currentTable();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_Table,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_currentTable, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_matrix(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_matrix(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Matrix *sipRes = 0;

#line 2212 "src/scripting/qti.sip"
  sipRes = sipCpp->current_folder->matrix(*a0, false);
  if(!sipRes)
    sipRes = sipCpp->projectFolder()->matrix(*a0, true);
#line 613 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Matrix,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_matrix, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_newMatrix(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_newMatrix(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            Matrix *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->newMatrix();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_Matrix,NULL);
        }
    }

    {
        const QString * a0;
        int a0State = 0;
        int a1 = 32;
        int a2 = 32;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1|ii", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State, &a1, &a2))
        {
            Matrix *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->newMatrix(*a0,a1,a2);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Matrix,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_newMatrix, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_currentMatrix(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_currentMatrix(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            Matrix *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->currentMatrix();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_Matrix,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_currentMatrix, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_graph(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_graph(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State))
        {
            MultiLayer *sipRes = 0;

#line 2221 "src/scripting/qti.sip"
  sipRes = sipCpp->current_folder->graph(*a0, false);
  if(!sipRes)
    sipRes = sipCpp->projectFolder()->graph(*a0, true);
#line 719 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_MultiLayer,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_graph, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_currentGraph(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_currentGraph(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            MultiLayer *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->currentPlot();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_MultiLayer,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_currentGraph, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_newGraph(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_newGraph(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString& a0def = "Graph1";
        const QString * a0 = &a0def;
        int a0State = 0;
        int a1 = 1;
        int a2 = 1;
        int a3 = 1;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|J1iii", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State, &a1, &a2, &a3))
        {
            MultiLayer *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->multilayerPlot(*a0,a1,a2,a3);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_MultiLayer,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_newGraph, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_note(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_note(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Note *sipRes = 0;

#line 2230 "src/scripting/qti.sip"
  sipRes = sipCpp->current_folder->note(*a0, false);
  if(!sipRes)
    sipRes = sipCpp->projectFolder()->note(*a0, true);
#line 812 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Note,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_note, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_newNote(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_newNote(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString& a0def = QString::null;
        const QString * a0 = &a0def;
        int a0State = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|J1", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Note *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->newNote(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Note,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_newNote, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_currentNote(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_currentNote(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            Note *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->currentNote();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_Note,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_currentNote, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_plot(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_plot(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table * a0;
        PyObject * a1;
        int a2 = 1;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8T|i", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Table, &a0, &PyTuple_Type, &a1, &a2))
        {
            MultiLayer *sipRes = 0;
            int sipIsErr = 0;

#line 2238 "src/scripting/qti.sip"
	if (a0 == 0) {
	   sipIsErr = 1;
	   PyErr_Format(PyExc_ValueError, "Invalid table in argument to plot().");
	} else {
	  QStringList l;
	  int n = PyTuple_Size(a1);
	  for (int i=0; i<n; i++) {
		PyObject *str = PyObject_Str(PyTuple_GET_ITEM(a1,i));
		if (str) {
		  l << PyString_AsString(str);
			Py_DECREF(str);
		 } else {
		  sipIsErr = 1;
		  break;
		}
	  }
	  sipRes = sipCpp->multilayerPlot(a0, l, a2);
	}
#line 919 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"

            if (sipIsErr)
                return 0;

            return sipConvertFromType(sipRes,sipType_MultiLayer,NULL);
        }
    }

    {
        Table * a0;
        const QString * a1;
        int a1State = 0;
        int a2 = 1;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8J1|i", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Table, &a0, sipType_QString,&a1, &a1State, &a2))
        {
            MultiLayer *sipRes = 0;
            int sipIsErr = 0;

#line 2259 "src/scripting/qti.sip"
	if (a0 == 0) {
	   sipIsErr = 1;
	   PyErr_Format(PyExc_ValueError, "Invalid table in argument to plot().");
	} else {
	  QStringList l;
	  l << *a1;
	  sipRes = sipCpp->multilayerPlot(a0, l, a2);
	}
#line 949 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            if (sipIsErr)
                return 0;

            return sipConvertFromType(sipRes,sipType_MultiLayer,NULL);
        }
    }

    {
        Matrix * a0;
        Graph::CurveType a1 = Graph::ColorMap;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8|E", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Matrix, &a0, sipType_Graph_CurveType, &a1))
        {
            MultiLayer *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->plotSpectrogram(a0,a1);
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_MultiLayer,NULL);
        }
    }

    {
        const QString * a0;
        int a0State = 0;
        double a1;
        double a2;
        int a3 = 100;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1dd|i", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State, &a1, &a2, &a3))
        {
            MultiLayer *sipRes = 0;

#line 2296 "src/scripting/qti.sip"
  QStringList l;
  l << *a0;
  sipRes = sipCpp->newFunctionPlot(l, a1, a2, a3);
#line 992 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_MultiLayer,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_plot, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_waterfallPlot(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_waterfallPlot(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table * a0;
        PyObject * a1;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8T", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Table, &a0, &PyTuple_Type, &a1))
        {
            MultiLayer *sipRes = 0;
            int sipIsErr = 0;

#line 2271 "src/scripting/qti.sip"
	if (a0 == 0) {
	   sipIsErr = 1;
	   PyErr_Format(PyExc_ValueError, "Invalid table in argument to waterfallPlot().");
	} else {
	  QStringList l;
	  int n = PyTuple_Size(a1);
	  for (int i=0; i<n; i++) {
		PyObject *str = PyObject_Str(PyTuple_GET_ITEM(a1,i));
		if (str) {
		  l << PyString_AsString(str);
			Py_DECREF(str);
		 } else {
		  sipIsErr = 1;
		  break;
		}
	  }
	  sipRes = sipCpp->waterfallPlot(a0, l);
	}
#line 1040 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"

            if (sipIsErr)
                return 0;

            return sipConvertFromType(sipRes,sipType_MultiLayer,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_waterfallPlot, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_importImage(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_importImage(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        bool a1;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1b", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State, &a1))
        {
            Matrix *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->importImage(*a0,a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Matrix,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_importImage, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_plotImageProfiles(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_plotImageProfiles(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Matrix * a0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Matrix, &a0))
        {
            MultiLayer *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->plotImageProfiles(a0);
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_MultiLayer,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_plotImageProfiles, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_plot3D(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_plot3D(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Graph3D *sipRes = 0;

#line 2303 "src/scripting/qti.sip"
  sipRes = sipCpp->current_folder->plot3D(*a0, false);
  if(!sipRes)
    sipRes = sipCpp->projectFolder()->plot3D(*a0, true);
#line 1133 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Graph3D,NULL);
        }
    }

    {
        Table * a0;
        const QString * a1;
        int a1State = 0;
        int a2 = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8J1|i", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Table, &a0, sipType_QString,&a1, &a1State, &a2))
        {
            Graph3D *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->plotXYZ(a0,*a1,a2);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            return sipConvertFromType(sipRes,sipType_Graph3D,NULL);
        }
    }

    {
        Matrix * a0;
        int a1 = 5;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8|i", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Matrix, &a0, &a1))
        {
            Graph3D *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->plot3DMatrix(a0,a1);
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_Graph3D,NULL);
        }
    }

    {
        const QString * a0;
        int a0State = 0;
        double a1;
        double a2;
        double a3;
        double a4;
        double a5;
        double a6;
        int a7 = 40;
        int a8 = 40;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1dddddd|ii", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State, &a1, &a2, &a3, &a4, &a5, &a6, &a7, &a8))
        {
            Graph3D *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->plotSurface(*a0,a1,a2,a3,a4,a5,a6,a7,a8);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Graph3D,NULL);
        }
    }

    {
        const QString * a0;
        int a0State = 0;
        const QString * a1;
        int a1State = 0;
        const QString * a2;
        int a2State = 0;
        double a3;
        double a4;
        double a5;
        double a6;
        int a7 = 40;
        int a8 = 40;
        bool a9 = 1;
        bool a10 = 1;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1J1J1dddd|iibb", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State, sipType_QString,&a1, &a1State, sipType_QString,&a2, &a2State, &a3, &a4, &a5, &a6, &a7, &a8, &a9, &a10))
        {
            Graph3D *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->plotParametricSurface(*a0,*a1,*a2,a3,a4,a5,a6,a7,a8,a9,a10);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);
            sipReleaseType(const_cast<QString *>(a2),sipType_QString,a2State);

            return sipConvertFromType(sipRes,sipType_Graph3D,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_plot3D, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_newPlot3D(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_newPlot3D(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString& a0def = QString();
        const QString * a0 = &a0def;
        int a0State = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|J1", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Graph3D *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->newPlot3D(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Graph3D,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_newPlot3D, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_windows(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_windows(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            QList<MdiSubWindow *> *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QList<MdiSubWindow *>(sipCpp->windowsList());
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QList_0101MdiSubWindow,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_windows, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_activeFolder(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_activeFolder(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            Folder *sipRes = 0;

#line 2321 "src/scripting/qti.sip"
  sipRes = sipCpp->current_folder;
#line 1314 "../tmp/qtiplot/sipqtiApplicationWindow.cpp"

            return sipConvertFromType(sipRes,sipType_Folder,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_activeFolder, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_appendProject(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_appendProject(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        Folder * a1 = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1|J8", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State, sipType_Folder, &a1))
        {
            Folder *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->appendProject(*a0,a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Folder,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_appendProject, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_saveFolder(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_saveFolder(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Folder * a0;
        const QString * a1;
        int a1State = 0;
        bool a2 = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8J1|b", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Folder, &a0, sipType_QString,&a1, &a1State, &a2))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->saveFolder(a0,*a1,a2);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_saveFolder, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_rootFolder(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_rootFolder(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            Folder *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->projectFolder();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_Folder,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_rootFolder, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_addFolder(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_addFolder(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        QString * a0;
        int a0State = 0;
        Folder * a1 = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1|J8", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State, sipType_Folder, &a1))
        {
            Folder *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->addFolder(*a0,a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(a0,sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Folder,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_addFolder, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_deleteFolder(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_deleteFolder(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Folder * a0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Folder, &a0))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->deleteFolder(a0);
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_deleteFolder, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_changeFolder(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_changeFolder(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Folder * a0;
        bool a1 = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8|b", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Folder, &a0, &a1))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->changeFolder(a0,a1);
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_changeFolder, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_copyFolder(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_copyFolder(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Folder * a0;
        Folder * a1;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8J8", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Folder, &a0, sipType_Folder, &a1))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->copyFolder(a0,a1);
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_copyFolder, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_openTemplate(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_openTemplate(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State))
        {
            MdiSubWindow *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->openTemplate(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_MdiSubWindow,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_openTemplate, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_saveAsTemplate(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_saveAsTemplate(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        MdiSubWindow * a0;
        const QString * a1;
        int a1State = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8J1", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_MdiSubWindow, &a0, sipType_QString,&a1, &a1State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->saveAsTemplate(a0,*a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_saveAsTemplate, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_setWindowName(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_setWindowName(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        MdiSubWindow * a0;
        const QString * a1;
        int a1State = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8J1", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_MdiSubWindow, &a0, sipType_QString,&a1, &a1State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setWindowName(a0,*a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_setWindowName, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_setPreferences(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_setPreferences(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph * a0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Graph, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setPreferences(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_setPreferences, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_saveProjectAs(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_saveProjectAs(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString& a0def = QString();
        const QString * a0 = &a0def;
        int a0State = 0;
        bool a1 = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|J1b", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->saveProjectAs(*a0,a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_saveProjectAs, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_clone(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_clone(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        MdiSubWindow * a0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_MdiSubWindow, &a0))
        {
            MdiSubWindow *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->clone(a0);
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_MdiSubWindow,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_clone, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_tableToMatrix(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_tableToMatrix(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table * a0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Table, &a0))
        {
            Matrix *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->tableToMatrix(a0);
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_Matrix,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_tableToMatrix, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_tableToMatrixRegularXYZ(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_tableToMatrixRegularXYZ(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table * a0;
        const QString * a1;
        int a1State = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8J1", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Table, &a0, sipType_QString,&a1, &a1State))
        {
            Matrix *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->tableToMatrixRegularXYZ(a0,*a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            return sipConvertFromType(sipRes,sipType_Matrix,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_tableToMatrixRegularXYZ, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_matrixToTable(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_matrixToTable(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Matrix * a0;
        ApplicationWindow::MatrixToTableConversion a1 = ApplicationWindow::Direct;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8|E", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Matrix, &a0, sipType_ApplicationWindow_MatrixToTableConversion, &a1))
        {
            Table *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->matrixToTable(a0,a1);
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_Table,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_matrixToTable, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_resultsLog(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_resultsLog(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            QTextEdit *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->resultsLog();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_QTextEdit,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_resultsLog, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_displayInfo(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_displayInfo(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->displayInfo(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_displayInfo, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_infoLineEdit(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_infoLineEdit(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            QLineEdit *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->infoLineEdit();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_QLineEdit,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_infoLineEdit, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_stemPlot(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_stemPlot(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table * a0;
        const QString * a1;
        int a1State = 0;
        int a2 = 1001;
        int a3 = 0;
        int a4 = -1;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8J1|iii", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_Table, &a0, sipType_QString,&a1, &a1State, &a2, &a3, &a4))
        {
            QString *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QString(sipCpp->stemPlot(a0,*a1,a2,a3,a4));
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            return sipConvertFromNewType(sipRes,sipType_QString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_stemPlot, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_workspace(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_workspace(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            QMdiArea *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->workspace();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_QMdiArea,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_workspace, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_importOdfSpreadsheet(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_importOdfSpreadsheet(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString& a0def = QString::null;
        const QString * a0 = &a0def;
        int a0State = 0;
        int a1 = -1;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|J1i", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State, &a1))
        {
            Table *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->importOdfSpreadsheet(*a0,a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Table,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_importOdfSpreadsheet, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_importExcel(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_importExcel(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString& a0def = QString::null;
        const QString * a0 = &a0def;
        int a0State = 0;
        int a1 = -1;
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|J1i", &sipSelf, sipType_ApplicationWindow, &sipCpp, sipType_QString,&a0, &a0State, &a1))
        {
            Table *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->importExcel(*a0,a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return sipConvertFromType(sipRes,sipType_Table,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_importExcel, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ApplicationWindow_importWaveFile(PyObject *, PyObject *);}
static PyObject *meth_ApplicationWindow_importWaveFile(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ApplicationWindow *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ApplicationWindow, &sipCpp))
        {
            Table *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->importWaveFile();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_Table,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ApplicationWindow, sipName_importWaveFile, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_ApplicationWindow(void *, const sipTypeDef *);}
static void *cast_ApplicationWindow(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_ApplicationWindow)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_QMainWindow)->ctd_cast((QMainWindow *)(ApplicationWindow *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_ApplicationWindow(void *, int);}
static void release_ApplicationWindow(void *sipCppV,int)
{
    Py_BEGIN_ALLOW_THREADS

    ApplicationWindow *sipCpp = reinterpret_cast<ApplicationWindow *>(sipCppV);

    if (QThread::currentThread() == sipCpp->thread())
        delete sipCpp;
    else
        sipCpp->deleteLater();

    Py_END_ALLOW_THREADS
}


extern "C" {static void dealloc_ApplicationWindow(sipSimpleWrapper *);}
static void dealloc_ApplicationWindow(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_ApplicationWindow(sipGetAddress(sipSelf),0);
    }
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_ApplicationWindow[] = {{323, 1, 1}};


static PyMethodDef methods_ApplicationWindow[] = {
    {SIP_MLNAME_CAST(sipName_activeFolder), meth_ApplicationWindow_activeFolder, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_addFolder), meth_ApplicationWindow_addFolder, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_appendProject), meth_ApplicationWindow_appendProject, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_changeFolder), meth_ApplicationWindow_changeFolder, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_clone), meth_ApplicationWindow_clone, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_copyFolder), meth_ApplicationWindow_copyFolder, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_currentGraph), meth_ApplicationWindow_currentGraph, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_currentMatrix), meth_ApplicationWindow_currentMatrix, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_currentNote), meth_ApplicationWindow_currentNote, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_currentTable), meth_ApplicationWindow_currentTable, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_deleteFolder), meth_ApplicationWindow_deleteFolder, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_displayInfo), meth_ApplicationWindow_displayInfo, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_graph), meth_ApplicationWindow_graph, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_importExcel), meth_ApplicationWindow_importExcel, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_importImage), meth_ApplicationWindow_importImage, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_importOdfSpreadsheet), meth_ApplicationWindow_importOdfSpreadsheet, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_importWaveFile), meth_ApplicationWindow_importWaveFile, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_infoLineEdit), meth_ApplicationWindow_infoLineEdit, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_matrix), meth_ApplicationWindow_matrix, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_matrixToTable), meth_ApplicationWindow_matrixToTable, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_newGraph), meth_ApplicationWindow_newGraph, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_newMatrix), meth_ApplicationWindow_newMatrix, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_newNote), meth_ApplicationWindow_newNote, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_newPlot3D), meth_ApplicationWindow_newPlot3D, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_newTable), meth_ApplicationWindow_newTable, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_note), meth_ApplicationWindow_note, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_openTemplate), meth_ApplicationWindow_openTemplate, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_plot), meth_ApplicationWindow_plot, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_plot3D), meth_ApplicationWindow_plot3D, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_plotImageProfiles), meth_ApplicationWindow_plotImageProfiles, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_resultsLog), meth_ApplicationWindow_resultsLog, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_rootFolder), meth_ApplicationWindow_rootFolder, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_saveAsTemplate), meth_ApplicationWindow_saveAsTemplate, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_saveFolder), meth_ApplicationWindow_saveFolder, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_saveProjectAs), meth_ApplicationWindow_saveProjectAs, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setPreferences), meth_ApplicationWindow_setPreferences, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setWindowName), meth_ApplicationWindow_setWindowName, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_stemPlot), meth_ApplicationWindow_stemPlot, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_table), meth_ApplicationWindow_table, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_tableToMatrix), meth_ApplicationWindow_tableToMatrix, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_tableToMatrixRegularXYZ), meth_ApplicationWindow_tableToMatrixRegularXYZ, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_waterfallPlot), meth_ApplicationWindow_waterfallPlot, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_windows), meth_ApplicationWindow_windows, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_workspace), meth_ApplicationWindow_workspace, METH_VARARGS, NULL}
};

static sipEnumMemberDef enummembers_ApplicationWindow[] = {
    {sipName_Direct, ApplicationWindow::Direct, 2},
    {sipName_XYZ, ApplicationWindow::XYZ, 2},
    {sipName_YXZ, ApplicationWindow::YXZ, 2},
};


pyqt4ClassTypeDef sipTypeDef_qti_ApplicationWindow = {
{
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_ApplicationWindow,
        {0}
    },
    {
        sipNameNr_ApplicationWindow,
        {0, 0, 1},
        44, methods_ApplicationWindow,
        3, enummembers_ApplicationWindow,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    0,
    -1,
    -1,
    supers_ApplicationWindow,
    0,
    0,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_ApplicationWindow,
    0,
    0,
    0,
    release_ApplicationWindow,
    cast_ApplicationWindow,
    0,
    0,
    0
},
    &ApplicationWindow::staticMetaObject,
    0,
    0
};
