/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.14.2 on Sat Mar 23 21:54:52 2013
 */

#include "sipAPIqti.h"

#line 1555 "src/scripting/qti.sip"
#include "../src/plot2D/BoxCurve.h"
#line 12 "../tmp/qtiplot/sipqtiBoxCurve.cpp"

#line 83 "src/scripting/qti.sip"
#include "../src/table/Table.h"
#include <QDate>
#include <QTime>
#include <QDateTime>
#include <datetime.h> // python include
#define CHECK_TABLE_COL(arg)\
    int col;\
    if (PyInt_Check(arg)) {\
      col = (int)PyInt_AsLong(arg) - 1;\
		if (col < 0 || col >= sipCpp->numCols()) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_ValueError, "There's no column %d in table %s!", col+1, sipCpp->name().ascii());\
		}\
	 } else {\
      PyObject *tmp = PyObject_Str(arg);\
		if (!tmp) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_TypeError, "Column argument must be either int or string.");\
		} else {\
			col = sipCpp->colIndex(PyString_AsString(tmp));\
			if (col < 0) {\
				sipIsErr = 1;\
				PyErr_Format(PyExc_ValueError, "There's no column named %s in table %s!", PyString_AsString(tmp),\
						sipCpp->name().ascii());\
				Py_DECREF(tmp);\
			}\
		}\
	 }

#define CHECK_TABLE_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in table %s!", row+1, sipCpp->name().ascii());\
	}

static int setCellDataHelper(Table* table, int row, int col, PyObject* item) {
  PyTypeObject* item_type = item->ob_type;
  if (item == Py_None) {
    table->clearCell(row, col);
    return 0;
  }
  switch (table->columnType(col)) {
  case Table::Numeric:
    item = PyNumber_Float(item);
    if (item) {
      table->setCell(row, col, PyFloat_AsDouble(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a float!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Text:
    item = PyObject_Str(item);
    if (item) {
      table->setText(row, col, PyString_AsString(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a string!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Date:
    if (sipCanConvertToType(item, sipType_QDateTime, 0)) {
      int isErr = 0;
      QDateTime* dateTime = reinterpret_cast<QDateTime*>(sipConvertToType(item, sipType_QDateTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, dateTime->toString(table->columnFormat(col)));
      delete dateTime;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a datetime!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Time:
    if (sipCanConvertToType(item, sipType_QTime, 0)) {
      int isErr = 0;
      QTime* time = reinterpret_cast<QTime*>(sipConvertToType(item, sipType_QTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, time->toString(table->columnFormat(col)));
      delete time;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a time!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Month:
    item = PyNumber_Int(item);
    if (item) {
      int m = PyInt_AS_LONG(item) % 12; // no type checking required since we casted above
      if (!m)
        m = 12;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "M")
          table->setText(row, col, QDate::shortMonthName(m).left(1));
      else if (format == "MMM")
          table->setText(row, col, QDate::shortMonthName(m));
      else if (format == "MMMM")
          table->setText(row, col, QDate::longMonthName(m));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Day:
    item = PyNumber_Int(item);
    if (item) {
      int day = PyInt_AS_LONG(item) % 7; // no type checking required since we casted above
      if (!day)
        day = 7;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "d")
          table->setText(row, col, QDate::shortDayName(day).left(1));
      else if (format == "ddd")
          table->setText(row, col, QDate::shortDayName(day));
      else if (format == "dddd")
          table->setText(row, col, QDate::longDayName(day));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  default:
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}

static int cellDataHelper(Table* table, int row, int col, PyObject** item) {
  switch (table->columnType(col)) {
  case Table::Numeric:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else
      *item = PyFloat_FromDouble(table->cell(row, col));
    break;
  case Table::Text:
    *item = PyString_FromString(table->text(row, col));
    break;
  case Table::Date:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QDateTime dateTime = QDateTime::fromString(table->text(row, col), table->columnFormat(col));
      QDate date = dateTime.date();
      QTime time = dateTime.time();
      *item = PyDateTime_FromDateAndTime(date.year(), date.month(), date.day(),
                                         time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Time:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QTime time = QTime::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyTime_FromTime(time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Month:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.month());
    }
    break;
  case Table::Day:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.dayOfWeek());
    }
    break;
  default:
    *item = NULL;
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}
#line 224 "../tmp/qtiplot/sipqtiBoxCurve.cpp"
#line 36 "/usr/share/sip/PyQt4/QtCore/qstring.sip"
#include <qstring.h>
#line 227 "../tmp/qtiplot/sipqtiBoxCurve.cpp"
#line 1160 "src/scripting/qti.sip"
#include <qwt_symbol.h>
#line 230 "../tmp/qtiplot/sipqtiBoxCurve.cpp"
#line 1371 "src/scripting/qti.sip"
#include "../src/plot2D/ErrorBarsCurve.h"
#line 233 "../tmp/qtiplot/sipqtiBoxCurve.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 236 "../tmp/qtiplot/sipqtiBoxCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qcolor.sip"
#include <qcolor.h>
#line 239 "../tmp/qtiplot/sipqtiBoxCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qfont.sip"
#include <qfont.h>
#line 242 "../tmp/qtiplot/sipqtiBoxCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qbrush.sip"
#include <qbrush.h>
#line 245 "../tmp/qtiplot/sipqtiBoxCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qpen.sip"
#include <qpen.h>
#line 248 "../tmp/qtiplot/sipqtiBoxCurve.cpp"


extern "C" {static PyObject *meth_BoxCurve_minStyle(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_minStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            QwtSymbol::Style sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->minStyle();
            Py_END_ALLOW_THREADS

            return sipConvertFromEnum(sipRes,sipType_QwtSymbol_Style);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_minStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_setMinStyle(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_setMinStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        QwtSymbol::Style a0;
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BE", &sipSelf, sipType_BoxCurve, &sipCpp, sipType_QwtSymbol_Style, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setMinStyle(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_setMinStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_maxStyle(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_maxStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            QwtSymbol::Style sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->maxStyle();
            Py_END_ALLOW_THREADS

            return sipConvertFromEnum(sipRes,sipType_QwtSymbol_Style);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_maxStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_setMaxStyle(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_setMaxStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        QwtSymbol::Style a0;
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BE", &sipSelf, sipType_BoxCurve, &sipCpp, sipType_QwtSymbol_Style, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setMaxStyle(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_setMaxStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_setMeanStyle(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_setMeanStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        QwtSymbol::Style a0;
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BE", &sipSelf, sipType_BoxCurve, &sipCpp, sipType_QwtSymbol_Style, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setMeanStyle(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_setMeanStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_meanStyle(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_meanStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            QwtSymbol::Style sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->meanStyle();
            Py_END_ALLOW_THREADS

            return sipConvertFromEnum(sipRes,sipType_QwtSymbol_Style);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_meanStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_setP99Style(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_setP99Style(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        QwtSymbol::Style a0;
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BE", &sipSelf, sipType_BoxCurve, &sipCpp, sipType_QwtSymbol_Style, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setP99Style(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_setP99Style, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_p99Style(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_p99Style(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            QwtSymbol::Style sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->p99Style();
            Py_END_ALLOW_THREADS

            return sipConvertFromEnum(sipRes,sipType_QwtSymbol_Style);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_p99Style, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_setP1Style(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_setP1Style(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        QwtSymbol::Style a0;
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BE", &sipSelf, sipType_BoxCurve, &sipCpp, sipType_QwtSymbol_Style, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setP1Style(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_setP1Style, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_p1Style(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_p1Style(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            QwtSymbol::Style sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->p1Style();
            Py_END_ALLOW_THREADS

            return sipConvertFromEnum(sipRes,sipType_QwtSymbol_Style);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_p1Style, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_boxStyle(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_boxStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->boxStyle();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_boxStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_setBoxStyle(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_setBoxStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_BoxCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setBoxStyle(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_setBoxStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_boxWidth(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_boxWidth(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->boxWidth();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_boxWidth, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_setBoxWidth(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_setBoxWidth(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_BoxCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setBoxWidth(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_setBoxWidth, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_boxRange(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_boxRange(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->boxRange();
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_boxRange, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_boxRangeType(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_boxRangeType(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->boxRangeType();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_boxRangeType, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_setBoxRange(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_setBoxRange(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        double a1;
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bid", &sipSelf, sipType_BoxCurve, &sipCpp, &a0, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setBoxRange(a0,a1);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_setBoxRange, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_whiskersRange(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_whiskersRange(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->whiskersRange();
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_whiskersRange, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_whiskersRangeType(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_whiskersRangeType(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->whiskersRangeType();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_whiskersRangeType, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_setWhiskersRange(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_setWhiskersRange(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        double a1 = 0;
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi|d", &sipSelf, sipType_BoxCurve, &sipCpp, &a0, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setWhiskersRange(a0,a1);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_setWhiskersRange, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_loadData(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_loadData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->loadData();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_loadData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_statistics(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_statistics(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            QString *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QString(sipCpp->statistics());
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_statistics, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_median(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_median(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_BoxCurve, &sipCpp))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->median();
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_median, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_BoxCurve_quantile(PyObject *, PyObject *);}
static PyObject *meth_BoxCurve_quantile(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        BoxCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bd", &sipSelf, sipType_BoxCurve, &sipCpp, &a0))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->quantile(a0);
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_BoxCurve, sipName_quantile, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_BoxCurve(void *, const sipTypeDef *);}
static void *cast_BoxCurve(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_BoxCurve)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_DataCurve)->ctd_cast((DataCurve *)(BoxCurve *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_BoxCurve(void *, int);}
static void release_BoxCurve(void *sipCppV,int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast<BoxCurve *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void dealloc_BoxCurve(sipSimpleWrapper *);}
static void dealloc_BoxCurve(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_BoxCurve(sipGetAddress(sipSelf),0);
    }
}


extern "C" {static void *init_BoxCurve(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_BoxCurve(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    BoxCurve *sipCpp = 0;

    {
        Table * a0;
        const QString * a1;
        int a1State = 0;
        int a2 = 0;
        int a3 = -1;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J8J1|ii", sipType_Table, &a0, sipType_QString,&a1, &a1State, &a2, &a3))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new BoxCurve(a0,*a1,a2,a3);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_BoxCurve[] = {{10, 255, 1}};


static PyMethodDef methods_BoxCurve[] = {
    {SIP_MLNAME_CAST(sipName_boxRange), meth_BoxCurve_boxRange, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_boxRangeType), meth_BoxCurve_boxRangeType, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_boxStyle), meth_BoxCurve_boxStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_boxWidth), meth_BoxCurve_boxWidth, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_loadData), meth_BoxCurve_loadData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_maxStyle), meth_BoxCurve_maxStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_meanStyle), meth_BoxCurve_meanStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_median), meth_BoxCurve_median, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_minStyle), meth_BoxCurve_minStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_p1Style), meth_BoxCurve_p1Style, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_p99Style), meth_BoxCurve_p99Style, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_quantile), meth_BoxCurve_quantile, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setBoxRange), meth_BoxCurve_setBoxRange, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setBoxStyle), meth_BoxCurve_setBoxStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setBoxWidth), meth_BoxCurve_setBoxWidth, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setMaxStyle), meth_BoxCurve_setMaxStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setMeanStyle), meth_BoxCurve_setMeanStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setMinStyle), meth_BoxCurve_setMinStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setP1Style), meth_BoxCurve_setP1Style, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setP99Style), meth_BoxCurve_setP99Style, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setWhiskersRange), meth_BoxCurve_setWhiskersRange, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_statistics), meth_BoxCurve_statistics, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_whiskersRange), meth_BoxCurve_whiskersRange, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_whiskersRangeType), meth_BoxCurve_whiskersRangeType, METH_VARARGS, NULL}
};

static sipEnumMemberDef enummembers_BoxCurve[] = {
    {sipName_Diamond, BoxCurve::Diamond, 5},
    {sipName_MinMax, BoxCurve::MinMax, 6},
    {sipName_NoBox, BoxCurve::NoBox, 5},
    {sipName_None, BoxCurve::None, 6},
    {sipName_Notch, BoxCurve::Notch, 5},
    {sipName_Rect, BoxCurve::Rect, 5},
    {sipName_SD, BoxCurve::SD, 6},
    {sipName_SE, BoxCurve::SE, 6},
    {sipName_UserDef, BoxCurve::UserDef, 6},
    {sipName_WindBox, BoxCurve::WindBox, 5},
    {sipName_r10_90, BoxCurve::r10_90, 6},
    {sipName_r1_99, BoxCurve::r1_99, 6},
    {sipName_r25_75, BoxCurve::r25_75, 6},
    {sipName_r5_95, BoxCurve::r5_95, 6},
};


pyqt4ClassTypeDef sipTypeDef_qti_BoxCurve = {
{
    {
        -1,
        0,
        0,
        SIP_TYPE_CLASS,
        sipNameNr_BoxCurve,
        {0}
    },
    {
        sipNameNr_BoxCurve,
        {0, 0, 1},
        24, methods_BoxCurve,
        14, enummembers_BoxCurve,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    0,
    -1,
    -1,
    supers_BoxCurve,
    0,
    init_BoxCurve,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_BoxCurve,
    0,
    0,
    0,
    release_BoxCurve,
    cast_BoxCurve,
    0,
    0,
    0
},
    0,
    0,
    0
};
