/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.14.2 on Sat Mar 23 21:54:52 2013
 */

#include "sipAPIqti.h"

#line 1315 "src/scripting/qti.sip"
#include "../src/plot2D/PlotCurve.h"
#line 12 "../tmp/qtiplot/sipqtiDataCurve.cpp"

#line 83 "src/scripting/qti.sip"
#include "../src/table/Table.h"
#include <QDate>
#include <QTime>
#include <QDateTime>
#include <datetime.h> // python include
#define CHECK_TABLE_COL(arg)\
    int col;\
    if (PyInt_Check(arg)) {\
      col = (int)PyInt_AsLong(arg) - 1;\
		if (col < 0 || col >= sipCpp->numCols()) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_ValueError, "There's no column %d in table %s!", col+1, sipCpp->name().ascii());\
		}\
	 } else {\
      PyObject *tmp = PyObject_Str(arg);\
		if (!tmp) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_TypeError, "Column argument must be either int or string.");\
		} else {\
			col = sipCpp->colIndex(PyString_AsString(tmp));\
			if (col < 0) {\
				sipIsErr = 1;\
				PyErr_Format(PyExc_ValueError, "There's no column named %s in table %s!", PyString_AsString(tmp),\
						sipCpp->name().ascii());\
				Py_DECREF(tmp);\
			}\
		}\
	 }

#define CHECK_TABLE_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in table %s!", row+1, sipCpp->name().ascii());\
	}

static int setCellDataHelper(Table* table, int row, int col, PyObject* item) {
  PyTypeObject* item_type = item->ob_type;
  if (item == Py_None) {
    table->clearCell(row, col);
    return 0;
  }
  switch (table->columnType(col)) {
  case Table::Numeric:
    item = PyNumber_Float(item);
    if (item) {
      table->setCell(row, col, PyFloat_AsDouble(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a float!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Text:
    item = PyObject_Str(item);
    if (item) {
      table->setText(row, col, PyString_AsString(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a string!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Date:
    if (sipCanConvertToType(item, sipType_QDateTime, 0)) {
      int isErr = 0;
      QDateTime* dateTime = reinterpret_cast<QDateTime*>(sipConvertToType(item, sipType_QDateTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, dateTime->toString(table->columnFormat(col)));
      delete dateTime;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a datetime!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Time:
    if (sipCanConvertToType(item, sipType_QTime, 0)) {
      int isErr = 0;
      QTime* time = reinterpret_cast<QTime*>(sipConvertToType(item, sipType_QTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, time->toString(table->columnFormat(col)));
      delete time;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a time!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Month:
    item = PyNumber_Int(item);
    if (item) {
      int m = PyInt_AS_LONG(item) % 12; // no type checking required since we casted above
      if (!m)
        m = 12;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "M")
          table->setText(row, col, QDate::shortMonthName(m).left(1));
      else if (format == "MMM")
          table->setText(row, col, QDate::shortMonthName(m));
      else if (format == "MMMM")
          table->setText(row, col, QDate::longMonthName(m));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Day:
    item = PyNumber_Int(item);
    if (item) {
      int day = PyInt_AS_LONG(item) % 7; // no type checking required since we casted above
      if (!day)
        day = 7;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "d")
          table->setText(row, col, QDate::shortDayName(day).left(1));
      else if (format == "ddd")
          table->setText(row, col, QDate::shortDayName(day));
      else if (format == "dddd")
          table->setText(row, col, QDate::longDayName(day));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  default:
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}

static int cellDataHelper(Table* table, int row, int col, PyObject** item) {
  switch (table->columnType(col)) {
  case Table::Numeric:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else
      *item = PyFloat_FromDouble(table->cell(row, col));
    break;
  case Table::Text:
    *item = PyString_FromString(table->text(row, col));
    break;
  case Table::Date:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QDateTime dateTime = QDateTime::fromString(table->text(row, col), table->columnFormat(col));
      QDate date = dateTime.date();
      QTime time = dateTime.time();
      *item = PyDateTime_FromDateAndTime(date.year(), date.month(), date.day(),
                                         time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Time:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QTime time = QTime::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyTime_FromTime(time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Month:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.month());
    }
    break;
  case Table::Day:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.dayOfWeek());
    }
    break;
  default:
    *item = NULL;
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}
#line 224 "../tmp/qtiplot/sipqtiDataCurve.cpp"
#line 36 "/usr/share/sip/PyQt4/QtCore/qstring.sip"
#include <qstring.h>
#line 227 "../tmp/qtiplot/sipqtiDataCurve.cpp"
#line 1371 "src/scripting/qti.sip"
#include "../src/plot2D/ErrorBarsCurve.h"
#line 230 "../tmp/qtiplot/sipqtiDataCurve.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 233 "../tmp/qtiplot/sipqtiDataCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qcolor.sip"
#include <qcolor.h>
#line 236 "../tmp/qtiplot/sipqtiDataCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qfont.sip"
#include <qfont.h>
#line 239 "../tmp/qtiplot/sipqtiDataCurve.cpp"
#line 1160 "src/scripting/qti.sip"
#include <qwt_symbol.h>
#line 242 "../tmp/qtiplot/sipqtiDataCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qbrush.sip"
#include <qbrush.h>
#line 245 "../tmp/qtiplot/sipqtiDataCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qpen.sip"
#include <qpen.h>
#line 248 "../tmp/qtiplot/sipqtiDataCurve.cpp"


extern "C" {static PyObject *meth_DataCurve_hasLabels(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_hasLabels(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->hasLabels();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_hasLabels, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_labelsColumnName(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_labelsColumnName(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            QString *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QString(sipCpp->labelsColumnName());
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_labelsColumnName, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_setLabelsColumnName(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_setLabelsColumnName(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_DataCurve, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelsColumnName(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_setLabelsColumnName, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_labelsAlignment(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_labelsAlignment(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->labelsAlignment();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_labelsAlignment, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_setLabelsAlignment(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_setLabelsAlignment(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_DataCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelsAlignment(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_setLabelsAlignment, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_labelsXOffset(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_labelsXOffset(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->labelsXOffset();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_labelsXOffset, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_labelsYOffset(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_labelsYOffset(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->labelsYOffset();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_labelsYOffset, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_setLabelsOffset(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_setLabelsOffset(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        int a1;
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bii", &sipSelf, sipType_DataCurve, &sipCpp, &a0, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelsOffset(a0,a1);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_setLabelsOffset, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_labelsRotation(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_labelsRotation(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->labelsRotation();
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_labelsRotation, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_setLabelsRotation(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_setLabelsRotation(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bd", &sipSelf, sipType_DataCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelsRotation(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_setLabelsRotation, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_labelsFont(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_labelsFont(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            QFont *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QFont(sipCpp->labelsFont());
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QFont,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_labelsFont, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_setLabelsFont(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_setLabelsFont(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QFont * a0;
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ9", &sipSelf, sipType_DataCurve, &sipCpp, sipType_QFont, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelsFont(*a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_setLabelsFont, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_labelsColor(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_labelsColor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            QColor *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QColor(sipCpp->labelsColor());
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QColor,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_labelsColor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_setLabelsColor(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_setLabelsColor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QColor * a0;
        int a0State = 0;
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_DataCurve, &sipCpp, sipType_QColor, &a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelsColor(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QColor *>(a0),sipType_QColor,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_setLabelsColor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_labelsWhiteOut(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_labelsWhiteOut(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->labelsWhiteOut();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_labelsWhiteOut, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_setLabelsWhiteOut(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_setLabelsWhiteOut(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_DataCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelsWhiteOut(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_setLabelsWhiteOut, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_table(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_table(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            Table *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->table();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_Table,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_table, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_startRow(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_startRow(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->startRow();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_startRow, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_endRow(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_endRow(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->endRow();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_endRow, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_setRowRange(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_setRowRange(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        int a1;
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bii", &sipSelf, sipType_DataCurve, &sipCpp, &a0, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setRowRange(a0,a1);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_setRowRange, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_isFullRange(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_isFullRange(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->isFullRange();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_isFullRange, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_setFullRange(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_setFullRange(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setFullRange();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_setFullRange, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_updateData(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_updateData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table * a0;
        const QString * a1;
        int a1State = 0;
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8J1", &sipSelf, sipType_DataCurve, &sipCpp, sipType_Table, &a0, sipType_QString,&a1, &a1State))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->updateData(a0,*a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_updateData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_loadData(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_loadData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->loadData();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_loadData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_errorBarsList(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_errorBarsList(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            QList<ErrorBarsCurve *> *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QList<ErrorBarsCurve *>(sipCpp->errorBarsList());
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QList_0101ErrorBarsCurve,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_errorBarsList, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_removeErrorBars(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_removeErrorBars(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ErrorBarsCurve * a0;
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_DataCurve, &sipCpp, sipType_ErrorBarsCurve, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->removeErrorBars(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_removeErrorBars, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_clearErrorBars(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_clearErrorBars(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->clearErrorBars();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_clearErrorBars, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_DataCurve_clearLabels(PyObject *, PyObject *);}
static PyObject *meth_DataCurve_clearLabels(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_DataCurve, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->clearLabels();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DataCurve, sipName_clearLabels, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_DataCurve(void *, const sipTypeDef *);}
static void *cast_DataCurve(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_DataCurve)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_PlotCurve)->ctd_cast((PlotCurve *)(DataCurve *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_DataCurve(void *, int);}
static void release_DataCurve(void *sipCppV,int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast<DataCurve *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void dealloc_DataCurve(sipSimpleWrapper *);}
static void dealloc_DataCurve(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_DataCurve(sipGetAddress(sipSelf),0);
    }
}


extern "C" {static void *init_DataCurve(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_DataCurve(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    DataCurve *sipCpp = 0;

    {
        Table * a0;
        const QString * a1;
        int a1State = 0;
        const QString * a2;
        int a2State = 0;
        int a3 = 0;
        int a4 = -1;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J8J1J1|ii", sipType_Table, &a0, sipType_QString,&a1, &a1State, sipType_QString,&a2, &a2State, &a3, &a4))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new DataCurve(a0,*a1,*a2,a3,a4);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);
            sipReleaseType(const_cast<QString *>(a2),sipType_QString,a2State);

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_DataCurve[] = {{66, 255, 1}};


static PyMethodDef methods_DataCurve[] = {
    {SIP_MLNAME_CAST(sipName_clearErrorBars), meth_DataCurve_clearErrorBars, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_clearLabels), meth_DataCurve_clearLabels, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_endRow), meth_DataCurve_endRow, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_errorBarsList), meth_DataCurve_errorBarsList, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_hasLabels), meth_DataCurve_hasLabels, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_isFullRange), meth_DataCurve_isFullRange, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelsAlignment), meth_DataCurve_labelsAlignment, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelsColor), meth_DataCurve_labelsColor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelsColumnName), meth_DataCurve_labelsColumnName, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelsFont), meth_DataCurve_labelsFont, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelsRotation), meth_DataCurve_labelsRotation, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelsWhiteOut), meth_DataCurve_labelsWhiteOut, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelsXOffset), meth_DataCurve_labelsXOffset, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelsYOffset), meth_DataCurve_labelsYOffset, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_loadData), meth_DataCurve_loadData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_removeErrorBars), meth_DataCurve_removeErrorBars, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setFullRange), meth_DataCurve_setFullRange, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelsAlignment), meth_DataCurve_setLabelsAlignment, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelsColor), meth_DataCurve_setLabelsColor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelsColumnName), meth_DataCurve_setLabelsColumnName, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelsFont), meth_DataCurve_setLabelsFont, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelsOffset), meth_DataCurve_setLabelsOffset, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelsRotation), meth_DataCurve_setLabelsRotation, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelsWhiteOut), meth_DataCurve_setLabelsWhiteOut, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setRowRange), meth_DataCurve_setRowRange, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_startRow), meth_DataCurve_startRow, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_table), meth_DataCurve_table, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_updateData), meth_DataCurve_updateData, METH_VARARGS, NULL}
};


pyqt4ClassTypeDef sipTypeDef_qti_DataCurve = {
{
    {
        -1,
        0,
        0,
        SIP_TYPE_CLASS,
        sipNameNr_DataCurve,
        {0}
    },
    {
        sipNameNr_DataCurve,
        {0, 0, 1},
        28, methods_DataCurve,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    0,
    -1,
    -1,
    supers_DataCurve,
    0,
    init_DataCurve,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_DataCurve,
    0,
    0,
    0,
    release_DataCurve,
    cast_DataCurve,
    0,
    0,
    0
},
    0,
    0,
    0
};
