/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.14.2 on Sat Mar 23 21:54:52 2013
 */

#include "sipAPIqti.h"

#line 1371 "src/scripting/qti.sip"
#include "../src/plot2D/ErrorBarsCurve.h"
#line 12 "../tmp/qtiplot/sipqtiErrorBarsCurve.cpp"

#line 83 "src/scripting/qti.sip"
#include "../src/table/Table.h"
#include <QDate>
#include <QTime>
#include <QDateTime>
#include <datetime.h> // python include
#define CHECK_TABLE_COL(arg)\
    int col;\
    if (PyInt_Check(arg)) {\
      col = (int)PyInt_AsLong(arg) - 1;\
		if (col < 0 || col >= sipCpp->numCols()) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_ValueError, "There's no column %d in table %s!", col+1, sipCpp->name().ascii());\
		}\
	 } else {\
      PyObject *tmp = PyObject_Str(arg);\
		if (!tmp) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_TypeError, "Column argument must be either int or string.");\
		} else {\
			col = sipCpp->colIndex(PyString_AsString(tmp));\
			if (col < 0) {\
				sipIsErr = 1;\
				PyErr_Format(PyExc_ValueError, "There's no column named %s in table %s!", PyString_AsString(tmp),\
						sipCpp->name().ascii());\
				Py_DECREF(tmp);\
			}\
		}\
	 }

#define CHECK_TABLE_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in table %s!", row+1, sipCpp->name().ascii());\
	}

static int setCellDataHelper(Table* table, int row, int col, PyObject* item) {
  PyTypeObject* item_type = item->ob_type;
  if (item == Py_None) {
    table->clearCell(row, col);
    return 0;
  }
  switch (table->columnType(col)) {
  case Table::Numeric:
    item = PyNumber_Float(item);
    if (item) {
      table->setCell(row, col, PyFloat_AsDouble(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a float!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Text:
    item = PyObject_Str(item);
    if (item) {
      table->setText(row, col, PyString_AsString(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a string!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Date:
    if (sipCanConvertToType(item, sipType_QDateTime, 0)) {
      int isErr = 0;
      QDateTime* dateTime = reinterpret_cast<QDateTime*>(sipConvertToType(item, sipType_QDateTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, dateTime->toString(table->columnFormat(col)));
      delete dateTime;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a datetime!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Time:
    if (sipCanConvertToType(item, sipType_QTime, 0)) {
      int isErr = 0;
      QTime* time = reinterpret_cast<QTime*>(sipConvertToType(item, sipType_QTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, time->toString(table->columnFormat(col)));
      delete time;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a time!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Month:
    item = PyNumber_Int(item);
    if (item) {
      int m = PyInt_AS_LONG(item) % 12; // no type checking required since we casted above
      if (!m)
        m = 12;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "M")
          table->setText(row, col, QDate::shortMonthName(m).left(1));
      else if (format == "MMM")
          table->setText(row, col, QDate::shortMonthName(m));
      else if (format == "MMMM")
          table->setText(row, col, QDate::longMonthName(m));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Day:
    item = PyNumber_Int(item);
    if (item) {
      int day = PyInt_AS_LONG(item) % 7; // no type checking required since we casted above
      if (!day)
        day = 7;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "d")
          table->setText(row, col, QDate::shortDayName(day).left(1));
      else if (format == "ddd")
          table->setText(row, col, QDate::shortDayName(day));
      else if (format == "dddd")
          table->setText(row, col, QDate::longDayName(day));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  default:
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}

static int cellDataHelper(Table* table, int row, int col, PyObject** item) {
  switch (table->columnType(col)) {
  case Table::Numeric:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else
      *item = PyFloat_FromDouble(table->cell(row, col));
    break;
  case Table::Text:
    *item = PyString_FromString(table->text(row, col));
    break;
  case Table::Date:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QDateTime dateTime = QDateTime::fromString(table->text(row, col), table->columnFormat(col));
      QDate date = dateTime.date();
      QTime time = dateTime.time();
      *item = PyDateTime_FromDateAndTime(date.year(), date.month(), date.day(),
                                         time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Time:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QTime time = QTime::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyTime_FromTime(time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Month:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.month());
    }
    break;
  case Table::Day:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.dayOfWeek());
    }
    break;
  default:
    *item = NULL;
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}
#line 224 "../tmp/qtiplot/sipqtiErrorBarsCurve.cpp"
#line 36 "/usr/share/sip/PyQt4/QtCore/qstring.sip"
#include <qstring.h>
#line 227 "../tmp/qtiplot/sipqtiErrorBarsCurve.cpp"
#line 1315 "src/scripting/qti.sip"
#include "../src/plot2D/PlotCurve.h"
#line 230 "../tmp/qtiplot/sipqtiErrorBarsCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qcolor.sip"
#include <qcolor.h>
#line 233 "../tmp/qtiplot/sipqtiErrorBarsCurve.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 236 "../tmp/qtiplot/sipqtiErrorBarsCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qfont.sip"
#include <qfont.h>
#line 239 "../tmp/qtiplot/sipqtiErrorBarsCurve.cpp"
#line 1160 "src/scripting/qti.sip"
#include <qwt_symbol.h>
#line 242 "../tmp/qtiplot/sipqtiErrorBarsCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qbrush.sip"
#include <qbrush.h>
#line 245 "../tmp/qtiplot/sipqtiErrorBarsCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qpen.sip"
#include <qpen.h>
#line 248 "../tmp/qtiplot/sipqtiErrorBarsCurve.cpp"


extern "C" {static PyObject *meth_ErrorBarsCurve_errorValue(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_errorValue(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_ErrorBarsCurve, &sipCpp, &a0))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->errorValue(a0);
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_errorValue, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_capLength(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_capLength(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ErrorBarsCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->capLength();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_capLength, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_setCapLength(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_setCapLength(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_ErrorBarsCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setCapLength(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_setCapLength, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_width(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_width(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ErrorBarsCurve, &sipCpp))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->width();
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_width, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_setWidth(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_setWidth(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bd", &sipSelf, sipType_ErrorBarsCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setWidth(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_setWidth, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_color(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_color(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ErrorBarsCurve, &sipCpp))
        {
            QColor *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QColor(sipCpp->color());
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QColor,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_color, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_setColor(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_setColor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QColor * a0;
        int a0State = 0;
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_ErrorBarsCurve, &sipCpp, sipType_QColor, &a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setColor(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QColor *>(a0),sipType_QColor,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_setColor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_direction(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_direction(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ErrorBarsCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->direction();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_direction, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_setDirection(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_setDirection(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_ErrorBarsCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setDirection(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_setDirection, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_xErrors(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_xErrors(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ErrorBarsCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->xErrors();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_xErrors, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_setXErrors(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_setXErrors(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0;
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bb", &sipSelf, sipType_ErrorBarsCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setXErrors(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_setXErrors, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_throughSymbol(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_throughSymbol(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ErrorBarsCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->throughSymbol();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_throughSymbol, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_drawThroughSymbol(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_drawThroughSymbol(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0;
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bb", &sipSelf, sipType_ErrorBarsCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->drawThroughSymbol(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_drawThroughSymbol, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_plusSide(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_plusSide(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ErrorBarsCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->plusSide();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_plusSide, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_drawPlusSide(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_drawPlusSide(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0;
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bb", &sipSelf, sipType_ErrorBarsCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->drawPlusSide(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_drawPlusSide, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_minusSide(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_minusSide(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ErrorBarsCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->minusSide();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_minusSide, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_drawMinusSide(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_drawMinusSide(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0;
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bb", &sipSelf, sipType_ErrorBarsCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->drawMinusSide(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_drawMinusSide, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_masterCurve(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_masterCurve(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ErrorBarsCurve, &sipCpp))
        {
            DataCurve *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->masterCurve();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_DataCurve,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_masterCurve, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_setMasterCurve(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_setMasterCurve(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        DataCurve * a0;
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_ErrorBarsCurve, &sipCpp, sipType_DataCurve, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setMasterCurve(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_setMasterCurve, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_detachFromMasterCurve(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_detachFromMasterCurve(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ErrorBarsCurve, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->detachFromMasterCurve();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_detachFromMasterCurve, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_ErrorBarsCurve_loadData(PyObject *, PyObject *);}
static PyObject *meth_ErrorBarsCurve_loadData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        ErrorBarsCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_ErrorBarsCurve, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->loadData();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ErrorBarsCurve, sipName_loadData, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_ErrorBarsCurve(void *, const sipTypeDef *);}
static void *cast_ErrorBarsCurve(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_ErrorBarsCurve)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_DataCurve)->ctd_cast((DataCurve *)(ErrorBarsCurve *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_ErrorBarsCurve(void *, int);}
static void release_ErrorBarsCurve(void *sipCppV,int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast<ErrorBarsCurve *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void dealloc_ErrorBarsCurve(sipSimpleWrapper *);}
static void dealloc_ErrorBarsCurve(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_ErrorBarsCurve(sipGetAddress(sipSelf),0);
    }
}


extern "C" {static void *init_ErrorBarsCurve(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_ErrorBarsCurve(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    ErrorBarsCurve *sipCpp = 0;

    {
        int a0;
        Table * a1;
        const QString * a2;
        int a2State = 0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "iJ8J1", &a0, sipType_Table, &a1, sipType_QString,&a2, &a2State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new ErrorBarsCurve(a0,a1,*a2);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a2),sipType_QString,a2State);

            return sipCpp;
        }
    }

    {
        Table * a0;
        const QString * a1;
        int a1State = 0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J8J1", sipType_Table, &a0, sipType_QString,&a1, &a1State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new ErrorBarsCurve(a0,*a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_ErrorBarsCurve[] = {{10, 255, 1}};


static PyMethodDef methods_ErrorBarsCurve[] = {
    {SIP_MLNAME_CAST(sipName_capLength), meth_ErrorBarsCurve_capLength, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_color), meth_ErrorBarsCurve_color, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_detachFromMasterCurve), meth_ErrorBarsCurve_detachFromMasterCurve, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_direction), meth_ErrorBarsCurve_direction, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_drawMinusSide), meth_ErrorBarsCurve_drawMinusSide, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_drawPlusSide), meth_ErrorBarsCurve_drawPlusSide, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_drawThroughSymbol), meth_ErrorBarsCurve_drawThroughSymbol, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_errorValue), meth_ErrorBarsCurve_errorValue, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_loadData), meth_ErrorBarsCurve_loadData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_masterCurve), meth_ErrorBarsCurve_masterCurve, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_minusSide), meth_ErrorBarsCurve_minusSide, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_plusSide), meth_ErrorBarsCurve_plusSide, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setCapLength), meth_ErrorBarsCurve_setCapLength, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColor), meth_ErrorBarsCurve_setColor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setDirection), meth_ErrorBarsCurve_setDirection, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setMasterCurve), meth_ErrorBarsCurve_setMasterCurve, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setWidth), meth_ErrorBarsCurve_setWidth, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setXErrors), meth_ErrorBarsCurve_setXErrors, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_throughSymbol), meth_ErrorBarsCurve_throughSymbol, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_width), meth_ErrorBarsCurve_width, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_xErrors), meth_ErrorBarsCurve_xErrors, METH_VARARGS, NULL}
};

static sipEnumMemberDef enummembers_ErrorBarsCurve[] = {
    {sipName_Horizontal, ErrorBarsCurve::Horizontal, 15},
    {sipName_Vertical, ErrorBarsCurve::Vertical, 15},
};


pyqt4ClassTypeDef sipTypeDef_qti_ErrorBarsCurve = {
{
    {
        -1,
        0,
        0,
        SIP_TYPE_CLASS,
        sipNameNr_ErrorBarsCurve,
        {0}
    },
    {
        sipNameNr_ErrorBarsCurve,
        {0, 0, 1},
        21, methods_ErrorBarsCurve,
        2, enummembers_ErrorBarsCurve,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    0,
    -1,
    -1,
    supers_ErrorBarsCurve,
    0,
    init_ErrorBarsCurve,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_ErrorBarsCurve,
    0,
    0,
    0,
    release_ErrorBarsCurve,
    cast_ErrorBarsCurve,
    0,
    0,
    0
},
    0,
    0,
    0
};
