/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.14.2 on Sat Mar 23 21:54:52 2013
 */

#include "sipAPIqti.h"

#line 2075 "src/scripting/qti.sip"
#include "../src/plot3D/Graph3D.h"
#line 12 "../tmp/qtiplot/sipqtiGraph3D.cpp"

#line 36 "/usr/share/sip/PyQt4/QtCore/qstring.sip"
#include <qstring.h>
#line 16 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 914 "src/scripting/qti.sip"
#include "../src/matrix/Matrix.h"
#define CHECK_MATRIX_COL(arg)\
	int col = arg-1;\
   if (col < 0 || col >= sipCpp->numCols()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no column %d in matrix %s!", col+1, sipCpp->name().ascii());\
	}
#define CHECK_MATRIX_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in matrix %s!", row+1, sipCpp->name().ascii());\
	}
#line 31 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 83 "src/scripting/qti.sip"
#include "../src/table/Table.h"
#include <QDate>
#include <QTime>
#include <QDateTime>
#include <datetime.h> // python include
#define CHECK_TABLE_COL(arg)\
    int col;\
    if (PyInt_Check(arg)) {\
      col = (int)PyInt_AsLong(arg) - 1;\
		if (col < 0 || col >= sipCpp->numCols()) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_ValueError, "There's no column %d in table %s!", col+1, sipCpp->name().ascii());\
		}\
	 } else {\
      PyObject *tmp = PyObject_Str(arg);\
		if (!tmp) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_TypeError, "Column argument must be either int or string.");\
		} else {\
			col = sipCpp->colIndex(PyString_AsString(tmp));\
			if (col < 0) {\
				sipIsErr = 1;\
				PyErr_Format(PyExc_ValueError, "There's no column named %s in table %s!", PyString_AsString(tmp),\
						sipCpp->name().ascii());\
				Py_DECREF(tmp);\
			}\
		}\
	 }

#define CHECK_TABLE_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in table %s!", row+1, sipCpp->name().ascii());\
	}

static int setCellDataHelper(Table* table, int row, int col, PyObject* item) {
  PyTypeObject* item_type = item->ob_type;
  if (item == Py_None) {
    table->clearCell(row, col);
    return 0;
  }
  switch (table->columnType(col)) {
  case Table::Numeric:
    item = PyNumber_Float(item);
    if (item) {
      table->setCell(row, col, PyFloat_AsDouble(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a float!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Text:
    item = PyObject_Str(item);
    if (item) {
      table->setText(row, col, PyString_AsString(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a string!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Date:
    if (sipCanConvertToType(item, sipType_QDateTime, 0)) {
      int isErr = 0;
      QDateTime* dateTime = reinterpret_cast<QDateTime*>(sipConvertToType(item, sipType_QDateTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, dateTime->toString(table->columnFormat(col)));
      delete dateTime;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a datetime!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Time:
    if (sipCanConvertToType(item, sipType_QTime, 0)) {
      int isErr = 0;
      QTime* time = reinterpret_cast<QTime*>(sipConvertToType(item, sipType_QTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, time->toString(table->columnFormat(col)));
      delete time;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a time!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Month:
    item = PyNumber_Int(item);
    if (item) {
      int m = PyInt_AS_LONG(item) % 12; // no type checking required since we casted above
      if (!m)
        m = 12;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "M")
          table->setText(row, col, QDate::shortMonthName(m).left(1));
      else if (format == "MMM")
          table->setText(row, col, QDate::shortMonthName(m));
      else if (format == "MMMM")
          table->setText(row, col, QDate::longMonthName(m));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Day:
    item = PyNumber_Int(item);
    if (item) {
      int day = PyInt_AS_LONG(item) % 7; // no type checking required since we casted above
      if (!day)
        day = 7;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "d")
          table->setText(row, col, QDate::shortDayName(day).left(1));
      else if (format == "ddd")
          table->setText(row, col, QDate::shortDayName(day));
      else if (format == "dddd")
          table->setText(row, col, QDate::longDayName(day));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  default:
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}

static int cellDataHelper(Table* table, int row, int col, PyObject** item) {
  switch (table->columnType(col)) {
  case Table::Numeric:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else
      *item = PyFloat_FromDouble(table->cell(row, col));
    break;
  case Table::Text:
    *item = PyString_FromString(table->text(row, col));
    break;
  case Table::Date:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QDateTime dateTime = QDateTime::fromString(table->text(row, col), table->columnFormat(col));
      QDate date = dateTime.date();
      QTime time = dateTime.time();
      *item = PyDateTime_FromDateAndTime(date.year(), date.month(), date.day(),
                                         time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Time:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QTime time = QTime::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyTime_FromTime(time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Month:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.month());
    }
    break;
  case Table::Day:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.dayOfWeek());
    }
    break;
  default:
    *item = NULL;
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}
#line 242 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qcolor.sip"
#include <qcolor.h>
#line 245 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qfont.sip"
#include <qfont.h>
#line 248 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 892 "src/scripting/qti.sip"
#include <qwt_color_map.h>
#line 251 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 112 "/usr/share/sip/PyQt4/QtCore/qsize.sip"
#include <qsize.h>
#line 254 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 3470 "src/scripting/qti.sip"
#include "../src/core/Folder.h"
#line 257 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 36 "/usr/share/sip/PyQt4/QtCore/qstringlist.sip"
#include <qstringlist.h>
#line 260 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 57 "src/scripting/qti.sip"
#include "../src/core/MdiSubWindow.h"
#line 263 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 355 "/usr/share/sip/PyQt4/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 266 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 514 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 269 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 627 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 272 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 483 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 275 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 261 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 278 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 533 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 281 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 557 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 284 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 338 "/usr/share/sip/PyQt4/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 287 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 570 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 290 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 31 "/usr/share/sip/PyQt4/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 293 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 583 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 296 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 616 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 299 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 605 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 302 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 34 "/usr/share/sip/PyQt4/QtCore/qobject.sip"
#include <qobject.h>
#line 305 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 308 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 39 "/usr/share/sip/PyQt4/QtGui/qmdiarea.sip"
#include <qmdiarea.h>
#line 311 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qmenu.sip"
#include <qmenu.h>
#line 314 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 39 "/usr/share/sip/PyQt4/QtGui/qmdisubwindow.sip"
#include <qmdisubwindow.h>
#line 317 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qwidget.sip"
#include <qwidget.h>
#line 320 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qsize.sip"
#include <qsize.h>
#line 323 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 326 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 39 "/usr/share/sip/PyQt4/QtCore/qmargins.sip"
#include <qmargins.h>
#line 329 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 332 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 335 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 39 "/usr/share/sip/PyQt4/QtGui/qgraphicseffect.sip"
#include <qgraphicseffect.h>
#line 338 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 33 "/usr/share/sip/PyQt4/QtGui/qgraphicsproxywidget.sip"
#include <qgraphicsproxywidget.h>
#line 341 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qlocale.sip"
#include <qlocale.h>
#line 344 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qpaintdevice.sip"
#include <qpaintdevice.h>
#line 347 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qpoint.sip"
#include <qpoint.h>
#line 350 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qregion.sip"
#include <qregion.h>
#line 353 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qwidget.sip"
#include <qwidget.h>
#line 356 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qpainter.sip"
#include <qpainter.h>
#line 359 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 37 "/usr/share/sip/PyQt4/QtCore/qbytearray.sip"
#include <qbytearray.h>
#line 362 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qrect.sip"
#include <qrect.h>
#line 365 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qfontinfo.sip"
#include <qfontinfo.h>
#line 368 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qfontmetrics.sip"
#include <qfontmetrics.h>
#line 371 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 374 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qpalette.sip"
#include <qpalette.h>
#line 377 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 274 "/usr/share/sip/PyQt4/QtCore/qvariant.sip"
#include <qvariant.h>
#line 380 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 656 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 383 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 748 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 386 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 801 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 389 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 774 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 392 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 790 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 395 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 863 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 398 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 412 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 401 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 356 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 404 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 33 "/usr/share/sip/PyQt4/QtGui/qinputcontext.sip"
#include <qinputcontext.h>
#line 407 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 61 "/usr/share/sip/PyQt4/QtGui/qpaintengine.sip"
#include <qpaintengine.h>
#line 410 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 39 "/usr/share/sip/PyQt4/QtGui/qx11info_x11.sip"
#include <qx11info_x11.h>
#line 413 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 416 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qaction.sip"
#include <qaction.h>
#line 419 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qlayout.sip"
#include <qlayout.h>
#line 422 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qsizepolicy.sip"
#include <qsizepolicy.h>
#line 425 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qkeysequence.sip"
#include <qkeysequence.h>
#line 428 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qcursor.sip"
#include <qcursor.h>
#line 431 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qicon.sip"
#include <qicon.h>
#line 434 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qbitmap.sip"
#include <qbitmap.h>
#line 437 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qstyle.sip"
#include <qstyle.h>
#line 440 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 33 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 443 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 446 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 31 "/usr/share/sip/PyQt4/QtCore/qthread.sip"
#include <qthread.h>
#line 449 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qregexp.sip"
#include <qregexp.h>
#line 452 "../tmp/qtiplot/sipqtiGraph3D.cpp"
#line 31 "/usr/share/sip/PyQt4/QtCore/qobjectdefs.sip"
#include <qobjectdefs.h>
#line 455 "../tmp/qtiplot/sipqtiGraph3D.cpp"


extern "C" {static PyObject *meth_Graph3D_export(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_export(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->exportToFile(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_export, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_exportVector(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_exportVector(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        int a1 = 0;
        int a2 = 1;
        const QSizeF& a3def = QSizeF();
        const QSizeF * a3 = &a3def;
        int a4 = FrameWidget::Pixel;
        double a5 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1|iiJ9id", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QString,&a0, &a0State, &a1, &a2, sipType_QSizeF, &a3, &a4, &a5))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->exportVector(*a0,a1,a2,*a3,a4,a5);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_exportVector, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_exportImage(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_exportImage(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        int a1 = 100;
        bool a2 = 0;
        int a3 = 0;
        const QSizeF& a4def = QSizeF();
        const QSizeF * a4 = &a4def;
        int a5 = FrameWidget::Pixel;
        double a6 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1|ibiJ9id", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QString,&a0, &a0State, &a1, &a2, &a3, sipType_QSizeF, &a4, &a5, &a6))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->exportImage(*a0,a1,a2,a3,*a4,a5,a6);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_exportImage, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setRotation(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setRotation(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        double a1;
        double a2;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bddd", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1, &a2))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setRotation(a0,a1,a2);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setRotation, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setScale(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setScale(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        double a1;
        double a2;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bddd", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1, &a2))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setScale(a0,a1,a2);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setScale, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setShift(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setShift(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        double a1;
        double a2;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bddd", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1, &a2))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setShift(a0,a1,a2);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setShift, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setZoom(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setZoom(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bd", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setZoom(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setZoom, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setOrthogonal(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setOrthogonal(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setOrthogonal(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setOrthogonal, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setMeshLineWidth(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setMeshLineWidth(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setMeshLineWidth(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setMeshLineWidth, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setMeshColor(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setMeshColor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QColor * a0;
        int a0State = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QColor, &a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setMeshColor(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QColor *>(a0),sipType_QColor,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setMeshColor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setAxesColor(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setAxesColor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QColor * a0;
        int a0State = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QColor, &a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setAxesColor(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QColor *>(a0),sipType_QColor,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setAxesColor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setNumbersColor(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setNumbersColor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QColor * a0;
        int a0State = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QColor, &a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setNumbersColor(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QColor *>(a0),sipType_QColor,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setNumbersColor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setLabelsColor(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setLabelsColor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QColor * a0;
        int a0State = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QColor, &a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelsColor(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QColor *>(a0),sipType_QColor,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setLabelsColor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setLabelsDistance(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setLabelsDistance(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelsDistance(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setLabelsDistance, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setBackgroundColor(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setBackgroundColor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QColor * a0;
        int a0State = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QColor, &a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setBackgroundColor(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QColor *>(a0),sipType_QColor,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setBackgroundColor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setGridColor(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setGridColor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QColor * a0;
        int a0State = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QColor, &a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setGridColor(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QColor *>(a0),sipType_QColor,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setGridColor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setDataColors(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setDataColors(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QColor * a0;
        int a0State = 0;
        const QColor * a1;
        int a1State = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1J1", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QColor, &a0, &a0State, sipType_QColor, &a1, &a1State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setDataColors(*a0,*a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QColor *>(a0),sipType_QColor,a0State);
            sipReleaseType(const_cast<QColor *>(a1),sipType_QColor,a1State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setDataColors, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_colorMapFile(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_colorMapFile(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            QString *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QString(sipCpp->colorMapFile());
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_colorMapFile, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setDataColorMap(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setDataColorMap(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setDataColorMap(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    {
        const QwtLinearColorMap * a0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ9", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QwtLinearColorMap, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setDataColorMap(*a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setDataColorMap, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_colorMap(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_colorMap(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            QwtLinearColorMap *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->colorMapPointer();
            Py_END_ALLOW_THREADS

            return sipConvertFromType(sipRes,sipType_QwtLinearColorMap,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_colorMap, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setOpacity(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setOpacity(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bd", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->changeTransparency(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setOpacity, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setResolution(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setResolution(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setResolution(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setResolution, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_showLegend(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_showLegend(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->showColorLegend(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_showLegend, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setTitle(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setTitle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        const QColor& a1def = QColor(Qt::black);
        const QColor * a1 = &a1def;
        int a1State = 0;
        const QFont& a2def = QFont();
        const QFont * a2 = &a2def;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1|J1J9", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QString,&a0, &a0State, sipType_QColor, &a1, &a1State, sipType_QFont, &a2))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setTitle(*a0,*a1,*a2);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);
            sipReleaseType(const_cast<QColor *>(a1),sipType_QColor,a1State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setTitle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setAntialiasing(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setAntialiasing(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setAntialiasing(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setAntialiasing, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setLeftGrid(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setLeftGrid(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLeftGrid(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setLeftGrid, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setRightGrid(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setRightGrid(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setRightGrid(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setRightGrid, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setCeilGrid(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setCeilGrid(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setCeilGrid(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setCeilGrid, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setFloorGrid(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setFloorGrid(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setFloorGrid(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setFloorGrid, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setFrontGrid(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setFrontGrid(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setFrontGrid(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setFrontGrid, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setBackGrid(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setBackGrid(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setBackGrid(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setBackGrid, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setFramed(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setFramed(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setFramed();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setFramed, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setBoxed(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setBoxed(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setBoxed();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setBoxed, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setNoAxes(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setNoAxes(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setNoAxes();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setNoAxes, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_showFloorProjection(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_showFloorProjection(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setFloorData();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_showFloorProjection, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_showFloorIsolines(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_showFloorIsolines(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setFloorIsolines();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_showFloorIsolines, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setEmptyFloor(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setEmptyFloor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setEmptyFloor();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setEmptyFloor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setPolygonStyle(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setPolygonStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setPolygonStyle();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setPolygonStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setHiddenLineStyle(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setHiddenLineStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setHiddenLineStyle();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setHiddenLineStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setWireframeStyle(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setWireframeStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setWireframeStyle();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setWireframeStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setFilledMeshStyle(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setFilledMeshStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setFilledMeshStyle();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setFilledMeshStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setDotStyle(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setDotStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setDotStyle();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setDotStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setBarStyle(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setBarStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setBarStyle();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setBarStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setConeStyle(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setConeStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setConeStyle();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setConeStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setCrossStyle(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setCrossStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setCrossStyle();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setCrossStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setConeOptions(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setConeOptions(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        int a1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bdi", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setConeOptions(a0,a1);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setConeOptions, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setCrossOptions(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setCrossOptions(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        double a1;
        bool a2;
        bool a3;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bddbb", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1, &a2, &a3))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setCrossOptions(a0,a1,a2,a3);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setCrossOptions, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setDotOptions(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setDotOptions(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        bool a1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bdb", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setDotOptions(a0,a1);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setDotOptions, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setBarRadius(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setBarRadius(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bd", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setBarRadius(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setBarRadius, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setBarLines(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setBarLines(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setBarLines(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setBarLines, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setFilledBars(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setFilledBars(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setFilledBars(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setFilledBars, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_animate(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_animate(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->animate(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_animate, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_findBestLayout(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_findBestLayout(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->findBestLayout();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_findBestLayout, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setData(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table * a0;
        const QString * a1;
        int a1State = 0;
        int a2 = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8J1|i", &sipSelf, sipType_Graph3D, &sipCpp, sipType_Table, &a0, sipType_QString,&a1, &a1State, &a2))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->changeDataColumn(a0,*a1,a2);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setMatrix(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setMatrix(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Matrix * a0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_Graph3D, &sipCpp, sipType_Matrix, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->addMatrixData(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setMatrix, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setFunction(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setFunction(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        double a1;
        double a2;
        double a3;
        double a4;
        double a5;
        double a6;
        int a7 = 40;
        int a8 = 40;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1dddddd|ii", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QString,&a0, &a0State, &a1, &a2, &a3, &a4, &a5, &a6, &a7, &a8))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->addFunction(*a0,a1,a2,a3,a4,a5,a6,a7,a8);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setFunction, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setParametricSurface(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setParametricSurface(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        const QString * a1;
        int a1State = 0;
        const QString * a2;
        int a2State = 0;
        double a3;
        double a4;
        double a5;
        double a6;
        int a7 = 40;
        int a8 = 40;
        bool a9 = 1;
        bool a10 = 1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1J1J1dddd|iibb", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QString,&a0, &a0State, sipType_QString,&a1, &a1State, sipType_QString,&a2, &a2State, &a3, &a4, &a5, &a6, &a7, &a8, &a9, &a10))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->addParametricSurface(*a0,*a1,*a2,a3,a4,a5,a6,a7,a8,a9,a10);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);
            sipReleaseType(const_cast<QString *>(a2),sipType_QString,a2State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setParametricSurface, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_update(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_update(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Graph3D, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->update();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_update, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setXAxisLabel(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setXAxisLabel(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setXAxisLabel(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setXAxisLabel, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setYAxisLabel(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setYAxisLabel(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setYAxisLabel(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setYAxisLabel, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setZAxisLabel(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setZAxisLabel(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_Graph3D, &sipCpp, sipType_QString,&a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setZAxisLabel(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setZAxisLabel, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setXAxisTickLength(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setXAxisTickLength(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        double a1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bdd", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setXAxisTickLength(a0,a1);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setXAxisTickLength, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setYAxisTickLength(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setYAxisTickLength(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        double a1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bdd", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setYAxisTickLength(a0,a1);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setYAxisTickLength, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setZAxisTickLength(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setZAxisTickLength(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        double a1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bdd", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setZAxisTickLength(a0,a1);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setZAxisTickLength, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setScales(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setScales(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        double a1;
        double a2;
        double a3;
        double a4;
        double a5;
        int a6 = -1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bdddddd|i", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1, &a2, &a3, &a4, &a5, &a6))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setScales(a0,a1,a2,a3,a4,a5,a6);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setScales, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_axisNumericFormat(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_axisNumericFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->axisNumericFormat(a0);
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_axisNumericFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_axisNumericPrecision(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_axisNumericPrecision(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_Graph3D, &sipCpp, &a0))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->axisNumericPrecision(a0);
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_axisNumericPrecision, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setAxisNumericFormat(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setAxisNumericFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        int a1;
        int a2;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Biii", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1, &a2))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setAxisNumericFormat(a0,a1,a2);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setAxisNumericFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setXAxisNumericFormat(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setXAxisNumericFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        int a1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bii", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1))
        {
#line 2168 "src/scripting/qti.sip"
	sipCpp->setAxisNumericFormat(0, a0, a1);
#line 2413 "../tmp/qtiplot/sipqtiGraph3D.cpp"

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setXAxisNumericFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setYAxisNumericFormat(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setYAxisNumericFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        int a1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bii", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1))
        {
#line 2173 "src/scripting/qti.sip"
	sipCpp->setAxisNumericFormat(1, a0, a1);
#line 2441 "../tmp/qtiplot/sipqtiGraph3D.cpp"

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setYAxisNumericFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Graph3D_setZAxisNumericFormat(PyObject *, PyObject *);}
static PyObject *meth_Graph3D_setZAxisNumericFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        int a1;
        Graph3D *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bii", &sipSelf, sipType_Graph3D, &sipCpp, &a0, &a1))
        {
#line 2178 "src/scripting/qti.sip"
	sipCpp->setAxisNumericFormat(2, a0, a1);
#line 2469 "../tmp/qtiplot/sipqtiGraph3D.cpp"

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Graph3D, sipName_setZAxisNumericFormat, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_Graph3D(void *, const sipTypeDef *);}
static void *cast_Graph3D(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_Graph3D)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_MdiSubWindow)->ctd_cast((MdiSubWindow *)(Graph3D *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_Graph3D(void *, int);}
static void release_Graph3D(void *sipCppV,int)
{
    Py_BEGIN_ALLOW_THREADS

    Graph3D *sipCpp = reinterpret_cast<Graph3D *>(sipCppV);

    if (QThread::currentThread() == sipCpp->thread())
        delete sipCpp;
    else
        sipCpp->deleteLater();

    Py_END_ALLOW_THREADS
}


extern "C" {static void dealloc_Graph3D(sipSimpleWrapper *);}
static void dealloc_Graph3D(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_Graph3D(sipGetAddress(sipSelf),0);
    }
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_Graph3D[] = {{55, 255, 1}};


static PyMethodDef methods_Graph3D[] = {
    {SIP_MLNAME_CAST(sipName_animate), meth_Graph3D_animate, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_axisNumericFormat), meth_Graph3D_axisNumericFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_axisNumericPrecision), meth_Graph3D_axisNumericPrecision, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_colorMap), meth_Graph3D_colorMap, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_colorMapFile), meth_Graph3D_colorMapFile, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_export), meth_Graph3D_export, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_exportImage), meth_Graph3D_exportImage, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_exportVector), meth_Graph3D_exportVector, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_findBestLayout), meth_Graph3D_findBestLayout, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setAntialiasing), meth_Graph3D_setAntialiasing, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setAxesColor), meth_Graph3D_setAxesColor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setAxisNumericFormat), meth_Graph3D_setAxisNumericFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setBackGrid), meth_Graph3D_setBackGrid, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setBackgroundColor), meth_Graph3D_setBackgroundColor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setBarLines), meth_Graph3D_setBarLines, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setBarRadius), meth_Graph3D_setBarRadius, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setBarStyle), meth_Graph3D_setBarStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setBoxed), meth_Graph3D_setBoxed, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setCeilGrid), meth_Graph3D_setCeilGrid, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setConeOptions), meth_Graph3D_setConeOptions, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setConeStyle), meth_Graph3D_setConeStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setCrossOptions), meth_Graph3D_setCrossOptions, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setCrossStyle), meth_Graph3D_setCrossStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setData), meth_Graph3D_setData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setDataColorMap), meth_Graph3D_setDataColorMap, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setDataColors), meth_Graph3D_setDataColors, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setDotOptions), meth_Graph3D_setDotOptions, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setDotStyle), meth_Graph3D_setDotStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setEmptyFloor), meth_Graph3D_setEmptyFloor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setFilledBars), meth_Graph3D_setFilledBars, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setFilledMeshStyle), meth_Graph3D_setFilledMeshStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setFloorGrid), meth_Graph3D_setFloorGrid, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setFramed), meth_Graph3D_setFramed, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setFrontGrid), meth_Graph3D_setFrontGrid, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setFunction), meth_Graph3D_setFunction, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setGridColor), meth_Graph3D_setGridColor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setHiddenLineStyle), meth_Graph3D_setHiddenLineStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelsColor), meth_Graph3D_setLabelsColor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelsDistance), meth_Graph3D_setLabelsDistance, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLeftGrid), meth_Graph3D_setLeftGrid, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setMatrix), meth_Graph3D_setMatrix, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setMeshColor), meth_Graph3D_setMeshColor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setMeshLineWidth), meth_Graph3D_setMeshLineWidth, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setNoAxes), meth_Graph3D_setNoAxes, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setNumbersColor), meth_Graph3D_setNumbersColor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setOpacity), meth_Graph3D_setOpacity, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setOrthogonal), meth_Graph3D_setOrthogonal, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setParametricSurface), meth_Graph3D_setParametricSurface, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setPolygonStyle), meth_Graph3D_setPolygonStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setResolution), meth_Graph3D_setResolution, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setRightGrid), meth_Graph3D_setRightGrid, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setRotation), meth_Graph3D_setRotation, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setScale), meth_Graph3D_setScale, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setScales), meth_Graph3D_setScales, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setShift), meth_Graph3D_setShift, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setTitle), meth_Graph3D_setTitle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setWireframeStyle), meth_Graph3D_setWireframeStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setXAxisLabel), meth_Graph3D_setXAxisLabel, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setXAxisNumericFormat), meth_Graph3D_setXAxisNumericFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setXAxisTickLength), meth_Graph3D_setXAxisTickLength, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setYAxisLabel), meth_Graph3D_setYAxisLabel, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setYAxisNumericFormat), meth_Graph3D_setYAxisNumericFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setYAxisTickLength), meth_Graph3D_setYAxisTickLength, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setZAxisLabel), meth_Graph3D_setZAxisLabel, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setZAxisNumericFormat), meth_Graph3D_setZAxisNumericFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setZAxisTickLength), meth_Graph3D_setZAxisTickLength, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setZoom), meth_Graph3D_setZoom, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_showFloorIsolines), meth_Graph3D_showFloorIsolines, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_showFloorProjection), meth_Graph3D_showFloorProjection, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_showLegend), meth_Graph3D_showLegend, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_update), meth_Graph3D_update, METH_VARARGS, NULL}
};

static sipEnumMemberDef enummembers_Graph3D[] = {
    {sipName_Bars, Graph3D::Bars, 35},
    {sipName_Decimal, Graph3D::Decimal, 34},
    {sipName_Default, Graph3D::Default, 34},
    {sipName_Engineering, Graph3D::Engineering, 34},
    {sipName_Ribbon, Graph3D::Ribbon, 35},
    {sipName_Scatter, Graph3D::Scatter, 35},
    {sipName_Scientific, Graph3D::Scientific, 34},
    {sipName_Trajectory, Graph3D::Trajectory, 35},
};


pyqt4ClassTypeDef sipTypeDef_qti_Graph3D = {
{
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_Graph3D,
        {0}
    },
    {
        sipNameNr_Graph3D,
        {0, 0, 1},
        71, methods_Graph3D,
        8, enummembers_Graph3D,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    0,
    -1,
    -1,
    supers_Graph3D,
    0,
    0,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_Graph3D,
    0,
    0,
    0,
    release_Graph3D,
    cast_Graph3D,
    0,
    0,
    0
},
    &Graph3D::staticMetaObject,
    0,
    0
};
