/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.14.2 on Sat Mar 23 21:54:52 2013
 */

#include "sipAPIqti.h"

#line 2708 "src/scripting/qti.sip"
#include "../src/analysis/NonLinearFit.h"
#line 12 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"

#line 2188 "src/scripting/qti.sip"
#include "../src/core/ApplicationWindow.h"
#line 16 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 83 "src/scripting/qti.sip"
#include "../src/table/Table.h"
#include <QDate>
#include <QTime>
#include <QDateTime>
#include <datetime.h> // python include
#define CHECK_TABLE_COL(arg)\
    int col;\
    if (PyInt_Check(arg)) {\
      col = (int)PyInt_AsLong(arg) - 1;\
		if (col < 0 || col >= sipCpp->numCols()) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_ValueError, "There's no column %d in table %s!", col+1, sipCpp->name().ascii());\
		}\
	 } else {\
      PyObject *tmp = PyObject_Str(arg);\
		if (!tmp) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_TypeError, "Column argument must be either int or string.");\
		} else {\
			col = sipCpp->colIndex(PyString_AsString(tmp));\
			if (col < 0) {\
				sipIsErr = 1;\
				PyErr_Format(PyExc_ValueError, "There's no column named %s in table %s!", PyString_AsString(tmp),\
						sipCpp->name().ascii());\
				Py_DECREF(tmp);\
			}\
		}\
	 }

#define CHECK_TABLE_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in table %s!", row+1, sipCpp->name().ascii());\
	}

static int setCellDataHelper(Table* table, int row, int col, PyObject* item) {
  PyTypeObject* item_type = item->ob_type;
  if (item == Py_None) {
    table->clearCell(row, col);
    return 0;
  }
  switch (table->columnType(col)) {
  case Table::Numeric:
    item = PyNumber_Float(item);
    if (item) {
      table->setCell(row, col, PyFloat_AsDouble(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a float!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Text:
    item = PyObject_Str(item);
    if (item) {
      table->setText(row, col, PyString_AsString(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a string!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Date:
    if (sipCanConvertToType(item, sipType_QDateTime, 0)) {
      int isErr = 0;
      QDateTime* dateTime = reinterpret_cast<QDateTime*>(sipConvertToType(item, sipType_QDateTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, dateTime->toString(table->columnFormat(col)));
      delete dateTime;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a datetime!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Time:
    if (sipCanConvertToType(item, sipType_QTime, 0)) {
      int isErr = 0;
      QTime* time = reinterpret_cast<QTime*>(sipConvertToType(item, sipType_QTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, time->toString(table->columnFormat(col)));
      delete time;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a time!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Month:
    item = PyNumber_Int(item);
    if (item) {
      int m = PyInt_AS_LONG(item) % 12; // no type checking required since we casted above
      if (!m)
        m = 12;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "M")
          table->setText(row, col, QDate::shortMonthName(m).left(1));
      else if (format == "MMM")
          table->setText(row, col, QDate::shortMonthName(m));
      else if (format == "MMMM")
          table->setText(row, col, QDate::longMonthName(m));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Day:
    item = PyNumber_Int(item);
    if (item) {
      int day = PyInt_AS_LONG(item) % 7; // no type checking required since we casted above
      if (!day)
        day = 7;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "d")
          table->setText(row, col, QDate::shortDayName(day).left(1));
      else if (format == "ddd")
          table->setText(row, col, QDate::shortDayName(day));
      else if (format == "dddd")
          table->setText(row, col, QDate::longDayName(day));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  default:
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}

static int cellDataHelper(Table* table, int row, int col, PyObject** item) {
  switch (table->columnType(col)) {
  case Table::Numeric:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else
      *item = PyFloat_FromDouble(table->cell(row, col));
    break;
  case Table::Text:
    *item = PyString_FromString(table->text(row, col));
    break;
  case Table::Date:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QDateTime dateTime = QDateTime::fromString(table->text(row, col), table->columnFormat(col));
      QDate date = dateTime.date();
      QTime time = dateTime.time();
      *item = PyDateTime_FromDateAndTime(date.year(), date.month(), date.day(),
                                         time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Time:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QTime time = QTime::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyTime_FromTime(time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Month:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.month());
    }
    break;
  case Table::Day:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.dayOfWeek());
    }
    break;
  default:
    *item = NULL;
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}
#line 227 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 36 "/usr/share/sip/PyQt4/QtCore/qstring.sip"
#include <qstring.h>
#line 230 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 1223 "src/scripting/qti.sip"
#include <qwt_plot_curve.h>
#line 233 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 1752 "src/scripting/qti.sip"
#include "../src/plot2D/Graph.h"
#include "../src/plot2D/LegendWidget.h"
#line 237 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 914 "src/scripting/qti.sip"
#include "../src/matrix/Matrix.h"
#define CHECK_MATRIX_COL(arg)\
	int col = arg-1;\
   if (col < 0 || col >= sipCpp->numCols()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no column %d in matrix %s!", col+1, sipCpp->name().ascii());\
	}
#define CHECK_MATRIX_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in matrix %s!", row+1, sipCpp->name().ascii());\
	}
#line 252 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 2363 "src/scripting/qti.sip"
#include "../src/analysis/Fit.h"
#line 255 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 36 "/usr/share/sip/PyQt4/QtCore/qstringlist.sip"
#include <qstringlist.h>
#line 258 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qcolor.sip"
#include <qcolor.h>
#line 261 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 31 "/usr/share/sip/PyQt4/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 264 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 355 "/usr/share/sip/PyQt4/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 267 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 338 "/usr/share/sip/PyQt4/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 270 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 34 "/usr/share/sip/PyQt4/QtCore/qobject.sip"
#include <qobject.h>
#line 273 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 274 "/usr/share/sip/PyQt4/QtCore/qvariant.sip"
#include <qvariant.h>
#line 276 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 33 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 279 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 37 "/usr/share/sip/PyQt4/QtCore/qbytearray.sip"
#include <qbytearray.h>
#line 282 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 285 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 288 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 31 "/usr/share/sip/PyQt4/QtCore/qthread.sip"
#include <qthread.h>
#line 291 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qregexp.sip"
#include <qregexp.h>
#line 294 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
#line 31 "/usr/share/sip/PyQt4/QtCore/qobjectdefs.sip"
#include <qobjectdefs.h>
#line 297 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"


class sipNonLinearFit : public NonLinearFit
{
public:
    sipNonLinearFit(ApplicationWindow *,Table *,const QString&,const QString&,int,int);
    sipNonLinearFit(ApplicationWindow *,QwtPlotCurve *);
    sipNonLinearFit(ApplicationWindow *,QwtPlotCurve *,double,double);
    sipNonLinearFit(ApplicationWindow *,Graph *,const QString&);
    sipNonLinearFit(ApplicationWindow *,Graph *,const QString&,double,double);
    virtual ~sipNonLinearFit();

    int qt_metacall(QMetaObject::Call,int,void **);
    void *qt_metacast(const char *);
    const QMetaObject *metaObject() const;

    /*
     * There is a public method for every protected method visible from
     * this class.
     */
    QObject * sipProtect_sender() const;
    int sipProtect_receivers(const char *) const;
    void sipProtectVirt_timerEvent(bool,QTimerEvent *);
    void sipProtectVirt_childEvent(bool,QChildEvent *);
    void sipProtectVirt_customEvent(bool,QEvent *);
    void sipProtectVirt_connectNotify(bool,const char *);
    void sipProtectVirt_disconnectNotify(bool,const char *);
    int sipProtect_senderSignalIndex() const;

    /*
     * There is a protected method for every virtual method visible from
     * this class.
     */
protected:
    void fit();
    bool run();
    void guessInitialValues();
    QString legendInfo();
    bool setDataFromTable(Table *,const QString&,const QString&,int,int);
    void enableGraphicsDisplay(bool,Graph *);
    bool event(QEvent *);
    bool eventFilter(QObject *,QEvent *);
    void timerEvent(QTimerEvent *);
    void childEvent(QChildEvent *);
    void customEvent(QEvent *);
    void connectNotify(const char *);
    void disconnectNotify(const char *);

public:
    sipSimpleWrapper *sipPySelf;

private:
    sipNonLinearFit(const sipNonLinearFit &);
    sipNonLinearFit &operator = (const sipNonLinearFit &);

    char sipPyMethods[13];
};

sipNonLinearFit::sipNonLinearFit(ApplicationWindow *a0,Table *a1,const QString& a2,const QString& a3,int a4,int a5): NonLinearFit(a0,a1,a2,a3,a4,a5), sipPySelf(0)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipNonLinearFit::sipNonLinearFit(ApplicationWindow *a0,QwtPlotCurve *a1): NonLinearFit(a0,a1), sipPySelf(0)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipNonLinearFit::sipNonLinearFit(ApplicationWindow *a0,QwtPlotCurve *a1,double a2,double a3): NonLinearFit(a0,a1,a2,a3), sipPySelf(0)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipNonLinearFit::sipNonLinearFit(ApplicationWindow *a0,Graph *a1,const QString& a2): NonLinearFit(a0,a1,a2), sipPySelf(0)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipNonLinearFit::sipNonLinearFit(ApplicationWindow *a0,Graph *a1,const QString& a2,double a3,double a4): NonLinearFit(a0,a1,a2,a3,a4), sipPySelf(0)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipNonLinearFit::~sipNonLinearFit()
{
    sipCommonDtor(sipPySelf);
}

const QMetaObject *sipNonLinearFit::metaObject() const
{
    return sip_qti_qt_metaobject(sipPySelf,sipType_NonLinearFit);
}

int sipNonLinearFit::qt_metacall(QMetaObject::Call _c,int _id,void **_a)
{
    _id = NonLinearFit::qt_metacall(_c,_id,_a);

    if (_id >= 0)
        _id = sip_qti_qt_metacall(sipPySelf,sipType_NonLinearFit,_c,_id,_a);

    return _id;
}

void *sipNonLinearFit::qt_metacast(const char *_clname)
{
    return (sip_qti_qt_metacast && sip_qti_qt_metacast(sipPySelf,sipType_NonLinearFit,_clname)) ? this : NonLinearFit::qt_metacast(_clname);
}

void sipNonLinearFit::fit()
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[0],sipPySelf,NULL,sipName_fit);

    if (!sipMeth)
    {
        Fit::fit();
        return;
    }

    typedef void (*sipVH_QtCore_11)(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    ((sipVH_QtCore_11)(sipModuleAPI_qti_QtCore->em_virthandlers[11]))(sipGILState, 0, sipPySelf, sipMeth);
}

bool sipNonLinearFit::run()
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[1],sipPySelf,NULL,sipName_run);

    if (!sipMeth)
        return Fit::run();

    typedef bool (*sipVH_QtCore_7)(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    return ((sipVH_QtCore_7)(sipModuleAPI_qti_QtCore->em_virthandlers[7]))(sipGILState, 0, sipPySelf, sipMeth);
}

void sipNonLinearFit::guessInitialValues()
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[2],sipPySelf,NULL,sipName_guessInitialValues);

    if (!sipMeth)
    {
        Fit::guessInitialValues();
        return;
    }

    typedef void (*sipVH_QtCore_11)(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    ((sipVH_QtCore_11)(sipModuleAPI_qti_QtCore->em_virthandlers[11]))(sipGILState, 0, sipPySelf, sipMeth);
}

QString sipNonLinearFit::legendInfo()
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[3],sipPySelf,NULL,sipName_legendInfo);

    if (!sipMeth)
        return Fit::legendInfo();

    typedef QString (*sipVH_QtCore_62)(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    return ((sipVH_QtCore_62)(sipModuleAPI_qti_QtCore->em_virthandlers[62]))(sipGILState, 0, sipPySelf, sipMeth);
}

bool sipNonLinearFit::setDataFromTable(Table *a0,const QString& a1,const QString& a2,int a3,int a4)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[4],sipPySelf,NULL,sipName_setDataFromTable);

    if (!sipMeth)
        return Fit::setDataFromTable(a0,a1,a2,a3,a4);

    extern bool sipVH_qti_2(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, Table *,const QString&,const QString&,int,int);

    return sipVH_qti_2(sipGILState, 0, sipPySelf, sipMeth, a0, a1, a2, a3, a4);
}

void sipNonLinearFit::enableGraphicsDisplay(bool a0,Graph *a1)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[5],sipPySelf,NULL,sipName_enableGraphicsDisplay);

    if (!sipMeth)
    {
        Filter::enableGraphicsDisplay(a0,a1);
        return;
    }

    extern void sipVH_qti_1(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, bool,Graph *);

    sipVH_qti_1(sipGILState, 0, sipPySelf, sipMeth, a0, a1);
}

bool sipNonLinearFit::event(QEvent *a0)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[6],sipPySelf,NULL,sipName_event);

    if (!sipMeth)
        return QObject::event(a0);

    typedef bool (*sipVH_QtCore_5)(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, QEvent *);

    return ((sipVH_QtCore_5)(sipModuleAPI_qti_QtCore->em_virthandlers[5]))(sipGILState, 0, sipPySelf, sipMeth, a0);
}

bool sipNonLinearFit::eventFilter(QObject *a0,QEvent *a1)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[7],sipPySelf,NULL,sipName_eventFilter);

    if (!sipMeth)
        return QObject::eventFilter(a0,a1);

    typedef bool (*sipVH_QtCore_18)(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, QObject *,QEvent *);

    return ((sipVH_QtCore_18)(sipModuleAPI_qti_QtCore->em_virthandlers[18]))(sipGILState, 0, sipPySelf, sipMeth, a0, a1);
}

void sipNonLinearFit::timerEvent(QTimerEvent *a0)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[8],sipPySelf,NULL,sipName_timerEvent);

    if (!sipMeth)
    {
        QObject::timerEvent(a0);
        return;
    }

    typedef void (*sipVH_QtCore_9)(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, QTimerEvent *);

    ((sipVH_QtCore_9)(sipModuleAPI_qti_QtCore->em_virthandlers[9]))(sipGILState, 0, sipPySelf, sipMeth, a0);
}

void sipNonLinearFit::childEvent(QChildEvent *a0)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[9],sipPySelf,NULL,sipName_childEvent);

    if (!sipMeth)
    {
        QObject::childEvent(a0);
        return;
    }

    typedef void (*sipVH_QtCore_25)(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, QChildEvent *);

    ((sipVH_QtCore_25)(sipModuleAPI_qti_QtCore->em_virthandlers[25]))(sipGILState, 0, sipPySelf, sipMeth, a0);
}

void sipNonLinearFit::customEvent(QEvent *a0)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[10],sipPySelf,NULL,sipName_customEvent);

    if (!sipMeth)
    {
        QObject::customEvent(a0);
        return;
    }

    typedef void (*sipVH_QtCore_17)(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, QEvent *);

    ((sipVH_QtCore_17)(sipModuleAPI_qti_QtCore->em_virthandlers[17]))(sipGILState, 0, sipPySelf, sipMeth, a0);
}

void sipNonLinearFit::connectNotify(const char *a0)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[11],sipPySelf,NULL,sipName_connectNotify);

    if (!sipMeth)
    {
        QObject::connectNotify(a0);
        return;
    }

    typedef void (*sipVH_QtCore_24)(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, const char *);

    ((sipVH_QtCore_24)(sipModuleAPI_qti_QtCore->em_virthandlers[24]))(sipGILState, 0, sipPySelf, sipMeth, a0);
}

void sipNonLinearFit::disconnectNotify(const char *a0)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[12],sipPySelf,NULL,sipName_disconnectNotify);

    if (!sipMeth)
    {
        QObject::disconnectNotify(a0);
        return;
    }

    typedef void (*sipVH_QtCore_24)(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, const char *);

    ((sipVH_QtCore_24)(sipModuleAPI_qti_QtCore->em_virthandlers[24]))(sipGILState, 0, sipPySelf, sipMeth, a0);
}

QObject * sipNonLinearFit::sipProtect_sender() const
{
    return QObject::sender();
}

int sipNonLinearFit::sipProtect_receivers(const char *a0) const
{
    return QObject::receivers(a0);
}

void sipNonLinearFit::sipProtectVirt_timerEvent(bool sipSelfWasArg,QTimerEvent *a0)
{
    (sipSelfWasArg ? QObject::timerEvent(a0) : timerEvent(a0));
}

void sipNonLinearFit::sipProtectVirt_childEvent(bool sipSelfWasArg,QChildEvent *a0)
{
    (sipSelfWasArg ? QObject::childEvent(a0) : childEvent(a0));
}

void sipNonLinearFit::sipProtectVirt_customEvent(bool sipSelfWasArg,QEvent *a0)
{
    (sipSelfWasArg ? QObject::customEvent(a0) : customEvent(a0));
}

void sipNonLinearFit::sipProtectVirt_connectNotify(bool sipSelfWasArg,const char *a0)
{
    (sipSelfWasArg ? QObject::connectNotify(a0) : connectNotify(a0));
}

void sipNonLinearFit::sipProtectVirt_disconnectNotify(bool sipSelfWasArg,const char *a0)
{
    (sipSelfWasArg ? QObject::disconnectNotify(a0) : disconnectNotify(a0));
}

int sipNonLinearFit::sipProtect_senderSignalIndex() const
{
    return QObject::senderSignalIndex();
}


extern "C" {static PyObject *meth_NonLinearFit_sender(PyObject *, PyObject *);}
static PyObject *meth_NonLinearFit_sender(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const sipNonLinearFit *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_NonLinearFit, &sipCpp))
        {
            QObject *sipRes = 0;

#line 655 "/usr/share/sip/PyQt4/QtCore/qobject.sip"
        typedef QObject *(*helper_func)(QObject *);
        
        static helper_func helper = 0;
        
        if (!helper)
            helper = (helper_func)sipImportSymbol("qpycore_qobject_sender");
        
        // sender() must be called without the GIL to avoid possible deadlocks between
        // the GIL ad Qt's internal thread data mutex.
        
        Py_BEGIN_ALLOW_THREADS
        
        #if defined(SIP_PROTECTED_IS_PUBLIC)
        sipRes = sipCpp->sender();
        #else
        sipRes = sipCpp->sipProtect_sender();
        #endif
        
        Py_END_ALLOW_THREADS
        
        if (helper)
            sipRes = helper(sipRes);
#line 701 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"

            return sipConvertFromType(sipRes,sipType_QObject,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_NonLinearFit, sipName_sender, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_NonLinearFit_receivers(PyObject *, PyObject *);}
static PyObject *meth_NonLinearFit_receivers(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        char * a0;
        const sipNonLinearFit *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BG", &sipSelf, sipType_NonLinearFit, &sipCpp, &a0))
        {
            int sipRes = 0;

#line 681 "/usr/share/sip/PyQt4/QtCore/qobject.sip"
        // We need to take into account any proxies for Python signals. Import the
        // helper if it hasn't already been done.
        typedef int (*helper_func)(QObject *, const char *, int);
        
        static helper_func helper = 0;
        
        if (!helper)
            helper = (helper_func)sipImportSymbol("qpycore_qobject_receivers");
        
        // PyQt5: Get rid of the const casts.
        if (helper)
        #if defined(SIP_PROTECTED_IS_PUBLIC)
            sipRes = helper(const_cast<QObject *>(sipCpp), a0, sipCpp->receivers(a0));
        #else
            sipRes = helper(const_cast<QObject *>(static_cast<const QObject *>(sipCpp)), a0, sipCpp->sipProtect_receivers(a0));
        #endif
#line 744 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_NonLinearFit, sipName_receivers, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_NonLinearFit_timerEvent(PyObject *, PyObject *);}
static PyObject *meth_NonLinearFit_timerEvent(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;
    bool sipSelfWasArg = (!sipSelf || sipIsDerived((sipSimpleWrapper *)sipSelf));

    {
        QTimerEvent * a0;
        sipNonLinearFit *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_NonLinearFit, &sipCpp, sipType_QTimerEvent, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->sipProtectVirt_timerEvent(sipSelfWasArg,a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_NonLinearFit, sipName_timerEvent, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_NonLinearFit_childEvent(PyObject *, PyObject *);}
static PyObject *meth_NonLinearFit_childEvent(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;
    bool sipSelfWasArg = (!sipSelf || sipIsDerived((sipSimpleWrapper *)sipSelf));

    {
        QChildEvent * a0;
        sipNonLinearFit *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_NonLinearFit, &sipCpp, sipType_QChildEvent, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->sipProtectVirt_childEvent(sipSelfWasArg,a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_NonLinearFit, sipName_childEvent, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_NonLinearFit_customEvent(PyObject *, PyObject *);}
static PyObject *meth_NonLinearFit_customEvent(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;
    bool sipSelfWasArg = (!sipSelf || sipIsDerived((sipSimpleWrapper *)sipSelf));

    {
        QEvent * a0;
        sipNonLinearFit *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_NonLinearFit, &sipCpp, sipType_QEvent, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->sipProtectVirt_customEvent(sipSelfWasArg,a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_NonLinearFit, sipName_customEvent, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_NonLinearFit_connectNotify(PyObject *, PyObject *);}
static PyObject *meth_NonLinearFit_connectNotify(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;
    bool sipSelfWasArg = (!sipSelf || sipIsDerived((sipSimpleWrapper *)sipSelf));

    {
        char * a0;
        sipNonLinearFit *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BG", &sipSelf, sipType_NonLinearFit, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->sipProtectVirt_connectNotify(sipSelfWasArg,a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_NonLinearFit, sipName_connectNotify, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_NonLinearFit_disconnectNotify(PyObject *, PyObject *);}
static PyObject *meth_NonLinearFit_disconnectNotify(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;
    bool sipSelfWasArg = (!sipSelf || sipIsDerived((sipSimpleWrapper *)sipSelf));

    {
        char * a0;
        sipNonLinearFit *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BG", &sipSelf, sipType_NonLinearFit, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->sipProtectVirt_disconnectNotify(sipSelfWasArg,a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_NonLinearFit, sipName_disconnectNotify, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_NonLinearFit_senderSignalIndex(PyObject *, PyObject *);}
static PyObject *meth_NonLinearFit_senderSignalIndex(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const sipNonLinearFit *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_NonLinearFit, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->sipProtect_senderSignalIndex();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_NonLinearFit, sipName_senderSignalIndex, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_NonLinearFit_setParameters(PyObject *, PyObject *);}
static PyObject *meth_NonLinearFit_setParameters(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        NonLinearFit *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BW", &sipSelf, sipType_NonLinearFit, &sipCpp, &a0))
        {
            int sipIsErr = 0;

#line 2739 "src/scripting/qti.sip"
  QStringList l;
  char *item;
  for (int i=0; i<PyTuple_GET_SIZE(a0); i++)
    if (item = PyString_AsString(PyTuple_GET_ITEM(a0, i)))
      l << item;
    else
      sipIsErr = 1;

  sipCpp->setParametersList(l);
#line 947 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"

            Py_DECREF(a0);

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_NonLinearFit, sipName_setParameters, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_NonLinearFit_setFormula(PyObject *, PyObject *);}
static PyObject *meth_NonLinearFit_setFormula(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        bool a1 = 1;
        NonLinearFit *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1|b", &sipSelf, sipType_NonLinearFit, &sipCpp, sipType_QString,&a0, &a0State, &a1))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->setFormula(*a0,a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_NonLinearFit, sipName_setFormula, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_NonLinearFit_save(PyObject *, PyObject *);}
static PyObject *meth_NonLinearFit_save(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        NonLinearFit *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_NonLinearFit, &sipCpp, sipType_QString,&a0, &a0State))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->save(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_NonLinearFit, sipName_save, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_NonLinearFit_load(PyObject *, PyObject *);}
static PyObject *meth_NonLinearFit_load(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        NonLinearFit *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_NonLinearFit, &sipCpp, sipType_QString,&a0, &a0State))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->load(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_NonLinearFit, sipName_load, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_NonLinearFit(void *, const sipTypeDef *);}
static void *cast_NonLinearFit(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_NonLinearFit)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_Fit)->ctd_cast((Fit *)(NonLinearFit *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_NonLinearFit(void *, int);}
static void release_NonLinearFit(void *sipCppV,int)
{
    Py_BEGIN_ALLOW_THREADS

    NonLinearFit *sipCpp = reinterpret_cast<NonLinearFit *>(sipCppV);

    if (QThread::currentThread() == sipCpp->thread())
        delete sipCpp;
    else
        sipCpp->deleteLater();

    Py_END_ALLOW_THREADS
}


extern "C" {static void dealloc_NonLinearFit(sipSimpleWrapper *);}
static void dealloc_NonLinearFit(sipSimpleWrapper *sipSelf)
{
    if (sipIsDerived(sipSelf))
        reinterpret_cast<sipNonLinearFit *>(sipGetAddress(sipSelf))->sipPySelf = NULL;

    if (sipIsPyOwned(sipSelf))
    {
        release_NonLinearFit(sipGetAddress(sipSelf),sipSelf->flags);
    }
}


extern "C" {static void *init_NonLinearFit(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_NonLinearFit(sipSimpleWrapper *sipSelf, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **sipOwner, PyObject **sipParseErr)
{
    sipNonLinearFit *sipCpp = 0;

    {
        ApplicationWindow * a0;
        Table * a1;
        const QString * a2;
        int a2State = 0;
        const QString * a3;
        int a3State = 0;
        int a4;
        int a5;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "JHJ8J1J1ii", sipType_ApplicationWindow, &a0, sipOwner, sipType_Table, &a1, sipType_QString,&a2, &a2State, sipType_QString,&a3, &a3State, &a4, &a5))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new sipNonLinearFit(a0,a1,*a2,*a3,a4,a5);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a2),sipType_QString,a2State);
            sipReleaseType(const_cast<QString *>(a3),sipType_QString,a3State);

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    {
        Table * a0;
        const QString * a1;
        int a1State = 0;
        const QString * a2;
        int a2State = 0;
        int a3 = 1;
        int a4 = -1;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J8J1J1|ii", sipType_Table, &a0, sipType_QString,&a1, &a1State, sipType_QString,&a2, &a2State, &a3, &a4))
        {
#line 2714 "src/scripting/qti.sip"
  SIPQTI_APP(new sipNonLinearFit(app, a0, *a1, *a2, a3, a4))
#line 1145 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);
            sipReleaseType(const_cast<QString *>(a2),sipType_QString,a2State);

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    {
        ApplicationWindow * a0;
        QwtPlotCurve * a1;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "JHJ8", sipType_ApplicationWindow, &a0, sipOwner, sipType_QwtPlotCurve, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new sipNonLinearFit(a0,a1);
            Py_END_ALLOW_THREADS

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    {
        ApplicationWindow * a0;
        QwtPlotCurve * a1;
        double a2;
        double a3;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "JHJ8dd", sipType_ApplicationWindow, &a0, sipOwner, sipType_QwtPlotCurve, &a1, &a2, &a3))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new sipNonLinearFit(a0,a1,a2,a3);
            Py_END_ALLOW_THREADS

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    {
        ApplicationWindow * a0;
        Graph * a1;
        const QString * a2;
        int a2State = 0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "JHJ8J1", sipType_ApplicationWindow, &a0, sipOwner, sipType_Graph, &a1, sipType_QString,&a2, &a2State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new sipNonLinearFit(a0,a1,*a2);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a2),sipType_QString,a2State);

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    {
        ApplicationWindow * a0;
        Graph * a1;
        const QString * a2;
        int a2State = 0;
        double a3;
        double a4;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "JHJ8J1dd", sipType_ApplicationWindow, &a0, sipOwner, sipType_Graph, &a1, sipType_QString,&a2, &a2State, &a3, &a4))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new sipNonLinearFit(a0,a1,*a2,a3,a4);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a2),sipType_QString,a2State);

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    {
        QwtPlotCurve * a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J8", sipType_QwtPlotCurve, &a0))
        {
#line 2723 "src/scripting/qti.sip"
  SIPQTI_APP(new sipNonLinearFit(app, a0))
#line 1236 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    {
        QwtPlotCurve * a0;
        double a1;
        double a2;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J8dd", sipType_QwtPlotCurve, &a0, &a1, &a2))
        {
#line 2727 "src/scripting/qti.sip"
  SIPQTI_APP(new sipNonLinearFit(app, a0, a1, a2))
#line 1253 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    {
        Graph * a0;
        const QString * a1;
        int a1State = 0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J8J1", sipType_Graph, &a0, sipType_QString,&a1, &a1State))
        {
#line 2731 "src/scripting/qti.sip"
  SIPQTI_APP(new sipNonLinearFit(app, a0, *a1))
#line 1270 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    {
        Graph * a0;
        const QString * a1;
        int a1State = 0;
        double a2;
        double a3;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J8J1dd", sipType_Graph, &a0, sipType_QString,&a1, &a1State, &a2, &a3))
        {
#line 2735 "src/scripting/qti.sip"
  SIPQTI_APP(new sipNonLinearFit(app, a0, *a1, a2, a3))
#line 1290 "../tmp/qtiplot/sipqtiNonLinearFit.cpp"
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_NonLinearFit[] = {{21, 255, 1}};


static PyMethodDef methods_NonLinearFit[] = {
    {SIP_MLNAME_CAST(sipName_childEvent), meth_NonLinearFit_childEvent, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_connectNotify), meth_NonLinearFit_connectNotify, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_customEvent), meth_NonLinearFit_customEvent, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_disconnectNotify), meth_NonLinearFit_disconnectNotify, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_load), meth_NonLinearFit_load, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_receivers), meth_NonLinearFit_receivers, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_save), meth_NonLinearFit_save, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_sender), meth_NonLinearFit_sender, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_senderSignalIndex), meth_NonLinearFit_senderSignalIndex, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setFormula), meth_NonLinearFit_setFormula, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setParameters), meth_NonLinearFit_setParameters, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_timerEvent), meth_NonLinearFit_timerEvent, METH_VARARGS, NULL}
};


pyqt4ClassTypeDef sipTypeDef_qti_NonLinearFit = {
{
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_NonLinearFit,
        {0}
    },
    {
        sipNameNr_NonLinearFit,
        {0, 0, 1},
        12, methods_NonLinearFit,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    0,
    -1,
    -1,
    supers_NonLinearFit,
    0,
    init_NonLinearFit,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_NonLinearFit,
    0,
    0,
    0,
    release_NonLinearFit,
    cast_NonLinearFit,
    0,
    0,
    0
},
    &NonLinearFit::staticMetaObject,
    0,
    0
};
