/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.14.2 on Sat Mar 23 21:54:52 2013
 */

#include "sipAPIqti.h"

#line 1421 "src/scripting/qti.sip"
#include "../src/plot2D/PieCurve.h"
#line 12 "../tmp/qtiplot/sipqtiPieCurve.cpp"

#line 83 "src/scripting/qti.sip"
#include "../src/table/Table.h"
#include <QDate>
#include <QTime>
#include <QDateTime>
#include <datetime.h> // python include
#define CHECK_TABLE_COL(arg)\
    int col;\
    if (PyInt_Check(arg)) {\
      col = (int)PyInt_AsLong(arg) - 1;\
		if (col < 0 || col >= sipCpp->numCols()) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_ValueError, "There's no column %d in table %s!", col+1, sipCpp->name().ascii());\
		}\
	 } else {\
      PyObject *tmp = PyObject_Str(arg);\
		if (!tmp) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_TypeError, "Column argument must be either int or string.");\
		} else {\
			col = sipCpp->colIndex(PyString_AsString(tmp));\
			if (col < 0) {\
				sipIsErr = 1;\
				PyErr_Format(PyExc_ValueError, "There's no column named %s in table %s!", PyString_AsString(tmp),\
						sipCpp->name().ascii());\
				Py_DECREF(tmp);\
			}\
		}\
	 }

#define CHECK_TABLE_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in table %s!", row+1, sipCpp->name().ascii());\
	}

static int setCellDataHelper(Table* table, int row, int col, PyObject* item) {
  PyTypeObject* item_type = item->ob_type;
  if (item == Py_None) {
    table->clearCell(row, col);
    return 0;
  }
  switch (table->columnType(col)) {
  case Table::Numeric:
    item = PyNumber_Float(item);
    if (item) {
      table->setCell(row, col, PyFloat_AsDouble(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a float!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Text:
    item = PyObject_Str(item);
    if (item) {
      table->setText(row, col, PyString_AsString(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a string!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Date:
    if (sipCanConvertToType(item, sipType_QDateTime, 0)) {
      int isErr = 0;
      QDateTime* dateTime = reinterpret_cast<QDateTime*>(sipConvertToType(item, sipType_QDateTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, dateTime->toString(table->columnFormat(col)));
      delete dateTime;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a datetime!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Time:
    if (sipCanConvertToType(item, sipType_QTime, 0)) {
      int isErr = 0;
      QTime* time = reinterpret_cast<QTime*>(sipConvertToType(item, sipType_QTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, time->toString(table->columnFormat(col)));
      delete time;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a time!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Month:
    item = PyNumber_Int(item);
    if (item) {
      int m = PyInt_AS_LONG(item) % 12; // no type checking required since we casted above
      if (!m)
        m = 12;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "M")
          table->setText(row, col, QDate::shortMonthName(m).left(1));
      else if (format == "MMM")
          table->setText(row, col, QDate::shortMonthName(m));
      else if (format == "MMMM")
          table->setText(row, col, QDate::longMonthName(m));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Day:
    item = PyNumber_Int(item);
    if (item) {
      int day = PyInt_AS_LONG(item) % 7; // no type checking required since we casted above
      if (!day)
        day = 7;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "d")
          table->setText(row, col, QDate::shortDayName(day).left(1));
      else if (format == "ddd")
          table->setText(row, col, QDate::shortDayName(day));
      else if (format == "dddd")
          table->setText(row, col, QDate::longDayName(day));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  default:
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}

static int cellDataHelper(Table* table, int row, int col, PyObject** item) {
  switch (table->columnType(col)) {
  case Table::Numeric:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else
      *item = PyFloat_FromDouble(table->cell(row, col));
    break;
  case Table::Text:
    *item = PyString_FromString(table->text(row, col));
    break;
  case Table::Date:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QDateTime dateTime = QDateTime::fromString(table->text(row, col), table->columnFormat(col));
      QDate date = dateTime.date();
      QTime time = dateTime.time();
      *item = PyDateTime_FromDateAndTime(date.year(), date.month(), date.day(),
                                         time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Time:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QTime time = QTime::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyTime_FromTime(time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Month:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.month());
    }
    break;
  case Table::Day:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.dayOfWeek());
    }
    break;
  default:
    *item = NULL;
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}
#line 224 "../tmp/qtiplot/sipqtiPieCurve.cpp"
#line 36 "/usr/share/sip/PyQt4/QtCore/qstring.sip"
#include <qstring.h>
#line 227 "../tmp/qtiplot/sipqtiPieCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 230 "../tmp/qtiplot/sipqtiPieCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qcolor.sip"
#include <qcolor.h>
#line 233 "../tmp/qtiplot/sipqtiPieCurve.cpp"
#line 1371 "src/scripting/qti.sip"
#include "../src/plot2D/ErrorBarsCurve.h"
#line 236 "../tmp/qtiplot/sipqtiPieCurve.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 239 "../tmp/qtiplot/sipqtiPieCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qfont.sip"
#include <qfont.h>
#line 242 "../tmp/qtiplot/sipqtiPieCurve.cpp"
#line 1160 "src/scripting/qti.sip"
#include <qwt_symbol.h>
#line 245 "../tmp/qtiplot/sipqtiPieCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qbrush.sip"
#include <qbrush.h>
#line 248 "../tmp/qtiplot/sipqtiPieCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qpen.sip"
#include <qpen.h>
#line 251 "../tmp/qtiplot/sipqtiPieCurve.cpp"


extern "C" {static PyObject *meth_PieCurve_clone(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_clone(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve * a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ8", &sipSelf, sipType_PieCurve, &sipCpp, sipType_PieCurve, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->clone(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_clone, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_viewAngle(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_viewAngle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->viewAngle();
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_viewAngle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setViewAngle(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setViewAngle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bd", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setViewAngle(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setViewAngle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_thickness(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_thickness(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->thickness();
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_thickness, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setThickness(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setThickness(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bd", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setThickness(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setThickness, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_horizontalOffset(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_horizontalOffset(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->horizontalOffset();
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_horizontalOffset, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setHorizontalOffset(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setHorizontalOffset(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bd", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setHorizontalOffset(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setHorizontalOffset, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_counterClockwise(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_counterClockwise(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->counterClockwise();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_counterClockwise, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setCounterClockwise(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setCounterClockwise(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bb", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setCounterClockwise(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setCounterClockwise, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_startAzimuth(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_startAzimuth(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->startAzimuth();
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_startAzimuth, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setStartAzimuth(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setStartAzimuth(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bd", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setStartAzimuth(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setStartAzimuth, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_labelsEdgeDistance(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_labelsEdgeDistance(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->labelsEdgeDistance();
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_labelsEdgeDistance, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setLabelsEdgeDistance(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setLabelsEdgeDistance(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bd", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelsEdgeDistance(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setLabelsEdgeDistance, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_labelsAutoFormat(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_labelsAutoFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->labelsAutoFormat();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_labelsAutoFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setLabelsAutoFormat(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setLabelsAutoFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bb", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelsAutoFormat(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setLabelsAutoFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_labelsValuesFormat(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_labelsValuesFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->labelsValuesFormat();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_labelsValuesFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setLabelValuesFormat(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setLabelValuesFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bb", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelValuesFormat(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setLabelValuesFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_labelsPercentagesFormat(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_labelsPercentagesFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->labelsPercentagesFormat();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_labelsPercentagesFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setLabelPercentagesFormat(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setLabelPercentagesFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bb", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelPercentagesFormat(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setLabelPercentagesFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_labelCategories(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_labelCategories(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->labelCategories();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_labelCategories, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setLabelCategories(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setLabelCategories(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bb", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setLabelCategories(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setLabelCategories, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_fixedLabelsPosition(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_fixedLabelsPosition(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->fixedLabelsPosition();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_fixedLabelsPosition, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setFixedLabelsPosition(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setFixedLabelsPosition(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bb", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setFixedLabelsPosition(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setFixedLabelsPosition, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_color(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_color(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        const PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            QColor *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QColor(sipCpp->color(a0));
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QColor,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_color, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_radius(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_radius(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->radius();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_radius, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setRadius(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setRadius(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setRadius(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setRadius, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_pattern(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_pattern(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            Qt::BrushStyle sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->pattern();
            Py_END_ALLOW_THREADS

            return sipConvertFromEnum(sipRes,sipType_Qt_BrushStyle);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_pattern, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setBrushStyle(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setBrushStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Qt::BrushStyle a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BE", &sipSelf, sipType_PieCurve, &sipCpp, sipType_Qt_BrushStyle, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setBrushStyle(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setBrushStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_setFirstColor(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_setFirstColor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_PieCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setFirstColor(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_setFirstColor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_firstColor(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_firstColor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->firstColor();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_firstColor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_loadData(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_loadData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->loadData();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_loadData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_PieCurve_clearLabels(PyObject *, PyObject *);}
static PyObject *meth_PieCurve_clearLabels(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PieCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_PieCurve, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->clearLabels();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PieCurve, sipName_clearLabels, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_PieCurve(void *, const sipTypeDef *);}
static void *cast_PieCurve(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_PieCurve)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_DataCurve)->ctd_cast((DataCurve *)(PieCurve *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_PieCurve(void *, int);}
static void release_PieCurve(void *sipCppV,int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast<PieCurve *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void dealloc_PieCurve(sipSimpleWrapper *);}
static void dealloc_PieCurve(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_PieCurve(sipGetAddress(sipSelf),0);
    }
}


extern "C" {static void *init_PieCurve(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_PieCurve(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    PieCurve *sipCpp = 0;

    {
        Table * a0;
        const QString * a1;
        int a1State = 0;
        int a2;
        int a3;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J8J1ii", sipType_Table, &a0, sipType_QString,&a1, &a1State, &a2, &a3))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new PieCurve(a0,*a1,a2,a3);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_PieCurve[] = {{10, 255, 1}};


static PyMethodDef methods_PieCurve[] = {
    {SIP_MLNAME_CAST(sipName_clearLabels), meth_PieCurve_clearLabels, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_clone), meth_PieCurve_clone, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_color), meth_PieCurve_color, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_counterClockwise), meth_PieCurve_counterClockwise, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_firstColor), meth_PieCurve_firstColor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_fixedLabelsPosition), meth_PieCurve_fixedLabelsPosition, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_horizontalOffset), meth_PieCurve_horizontalOffset, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelCategories), meth_PieCurve_labelCategories, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelsAutoFormat), meth_PieCurve_labelsAutoFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelsEdgeDistance), meth_PieCurve_labelsEdgeDistance, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelsPercentagesFormat), meth_PieCurve_labelsPercentagesFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_labelsValuesFormat), meth_PieCurve_labelsValuesFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_loadData), meth_PieCurve_loadData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_pattern), meth_PieCurve_pattern, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_radius), meth_PieCurve_radius, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setBrushStyle), meth_PieCurve_setBrushStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setCounterClockwise), meth_PieCurve_setCounterClockwise, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setFirstColor), meth_PieCurve_setFirstColor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setFixedLabelsPosition), meth_PieCurve_setFixedLabelsPosition, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setHorizontalOffset), meth_PieCurve_setHorizontalOffset, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelCategories), meth_PieCurve_setLabelCategories, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelPercentagesFormat), meth_PieCurve_setLabelPercentagesFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelValuesFormat), meth_PieCurve_setLabelValuesFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelsAutoFormat), meth_PieCurve_setLabelsAutoFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setLabelsEdgeDistance), meth_PieCurve_setLabelsEdgeDistance, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setRadius), meth_PieCurve_setRadius, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setStartAzimuth), meth_PieCurve_setStartAzimuth, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setThickness), meth_PieCurve_setThickness, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setViewAngle), meth_PieCurve_setViewAngle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_startAzimuth), meth_PieCurve_startAzimuth, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_thickness), meth_PieCurve_thickness, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_viewAngle), meth_PieCurve_viewAngle, METH_VARARGS, NULL}
};


pyqt4ClassTypeDef sipTypeDef_qti_PieCurve = {
{
    {
        -1,
        0,
        0,
        SIP_TYPE_CLASS,
        sipNameNr_PieCurve,
        {0}
    },
    {
        sipNameNr_PieCurve,
        {0, 0, 1},
        32, methods_PieCurve,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    0,
    -1,
    -1,
    supers_PieCurve,
    0,
    init_PieCurve,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_PieCurve,
    0,
    0,
    0,
    release_PieCurve,
    cast_PieCurve,
    0,
    0,
    0
},
    0,
    0,
    0
};
