/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.14.2 on Sat Mar 23 21:54:52 2013
 */

#include "sipAPIqti.h"

#line 83 "src/scripting/qti.sip"
#include "../src/table/Table.h"
#include <QDate>
#include <QTime>
#include <QDateTime>
#include <datetime.h> // python include
#define CHECK_TABLE_COL(arg)\
    int col;\
    if (PyInt_Check(arg)) {\
      col = (int)PyInt_AsLong(arg) - 1;\
		if (col < 0 || col >= sipCpp->numCols()) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_ValueError, "There's no column %d in table %s!", col+1, sipCpp->name().ascii());\
		}\
	 } else {\
      PyObject *tmp = PyObject_Str(arg);\
		if (!tmp) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_TypeError, "Column argument must be either int or string.");\
		} else {\
			col = sipCpp->colIndex(PyString_AsString(tmp));\
			if (col < 0) {\
				sipIsErr = 1;\
				PyErr_Format(PyExc_ValueError, "There's no column named %s in table %s!", PyString_AsString(tmp),\
						sipCpp->name().ascii());\
				Py_DECREF(tmp);\
			}\
		}\
	 }

#define CHECK_TABLE_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in table %s!", row+1, sipCpp->name().ascii());\
	}

static int setCellDataHelper(Table* table, int row, int col, PyObject* item) {
  PyTypeObject* item_type = item->ob_type;
  if (item == Py_None) {
    table->clearCell(row, col);
    return 0;
  }
  switch (table->columnType(col)) {
  case Table::Numeric:
    item = PyNumber_Float(item);
    if (item) {
      table->setCell(row, col, PyFloat_AsDouble(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a float!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Text:
    item = PyObject_Str(item);
    if (item) {
      table->setText(row, col, PyString_AsString(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a string!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Date:
    if (sipCanConvertToType(item, sipType_QDateTime, 0)) {
      int isErr = 0;
      QDateTime* dateTime = reinterpret_cast<QDateTime*>(sipConvertToType(item, sipType_QDateTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, dateTime->toString(table->columnFormat(col)));
      delete dateTime;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a datetime!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Time:
    if (sipCanConvertToType(item, sipType_QTime, 0)) {
      int isErr = 0;
      QTime* time = reinterpret_cast<QTime*>(sipConvertToType(item, sipType_QTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, time->toString(table->columnFormat(col)));
      delete time;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a time!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Month:
    item = PyNumber_Int(item);
    if (item) {
      int m = PyInt_AS_LONG(item) % 12; // no type checking required since we casted above
      if (!m)
        m = 12;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "M")
          table->setText(row, col, QDate::shortMonthName(m).left(1));
      else if (format == "MMM")
          table->setText(row, col, QDate::shortMonthName(m));
      else if (format == "MMMM")
          table->setText(row, col, QDate::longMonthName(m));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Day:
    item = PyNumber_Int(item);
    if (item) {
      int day = PyInt_AS_LONG(item) % 7; // no type checking required since we casted above
      if (!day)
        day = 7;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "d")
          table->setText(row, col, QDate::shortDayName(day).left(1));
      else if (format == "ddd")
          table->setText(row, col, QDate::shortDayName(day));
      else if (format == "dddd")
          table->setText(row, col, QDate::longDayName(day));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  default:
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}

static int cellDataHelper(Table* table, int row, int col, PyObject** item) {
  switch (table->columnType(col)) {
  case Table::Numeric:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else
      *item = PyFloat_FromDouble(table->cell(row, col));
    break;
  case Table::Text:
    *item = PyString_FromString(table->text(row, col));
    break;
  case Table::Date:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QDateTime dateTime = QDateTime::fromString(table->text(row, col), table->columnFormat(col));
      QDate date = dateTime.date();
      QTime time = dateTime.time();
      *item = PyDateTime_FromDateAndTime(date.year(), date.month(), date.day(),
                                         time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Time:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QTime time = QTime::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyTime_FromTime(time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Month:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.month());
    }
    break;
  case Table::Day:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.dayOfWeek());
    }
    break;
  default:
    *item = NULL;
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}
#line 220 "../tmp/qtiplot/sipqtiTable.cpp"

#line 36 "/usr/share/sip/PyQt4/QtCore/qstring.sip"
#include <qstring.h>
#line 224 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qlocale.sip"
#include <qlocale.h>
#line 227 "../tmp/qtiplot/sipqtiTable.cpp"
#line 628 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 230 "../tmp/qtiplot/sipqtiTable.cpp"
#line 36 "/usr/share/sip/PyQt4/QtCore/qstringlist.sip"
#include <qstringlist.h>
#line 233 "../tmp/qtiplot/sipqtiTable.cpp"
#line 3470 "src/scripting/qti.sip"
#include "../src/core/Folder.h"
#line 236 "../tmp/qtiplot/sipqtiTable.cpp"
#line 57 "src/scripting/qti.sip"
#include "../src/core/MdiSubWindow.h"
#line 239 "../tmp/qtiplot/sipqtiTable.cpp"
#line 355 "/usr/share/sip/PyQt4/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 242 "../tmp/qtiplot/sipqtiTable.cpp"
#line 514 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 245 "../tmp/qtiplot/sipqtiTable.cpp"
#line 627 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 248 "../tmp/qtiplot/sipqtiTable.cpp"
#line 483 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 251 "../tmp/qtiplot/sipqtiTable.cpp"
#line 261 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 254 "../tmp/qtiplot/sipqtiTable.cpp"
#line 533 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 257 "../tmp/qtiplot/sipqtiTable.cpp"
#line 557 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 260 "../tmp/qtiplot/sipqtiTable.cpp"
#line 338 "/usr/share/sip/PyQt4/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 263 "../tmp/qtiplot/sipqtiTable.cpp"
#line 570 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 266 "../tmp/qtiplot/sipqtiTable.cpp"
#line 31 "/usr/share/sip/PyQt4/QtCore/qcoreevent.sip"
#include <qcoreevent.h>
#line 269 "../tmp/qtiplot/sipqtiTable.cpp"
#line 583 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 272 "../tmp/qtiplot/sipqtiTable.cpp"
#line 616 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 275 "../tmp/qtiplot/sipqtiTable.cpp"
#line 605 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 278 "../tmp/qtiplot/sipqtiTable.cpp"
#line 34 "/usr/share/sip/PyQt4/QtCore/qobject.sip"
#include <qobject.h>
#line 281 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 284 "../tmp/qtiplot/sipqtiTable.cpp"
#line 39 "/usr/share/sip/PyQt4/QtGui/qmdiarea.sip"
#include <qmdiarea.h>
#line 287 "../tmp/qtiplot/sipqtiTable.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qmenu.sip"
#include <qmenu.h>
#line 290 "../tmp/qtiplot/sipqtiTable.cpp"
#line 39 "/usr/share/sip/PyQt4/QtGui/qmdisubwindow.sip"
#include <qmdisubwindow.h>
#line 293 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qwidget.sip"
#include <qwidget.h>
#line 296 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qsize.sip"
#include <qsize.h>
#line 299 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 302 "../tmp/qtiplot/sipqtiTable.cpp"
#line 39 "/usr/share/sip/PyQt4/QtCore/qmargins.sip"
#include <qmargins.h>
#line 305 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 308 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 311 "../tmp/qtiplot/sipqtiTable.cpp"
#line 39 "/usr/share/sip/PyQt4/QtGui/qgraphicseffect.sip"
#include <qgraphicseffect.h>
#line 314 "../tmp/qtiplot/sipqtiTable.cpp"
#line 33 "/usr/share/sip/PyQt4/QtGui/qgraphicsproxywidget.sip"
#include <qgraphicsproxywidget.h>
#line 317 "../tmp/qtiplot/sipqtiTable.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qpaintdevice.sip"
#include <qpaintdevice.h>
#line 320 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qpoint.sip"
#include <qpoint.h>
#line 323 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qregion.sip"
#include <qregion.h>
#line 326 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qwidget.sip"
#include <qwidget.h>
#line 329 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qpainter.sip"
#include <qpainter.h>
#line 332 "../tmp/qtiplot/sipqtiTable.cpp"
#line 37 "/usr/share/sip/PyQt4/QtCore/qbytearray.sip"
#include <qbytearray.h>
#line 335 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qrect.sip"
#include <qrect.h>
#line 338 "../tmp/qtiplot/sipqtiTable.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qfontinfo.sip"
#include <qfontinfo.h>
#line 341 "../tmp/qtiplot/sipqtiTable.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qfontmetrics.sip"
#include <qfontmetrics.h>
#line 344 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qfont.sip"
#include <qfont.h>
#line 347 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qnamespace.sip"
#include <qnamespace.h>
#line 350 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qpalette.sip"
#include <qpalette.h>
#line 353 "../tmp/qtiplot/sipqtiTable.cpp"
#line 274 "/usr/share/sip/PyQt4/QtCore/qvariant.sip"
#include <qvariant.h>
#line 356 "../tmp/qtiplot/sipqtiTable.cpp"
#line 656 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 359 "../tmp/qtiplot/sipqtiTable.cpp"
#line 748 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 362 "../tmp/qtiplot/sipqtiTable.cpp"
#line 801 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 365 "../tmp/qtiplot/sipqtiTable.cpp"
#line 774 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 368 "../tmp/qtiplot/sipqtiTable.cpp"
#line 790 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 371 "../tmp/qtiplot/sipqtiTable.cpp"
#line 863 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 374 "../tmp/qtiplot/sipqtiTable.cpp"
#line 412 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 377 "../tmp/qtiplot/sipqtiTable.cpp"
#line 356 "/usr/share/sip/PyQt4/QtGui/qevent.sip"
#include <qevent.h>
#line 380 "../tmp/qtiplot/sipqtiTable.cpp"
#line 33 "/usr/share/sip/PyQt4/QtGui/qinputcontext.sip"
#include <qinputcontext.h>
#line 383 "../tmp/qtiplot/sipqtiTable.cpp"
#line 61 "/usr/share/sip/PyQt4/QtGui/qpaintengine.sip"
#include <qpaintengine.h>
#line 386 "../tmp/qtiplot/sipqtiTable.cpp"
#line 39 "/usr/share/sip/PyQt4/QtGui/qx11info_x11.sip"
#include <qx11info_x11.h>
#line 389 "../tmp/qtiplot/sipqtiTable.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 392 "../tmp/qtiplot/sipqtiTable.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qaction.sip"
#include <qaction.h>
#line 395 "../tmp/qtiplot/sipqtiTable.cpp"
#line 31 "/usr/share/sip/PyQt4/QtGui/qlayout.sip"
#include <qlayout.h>
#line 398 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qsizepolicy.sip"
#include <qsizepolicy.h>
#line 401 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qkeysequence.sip"
#include <qkeysequence.h>
#line 404 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qcursor.sip"
#include <qcursor.h>
#line 407 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qicon.sip"
#include <qicon.h>
#line 410 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qbitmap.sip"
#include <qbitmap.h>
#line 413 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qstyle.sip"
#include <qstyle.h>
#line 416 "../tmp/qtiplot/sipqtiTable.cpp"
#line 33 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 419 "../tmp/qtiplot/sipqtiTable.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 422 "../tmp/qtiplot/sipqtiTable.cpp"
#line 31 "/usr/share/sip/PyQt4/QtCore/qthread.sip"
#include <qthread.h>
#line 425 "../tmp/qtiplot/sipqtiTable.cpp"
#line 35 "/usr/share/sip/PyQt4/QtCore/qregexp.sip"
#include <qregexp.h>
#line 428 "../tmp/qtiplot/sipqtiTable.cpp"
#line 31 "/usr/share/sip/PyQt4/QtCore/qobjectdefs.sip"
#include <qobjectdefs.h>
#line 431 "../tmp/qtiplot/sipqtiTable.cpp"


extern "C" {static PyObject *meth_Table_numRows(PyObject *, PyObject *);}
static PyObject *meth_Table_numRows(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Table, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->numRows();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_numRows, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_numCols(PyObject *, PyObject *);}
static PyObject *meth_Table_numCols(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Table, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->numCols();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_numCols, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setNumRows(PyObject *, PyObject *);}
static PyObject *meth_Table_setNumRows(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_Table, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setNumRows(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setNumRows, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setNumCols(PyObject *, PyObject *);}
static PyObject *meth_Table_setNumCols(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_Table, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setNumCols(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setNumCols, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_deleteRows(PyObject *, PyObject *);}
static PyObject *meth_Table_deleteRows(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        int a1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bii", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->deleteRows(a0,a1);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_deleteRows, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_text(PyObject *, PyObject *);}
static PyObject *meth_Table_text(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0i", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            PyObject * sipRes = 0;
            int sipIsErr = 0;

#line 338 "src/scripting/qti.sip"
  sipIsErr = 0;
  CHECK_TABLE_COL(a0);
  CHECK_TABLE_ROW(a1);
  if (sipIsErr == 0) {
		PyObject *encstr = PyString_FromString(sipCpp->text(row, col).utf8());
		if (encstr) {
			sipRes = PyUnicode_FromEncodedObject(encstr, "utf8", 0);
			Py_DECREF(encstr);
		} else {
			sipRes = NULL;
			sipIsErr = 1;
		}
	}
#line 599 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return sipRes;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_text, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_removeCol(PyObject *, PyObject *);}
static PyObject *meth_Table_removeCol(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0", &sipSelf, sipType_Table, &sipCpp, &a0))
        {
            int sipIsErr = 0;

#line 355 "src/scripting/qti.sip"
    sipIsErr=0;
    CHECK_TABLE_COL(a0);
	if (sipIsErr == 0){
        QStringList list;
		list << sipCpp->colName(col);
        sipCpp->removeCol(list);
    }
#line 636 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_removeCol, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_cell(PyObject *, PyObject *);}
static PyObject *meth_Table_cell(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0i", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            double sipRes = 0;
            int sipIsErr = 0;

#line 366 "src/scripting/qti.sip"
  sipIsErr = 0;
  CHECK_TABLE_COL(a0);
  CHECK_TABLE_ROW(a1);
	if (sipIsErr == 0){
		if (sipCpp->text(row, col) != "")
			sipRes = sipCpp->cell(row, col);
		else {
			sipRes = NULL;
			PyErr_SetString(PyExc_ValueError, "Empty table cell");
		}
	}
#line 680 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_cell, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_cellData(PyObject *, PyObject *);}
static PyObject *meth_Table_cellData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0i", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            PyObject * sipRes = 0;
            int sipIsErr = 0;

#line 380 "src/scripting/qti.sip"
  sipIsErr = 0;
  CHECK_TABLE_COL(a0);
  CHECK_TABLE_ROW(a1);
	if (sipIsErr == 0)
    sipIsErr = cellDataHelper(sipCpp, row, col, &sipRes);
#line 717 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return sipRes;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_cellData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_rowData(PyObject *, PyObject *);}
static PyObject *meth_Table_rowData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_Table, &sipCpp, &a0))
        {
            PyObject * sipRes = 0;
            int sipIsErr = 0;

#line 388 "src/scripting/qti.sip"
  PyObject *item;
  sipIsErr = 0;
  CHECK_TABLE_ROW(a0);
	if (sipIsErr == 0){
    int size = sipCpp->numCols();
    sipRes = PyTuple_New(size);
    for(int col = 0; col < size; col++) {
      sipIsErr = cellDataHelper(sipCpp, row, col, &item);
      if (sipIsErr == 0)
        PyTuple_SET_ITEM(sipRes, col, item);
      else {
        Py_DECREF(sipRes);
        sipRes = NULL;
        break;
      }
    } // for each col
	} // if not sip error
#line 765 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return sipRes;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_rowData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_colData(PyObject *, PyObject *);}
static PyObject *meth_Table_colData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0", &sipSelf, sipType_Table, &sipCpp, &a0))
        {
            PyObject * sipRes = 0;
            int sipIsErr = 0;

#line 442 "src/scripting/qti.sip"
  PyObject *item;
  sipIsErr = 0;
  CHECK_TABLE_COL(a0);
	if (sipIsErr == 0){
    int size = sipCpp->numRows();
    sipRes = PyList_New(size);
    for(int row = 0; row < size; row++) {
      sipIsErr = cellDataHelper(sipCpp, row, col, &item);
      if (sipIsErr == 0)
        PyList_SET_ITEM(sipRes, row, item);
      else {
        Py_DECREF(sipRes);
        sipRes = NULL;
        break;
      }
    } // for
	} // if not sip error
#line 813 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return sipRes;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_colData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setRowData(PyObject *, PyObject *);}
static PyObject *meth_Table_setRowData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        PyObject * a1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BiT", &sipSelf, sipType_Table, &sipCpp, &a0, &PyTuple_Type, &a1))
        {
            int sipIsErr = 0;

#line 462 "src/scripting/qti.sip"
  PyObject *item;
  sipIsErr = 0;
  CHECK_TABLE_ROW(a0);
  int n = PyTuple_Size(a1);
  int size = sipCpp->numCols();
  if (n != size) {
    sipIsErr = 1;
    PyErr_SetString(PyExc_ValueError, "The argument length must match the table's column count!");
  }
	if (sipIsErr == 0){
    for(int col = 0; col < size; col++) {
      item = PyTuple_GET_ITEM(a1, col);
      sipIsErr = setCellDataHelper(sipCpp, row, col, item);
      if (sipIsErr)
        break;
    } // for each col
	} // if not sip error
#line 861 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setRowData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_appendRowData(PyObject *, PyObject *);}
static PyObject *meth_Table_appendRowData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BT", &sipSelf, sipType_Table, &sipCpp, &PyTuple_Type, &a0))
        {
            int sipRes = 0;
            int sipIsErr = 0;

#line 499 "src/scripting/qti.sip"
  sipRes = sipCpp->numRows() + 1;
  sipCpp->resizeRows(sipRes);
  PyObject* methodName = PyString_FromString("setRowData");
  PyObject* rowNumber = PyInt_FromLong(sipRes);
  PyObject* ret = PyObject_CallMethodObjArgs(sipSelf, methodName, rowNumber, a0, NULL);
  if (ret == NULL)
    sipIsErr = 1;
  else
    Py_DECREF(ret);
  Py_DECREF(rowNumber);
  Py_DECREF(methodName);
#line 904 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_appendRowData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setColData(PyObject *, PyObject *);}
static PyObject *meth_Table_setColData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        PyObject * a1;
        int a2 = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0P0|i", &sipSelf, sipType_Table, &sipCpp, &a0, &a1, &a2))
        {
            int sipIsErr = 0;

#line 513 "src/scripting/qti.sip"
  PyObject *item;
  PyObject *iterator = PyObject_GetIter(a1);
  sipIsErr = 0;
  CHECK_TABLE_COL(a0);
  int tableLength = sipCpp->numRows();
  if (iterator == NULL) {
    sipIsErr = 1;
    PyErr_SetString(PyExc_TypeError, "Object needs to be iterable");
  }
  else {
    while (a2 < 0) { // a negative offset should skip the first values in the iterator
      if (item = PyIter_Next(iterator))
        Py_DECREF(item); // not needed any more
      else {
        sipIsErr = 1;
        if (! PyErr_Occurred())
          PyErr_SetString(PyExc_StopIteration, "Iterator ended before any row could be filled!");
      }
      a2++;
    } //while
  }
	if (sipIsErr == 0){
    for(int row = a2; row < tableLength; row++) {
      if (item = PyIter_Next(iterator)) {
        sipIsErr = setCellDataHelper(sipCpp, row, col, item);
        Py_DECREF(item);
      }
      else {
        sipIsErr = 1;
        if (! PyErr_Occurred())
          PyErr_SetString(PyExc_StopIteration, "Iterator ended before all rows were filled!");
      }
      if (sipIsErr)
        break;
    } // for each row
	} // if not sip error
  if (iterator)
    Py_DECREF(iterator);
#line 974 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setColData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setText(PyObject *, PyObject *);}
static PyObject *meth_Table_setText(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1;
        const QString * a2;
        int a2State = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0iJ1", &sipSelf, sipType_Table, &sipCpp, &a0, &a1, sipType_QString,&a2, &a2State))
        {
            int sipIsErr = 0;

#line 554 "src/scripting/qti.sip"
  sipIsErr = 0;
  CHECK_TABLE_COL(a0);
  CHECK_TABLE_ROW(a1);
	if (sipIsErr == 0)
		sipCpp->setText(row, col, *a2);
#line 1013 "../tmp/qtiplot/sipqtiTable.cpp"
            sipReleaseType(const_cast<QString *>(a2),sipType_QString,a2State);

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setText, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setCell(PyObject *, PyObject *);}
static PyObject *meth_Table_setCell(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1;
        double a2;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0id", &sipSelf, sipType_Table, &sipCpp, &a0, &a1, &a2))
        {
            int sipIsErr = 0;

#line 562 "src/scripting/qti.sip"
  sipIsErr = 0;
  CHECK_TABLE_COL(a0);
  CHECK_TABLE_ROW(a1);
	if (sipIsErr == 0)
		sipCpp->setCell(row, col, a2);
#line 1052 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setCell, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setCellData(PyObject *, PyObject *);}
static PyObject *meth_Table_setCellData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1;
        PyObject * a2;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0iP0", &sipSelf, sipType_Table, &sipCpp, &a0, &a1, &a2))
        {
            int sipIsErr = 0;

#line 570 "src/scripting/qti.sip"
  sipIsErr = 0;
  CHECK_TABLE_COL(a0);
  CHECK_TABLE_ROW(a1);
	if (sipIsErr == 0)
		sipIsErr = setCellDataHelper(sipCpp, row, col, a2);
#line 1090 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setCellData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_colName(PyObject *, PyObject *);}
static PyObject *meth_Table_colName(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_Table, &sipCpp, &a0))
        {
            PyObject * sipRes = 0;
            int sipIsErr = 0;

#line 578 "src/scripting/qti.sip"
   if (a0 < 1 || a0 > sipCpp->numCols()) {\
		sipIsErr = 1;\
		PyErr_SetString(PyExc_ValueError, "Invalid column argument");\
	} else
		sipRes = PyString_FromString(sipCpp->colLabel(a0-1));
#line 1127 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return sipRes;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_colName, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_colNames(PyObject *, PyObject *);}
static PyObject *meth_Table_colNames(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Table, &sipCpp))
        {
            PyObject * sipRes = 0;
            int sipIsErr = 0;

#line 586 "src/scripting/qti.sip"
  QStringList l = sipCpp->colNames();
  int size = l.count();
  sipRes = PyTuple_New(size);
  if(sipRes) {
    for(int i=0; i<size; i++)
      PyTuple_SET_ITEM(sipRes, i, PyString_FromString(l.at(i)));
  } else
    sipIsErr = 1;
#line 1165 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return sipRes;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_colNames, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setColName(PyObject *, PyObject *);}
static PyObject *meth_Table_setColName(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        const QString * a1;
        int a1State = 0;
        bool a2 = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0J1|b", &sipSelf, sipType_Table, &sipCpp, &a0, sipType_QString,&a1, &a1State, &a2))
        {
            int sipIsErr = 0;

#line 597 "src/scripting/qti.sip"
	sipIsErr = 0;
   CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->setColName(col, *a1, a2);
#line 1202 "../tmp/qtiplot/sipqtiTable.cpp"
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setColName, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setColNames(PyObject *, PyObject *);}
static PyObject *meth_Table_setColNames(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        QStringList * a0;
        int a0State = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_Table, &sipCpp, sipType_QStringList,&a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setHeader(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(a0,sipType_QStringList,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setColNames, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_notifyChanges(PyObject *, PyObject *);}
static PyObject *meth_Table_notifyChanges(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Table, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->notifyChanges();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_notifyChanges, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_importASCII(PyObject *, PyObject *);}
static PyObject *meth_Table_importASCII(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        const QString& a1def = "\t";
        const QString * a1 = &a1def;
        int a1State = 0;
        int a2 = 0;
        bool a3 = 0;
        bool a4 = 1;
        bool a5 = 0;
        bool a6 = 0;
        const QString& a7def = "#";
        const QString * a7 = &a7def;
        int a7State = 0;
        bool a8 = 0;
        Table::ImportMode a9 = Table::Overwrite;
        const QLocale& a10def = QLocale();
        const QLocale * a10 = &a10def;
        int a11 = 0;
        int a12 = -1;
        const QList<int>& a13def = QList<int>();
        const QList<int> * a13 = &a13def;
        int a13State = 0;
        const QStringList& a14def = QStringList();
        const QStringList * a14 = &a14def;
        int a14State = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1|J1ibbbbJ1bEJ9iiJ1J1", &sipSelf, sipType_Table, &sipCpp, sipType_QString,&a0, &a0State, sipType_QString,&a1, &a1State, &a2, &a3, &a4, &a5, &a6, sipType_QString,&a7, &a7State, &a8, sipType_Table_ImportMode, &a9, sipType_QLocale, &a10, &a11, &a12, sipType_QList_1800,&a13, &a13State, sipType_QStringList,&a14, &a14State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->importASCII(*a0,*a1,a2,a3,a4,a5,a6,*a7,a8,a9,*a10,a11,a12,*a13,*a14);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);
            sipReleaseType(const_cast<QString *>(a7),sipType_QString,a7State);
            sipReleaseType(const_cast<QList<int> *>(a13),sipType_QList_1800,a13State);
            sipReleaseType(const_cast<QStringList *>(a14),sipType_QStringList,a14State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_importASCII, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_exportASCII(PyObject *, PyObject *);}
static PyObject *meth_Table_exportASCII(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        const QString& a1def = "\t";
        const QString * a1 = &a1def;
        int a1State = 0;
        bool a2 = 0;
        bool a3 = 0;
        bool a4 = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1|J1bbb", &sipSelf, sipType_Table, &sipCpp, sipType_QString,&a0, &a0State, sipType_QString,&a1, &a1State, &a2, &a3, &a4))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->exportASCII(*a0,*a1,a2,a3,a4);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_exportASCII, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setDecimalSeparators(PyObject *, PyObject *);}
static PyObject *meth_Table_setDecimalSeparators(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        bool a1 = 1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi|b", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
#line 612 "src/scripting/qti.sip"
	QLocale locale;
    switch (a0){
        case 0:
            locale = QLocale::system();
        break;
        case 1:
            locale = QLocale::c();
        break;
        case 2:
            locale = QLocale(QLocale::German);
        break;
        case 3:
            locale = QLocale(QLocale::French);
        break;
    }
 	if (a1==true)
		locale.setNumberOptions(QLocale::OmitGroupSeparator);

    sipCpp->updateDecimalSeparators(locale);
#line 1400 "../tmp/qtiplot/sipqtiTable.cpp"

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setDecimalSeparators, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_normalize(PyObject *, PyObject *);}
static PyObject *meth_Table_normalize(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0", &sipSelf, sipType_Table, &sipCpp, &a0))
        {
            int sipIsErr = 0;

#line 635 "src/scripting/qti.sip"
	sipIsErr = 0;
	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->normalizeCol(col);
#line 1432 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    {
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Table, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->normalize();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_normalize, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_sortColumn(PyObject *, PyObject *);}
static PyObject *meth_Table_sortColumn(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1 = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0|i", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            int sipIsErr = 0;

#line 644 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->sortColumn(col, a1);
#line 1482 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_sortColumn, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_sort(PyObject *, PyObject *);}
static PyObject *meth_Table_sort(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0 = 0;
        int a1 = 0;
        const QString& a2def = QString();
        const QString * a2 = &a2def;
        int a2State = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|iiJ1", &sipSelf, sipType_Table, &sipCpp, &a0, &a1, sipType_QString,&a2, &a2State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->sort(a0,a1,*a2);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a2),sipType_QString,a2State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_sort, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_sortColumns(PyObject *, PyObject *);}
static PyObject *meth_Table_sortColumns(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1 = 0;
        int a2 = 0;
        const QString& a3def = QString();
        const QString * a3 = &a3def;
        int a3State = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BT|iiJ1", &sipSelf, sipType_Table, &sipCpp, &PyTuple_Type, &a0, &a1, &a2, sipType_QString,&a3, &a3State))
        {
            int sipIsErr = 0;

#line 652 "src/scripting/qti.sip"
  QStringList l;
  int n = PyTuple_Size(a0);
  for (int i=0; i<n; i++) {
    PyObject *str = PyObject_Str(PyTuple_GET_ITEM(a0,i));
    if (str) {
      l << PyString_AsString(str);
		Py_DECREF(str);
	 } else {
      sipIsErr = 1;
      break;
    }
  }
  sipCpp->sortColumns(l, a1, a2, *a3);
#line 1563 "../tmp/qtiplot/sipqtiTable.cpp"
            sipReleaseType(const_cast<QString *>(a3),sipType_QString,a3State);

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_sortColumns, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setRandomValues(PyObject *, PyObject *);}
static PyObject *meth_Table_setRandomValues(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1 = 1;
        int a2 = -1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0|ii", &sipSelf, sipType_Table, &sipCpp, &a0, &a1, &a2))
        {
            int sipIsErr = 0;

#line 669 "src/scripting/qti.sip"
sipIsErr = 0;
CHECK_TABLE_COL(a0);
if (sipIsErr == 0)
	sipCpp->setRandomValues(col, a1 - 1, a2 - 1);
#line 1601 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setRandomValues, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setNormalRandomValues(PyObject *, PyObject *);}
static PyObject *meth_Table_setNormalRandomValues(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1 = 1;
        int a2 = -1;
        double a3 = 1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0|iid", &sipSelf, sipType_Table, &sipCpp, &a0, &a1, &a2, &a3))
        {
            int sipIsErr = 0;

#line 677 "src/scripting/qti.sip"
sipIsErr = 0;
CHECK_TABLE_COL(a0);
if (sipIsErr == 0)
	sipCpp->setNormalRandomValues(col, a1 - 1, a2 - 1, a3);
#line 1639 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setNormalRandomValues, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setCommand(PyObject *, PyObject *);}
static PyObject *meth_Table_setCommand(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        const QString * a1;
        int a1State = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0J1", &sipSelf, sipType_Table, &sipCpp, &a0, sipType_QString,&a1, &a1State))
        {
            int sipIsErr = 0;

#line 685 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->setCommand(col, *a1);
#line 1676 "../tmp/qtiplot/sipqtiTable.cpp"
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setCommand, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_recalculate(PyObject *, PyObject *);}
static PyObject *meth_Table_recalculate(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1 = 1;
        int a2 = -1;
        bool a3 = 0;
        bool a4 = 1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0|iibb", &sipSelf, sipType_Table, &sipCpp, &a0, &a1, &a2, &a3, &a4))
        {
            bool sipRes = 0;
            int sipIsErr = 0;

#line 692 "src/scripting/qti.sip"
  sipIsErr = 0;
  CHECK_TABLE_COL(a0);
  if (a2 == -1)
    a2 = sipCpp->numRows();
  if (sipIsErr == 0)
    sipCpp->calculate(col, a1 - 1, a2 - 1, a3, a4); // row indes starts at 0
#line 1719 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_recalculate, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_comment(PyObject *, PyObject *);}
static PyObject *meth_Table_comment(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0", &sipSelf, sipType_Table, &sipCpp, &a0))
        {
            QString *sipRes = 0;
            int sipIsErr = 0;

#line 702 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		return Py_BuildValue("s", sipCpp->comment(col).toAscii().constData());
#line 1754 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return sipConvertFromNewType(sipRes,sipType_QString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_comment, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setComment(PyObject *, PyObject *);}
static PyObject *meth_Table_setComment(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        const QString * a1;
        int a1State = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0J1", &sipSelf, sipType_Table, &sipCpp, &a0, sipType_QString,&a1, &a1State))
        {
            int sipIsErr = 0;

#line 710 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->setColComment(col, *a1);
#line 1790 "../tmp/qtiplot/sipqtiTable.cpp"
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setComment, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_showComments(PyObject *, PyObject *);}
static PyObject *meth_Table_showComments(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0 = 1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|b", &sipSelf, sipType_Table, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->showComments(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_showComments, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setReadOnlyColumn(PyObject *, PyObject *);}
static PyObject *meth_Table_setReadOnlyColumn(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        bool a1 = 1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0|b", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            int sipIsErr = 0;

#line 720 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->setReadOnlyColumn(col, a1);
#line 1854 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setReadOnlyColumn, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setColumnRole(PyObject *, PyObject *);}
static PyObject *meth_Table_setColumnRole(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        Table::PlotDesignation a1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0E", &sipSelf, sipType_Table, &sipCpp, &a0, sipType_Table_PlotDesignation, &a1))
        {
            int sipIsErr = 0;

#line 728 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0){
		sipCpp->setColPlotDesignation(col, a1);
		sipCpp->setHeaderColType();
	}
#line 1892 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setColumnRole, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setColTextFormat(PyObject *, PyObject *);}
static PyObject *meth_Table_setColTextFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0", &sipSelf, sipType_Table, &sipCpp, &a0))
        {
            int sipIsErr = 0;

#line 738 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->setTextFormat(col);
#line 1927 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setColTextFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setColNumericFormat(PyObject *, PyObject *);}
static PyObject *meth_Table_setColNumericFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1;
        int a2;
        bool a3 = 1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0ii|b", &sipSelf, sipType_Table, &sipCpp, &a0, &a1, &a2, &a3))
        {
            int sipIsErr = 0;

#line 746 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->setColNumericFormat(a1, a2, col, a3);
#line 1965 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setColNumericFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setColDateFormat(PyObject *, PyObject *);}
static PyObject *meth_Table_setColDateFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        const QString * a1;
        int a1State = 0;
        bool a2 = 1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0J1|b", &sipSelf, sipType_Table, &sipCpp, &a0, sipType_QString,&a1, &a1State, &a2))
        {
            int sipIsErr = 0;

#line 754 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->setDateFormat(*a1, col, a2);
#line 2003 "../tmp/qtiplot/sipqtiTable.cpp"
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setColDateFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setColTimeFormat(PyObject *, PyObject *);}
static PyObject *meth_Table_setColTimeFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        const QString * a1;
        int a1State = 0;
        bool a2 = 1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0J1|b", &sipSelf, sipType_Table, &sipCpp, &a0, sipType_QString,&a1, &a1State, &a2))
        {
            int sipIsErr = 0;

#line 762 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->setTimeFormat(*a1, col, a2);
#line 2042 "../tmp/qtiplot/sipqtiTable.cpp"
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setColTimeFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setColMonthFormat(PyObject *, PyObject *);}
static PyObject *meth_Table_setColMonthFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        const QString * a1;
        int a1State = 0;
        bool a2 = 1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0J1|b", &sipSelf, sipType_Table, &sipCpp, &a0, sipType_QString,&a1, &a1State, &a2))
        {
            int sipIsErr = 0;

#line 770 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->setMonthFormat(*a1, col, a2);
#line 2081 "../tmp/qtiplot/sipqtiTable.cpp"
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setColMonthFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setColDayFormat(PyObject *, PyObject *);}
static PyObject *meth_Table_setColDayFormat(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        const QString * a1;
        int a1State = 0;
        bool a2 = 1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0J1|b", &sipSelf, sipType_Table, &sipCpp, &a0, sipType_QString,&a1, &a1State, &a2))
        {
            int sipIsErr = 0;

#line 778 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->setDayFormat(*a1, col, a2);
#line 2120 "../tmp/qtiplot/sipqtiTable.cpp"
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setColDayFormat, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setColumnWidth(PyObject *, PyObject *);}
static PyObject *meth_Table_setColumnWidth(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0i", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            int sipIsErr = 0;

#line 786 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->setColumnWidth(col, a1);
#line 2157 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setColumnWidth, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_showAllColumns(PyObject *, PyObject *);}
static PyObject *meth_Table_showAllColumns(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Table, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->showAllColumns();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_showAllColumns, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_hideColumn(PyObject *, PyObject *);}
static PyObject *meth_Table_hideColumn(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        bool a1 = 1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0|b", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            int sipIsErr = 0;

#line 795 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->hideColumn(col, a1);
#line 2219 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_hideColumn, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_isRowSelected(PyObject *, PyObject *);}
static PyObject *meth_Table_isRowSelected(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        bool a1 = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi|b", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            bool sipRes = 0;
            int sipIsErr = 0;

#line 803 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_ROW(a0);
	if (sipIsErr == 0)
		return Py_BuildValue("b",sipCpp->isRowSelected(row, a1));

#line 2257 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_isRowSelected, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_isColSelected(PyObject *, PyObject *);}
static PyObject *meth_Table_isColSelected(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        bool a1 = 0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0|b", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            bool sipRes = 0;
            int sipIsErr = 0;

#line 812 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		return Py_BuildValue("b",sipCpp->isColumnSelected(col, a1));
#line 2293 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_isColSelected, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_firstSelectedColumn(PyObject *, PyObject *);}
static PyObject *meth_Table_firstSelectedColumn(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Table, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->firstSelectedColumn();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_firstSelectedColumn, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_numSelectedRows(PyObject *, PyObject *);}
static PyObject *meth_Table_numSelectedRows(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Table, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->numSelectedRows();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_numSelectedRows, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_setSelectedCol(PyObject *, PyObject *);}
static PyObject *meth_Table_setSelectedCol(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0", &sipSelf, sipType_Table, &sipCpp, &a0))
        {
            int sipIsErr = 0;

#line 823 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->setSelectedCol(col);
#line 2381 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_setSelectedCol, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_selectedColumn(PyObject *, PyObject *);}
static PyObject *meth_Table_selectedColumn(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Table, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->selectedColumn();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_selectedColumn, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_addColumn(PyObject *, PyObject *);}
static PyObject *meth_Table_addColumn(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table::PlotDesignation a0 = Table::Y;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B|E", &sipSelf, sipType_Table, &sipCpp, sipType_Table_PlotDesignation, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->addCol(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_addColumn, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_addRow(PyObject *, PyObject *);}
static PyObject *meth_Table_addRow(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_Table, &sipCpp))
        {
            int sipRes = 0;

#line 834 "src/scripting/qti.sip"
  sipRes = sipCpp->numRows() + 1;
  sipCpp->resizeRows(sipRes);
#line 2467 "../tmp/qtiplot/sipqtiTable.cpp"

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_addRow, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_insertColumns(PyObject *, PyObject *);}
static PyObject *meth_Table_insertColumns(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0i", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            int sipIsErr = 0;

#line 839 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);
	if (sipIsErr == 0)
		sipCpp->insertCols(col, a1);
#line 2499 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_insertColumns, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_swapColumns(PyObject *, PyObject *);}
static PyObject *meth_Table_swapColumns(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        PyObject * a1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0P0", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            int sipIsErr = 0;

#line 847 "src/scripting/qti.sip"
  	sipIsErr = 0;
  	CHECK_TABLE_COL(a0);

  	int col2;
    if (PyInt_Check(a1)) {
      col2 = (int)PyInt_AsLong(a1) - 1;
		if (col2 < 0 || col2 >= sipCpp->numCols()) {
			sipIsErr = 1;
			PyErr_Format(PyExc_ValueError, "There's no column %d in table %s!", col2+1, sipCpp->name().ascii());
		}
	 } else {
      PyObject *tmp = PyObject_Str(a1);
		if (!tmp) {
			sipIsErr = 1;
			PyErr_Format(PyExc_TypeError, "Column argument must be either int or string.");
		} else {
			col2 = sipCpp->colNames().findIndex(PyString_AsString(tmp));
			if (col2 < 0) {
				sipIsErr = 1;
				PyErr_Format(PyExc_ValueError, "There's no column named %s in table %s!", PyString_AsString(tmp),sipCpp->name().ascii());
				Py_DECREF(tmp);
			}
		}
	 }

	if (sipIsErr == 0)
		sipCpp->swapColumns(col, col2);
#line 2558 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_swapColumns, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_Table_scrollToCell(PyObject *, PyObject *);}
static PyObject *meth_Table_scrollToCell(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        PyObject * a0;
        int a1;
        Table *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BP0i", &sipSelf, sipType_Table, &sipCpp, &a0, &a1))
        {
            int sipIsErr = 0;

#line 878 "src/scripting/qti.sip"
  sipIsErr = 0;
  CHECK_TABLE_COL(a0);
  CHECK_TABLE_ROW(a1);
  if (sipIsErr == 0)
    sipCpp->table()->ensureCellVisible(row, col); // for some reason these indices seem to start at 1
#line 2595 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName_scrollToCell, NULL);

    return NULL;
}


extern "C" {static int slot_Table___setitem__(PyObject *,PyObject *);}
static int slot_Table___setitem__(PyObject *sipSelf,PyObject *sipArgs)
{
    Table *sipCpp = reinterpret_cast<Table *>(sipGetCppPtr((sipSimpleWrapper *)sipSelf,sipType_Table));

    if (!sipCpp)
        return -1;

    PyObject *sipParseErr = NULL;

    {
        int a0;
        PyObject * a1;

        if (sipParseArgs(&sipParseErr, sipArgs, "iT", &a0, &PyTuple_Type, &a1))
        {
            int sipIsErr = 0;

#line 482 "src/scripting/qti.sip"
  SIP_SSIZE_T idx = sipConvertFromSequenceIndex(a0, sipCpp->numRows());
  if (idx < 0)
    sipIsErr = 1;
  else {
    PyObject* methodName = PyString_FromString("setRowData");
    PyObject* rowNumber = PyInt_FromLong(idx + 1); // setRowData's index starts at 1
    PyObject* ret = PyObject_CallMethodObjArgs(sipSelf, methodName, rowNumber, a1, NULL);
    if (ret == NULL)
      sipIsErr = 1;
    else
      Py_DECREF(ret);
    Py_DECREF(rowNumber);
    Py_DECREF(methodName);
  }
#line 2645 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return -1;

            return 0;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName___setitem__, NULL);

    return -1;
}


extern "C" {static PyObject *slot_Table___getitem__(PyObject *,PyObject *);}
static PyObject *slot_Table___getitem__(PyObject *sipSelf,PyObject *sipArg)
{
    Table *sipCpp = reinterpret_cast<Table *>(sipGetCppPtr((sipSimpleWrapper *)sipSelf,sipType_Table));

    if (!sipCpp)
        return 0;

    PyObject *sipParseErr = NULL;

    {
        int a0;

        if (sipParseArgs(&sipParseErr, sipArg, "1i", &a0))
        {
            PyObject * sipRes = 0;
            int sipIsErr = 0;

#line 408 "src/scripting/qti.sip"
  SIP_SSIZE_T idx = sipConvertFromSequenceIndex(a0, sipCpp->numRows());
  if (idx < 0)
    sipIsErr = 1;
  else {
    sipRes = PyObject_CallMethod(sipSelf, "rowData", "i", idx + 1); // rowData's index starts at 1
    if (sipRes == NULL)
      sipIsErr = 1;
  }
#line 2688 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return sipRes;
        }
    }

    {
        PyObject * a0;

        if (sipParseArgs(&sipParseErr, sipArg, "1T", &PySlice_Type, &a0))
        {
            PyObject * sipRes = 0;
            int sipIsErr = 0;

#line 419 "src/scripting/qti.sip"
  SIP_SSIZE_T len, start, stop, step, slicelength;
  len = sipCpp->numRows();
  if (PySlice_GetIndicesEx((PySliceObject *)a0, len, &start, &stop, &step, &slicelength) < 0)
    sipIsErr = 1;
  else {
    PyObject *item;
    sipRes = PyList_New(slicelength);
    for(int i = 0; i < slicelength; i++) {
      item = PyObject_CallMethod(sipSelf, "rowData", "i", start + 1); // rowData's index starts at 1
      start += step;
      if (item)
        PyList_SET_ITEM(sipRes, i, item);
      else {
        Py_DECREF(sipRes);
        sipRes = NULL;
        sipIsErr = 1;
        break;
      }
    } // for
  }
#line 2726 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return 0;

            return sipRes;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName___getitem__, NULL);

    return 0;
}


extern "C" {static int slot_Table___delitem__(PyObject *,PyObject *);}
static int slot_Table___delitem__(PyObject *sipSelf,PyObject *sipArg)
{
    Table *sipCpp = reinterpret_cast<Table *>(sipGetCppPtr((sipSimpleWrapper *)sipSelf,sipType_Table));

    if (!sipCpp)
        return -1;

    PyObject *sipParseErr = NULL;

    {
        int a0;

        if (sipParseArgs(&sipParseErr, sipArg, "1i", &a0))
        {
            int sipIsErr = 0;

#line 311 "src/scripting/qti.sip"
  int len = sipCpp->numRows();
  if ((a0 = (int)sipConvertFromSequenceIndex(a0, len)) < 0)
    sipIsErr = 1;
  else
    sipCpp->deleteRows(a0 + 1, a0 + 1); // start and stop are equal, counting starts at 1
#line 2765 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return -1;

            return 0;
        }
    }

    {
        PyObject * a0;

        if (sipParseArgs(&sipParseErr, sipArg, "1T", &PySlice_Type, &a0))
        {
            int sipIsErr = 0;

#line 319 "src/scripting/qti.sip"
  SIP_SSIZE_T len, start, stop, step, slicelength;
  len = sipCpp->numRows();
  if (PySlice_GetIndicesEx((PySliceObject *)a0, len, &start, &stop, &step, &slicelength) < 0)
    sipIsErr = 1;
  else {
    start += 1; // row index starts at 1 (python at 0); the stop is inclusive (python exclusive) so no need to change
    if (step == 1)
      sipCpp->deleteRows(start, stop);
    else {
      for (int i = 0; i < slicelength; i++) {
        sipCpp->deleteRows(start, start);
        start += step - 1; // the "- 1" is needed since the removal also shifts the index
      }
    }
  }
#line 2797 "../tmp/qtiplot/sipqtiTable.cpp"

            if (sipIsErr)
                return -1;

            return 0;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_Table, sipName___delitem__, NULL);

    return -1;
}


extern "C" {static SIP_SSIZE_T slot_Table___len__(PyObject *);}
static SIP_SSIZE_T slot_Table___len__(PyObject *sipSelf)
{
    Table *sipCpp = reinterpret_cast<Table *>(sipGetCppPtr((sipSimpleWrapper *)sipSelf,sipType_Table));

    if (!sipCpp)
        return 0;


    {
        {
            int sipRes = 0;

#line 302 "src/scripting/qti.sip"
  sipRes = sipCpp->numRows();
#line 2828 "../tmp/qtiplot/sipqtiTable.cpp"

            return sipRes;
        }
    }

    return 0;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_Table(void *, const sipTypeDef *);}
static void *cast_Table(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_Table)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_MdiSubWindow)->ctd_cast((MdiSubWindow *)(Table *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_Table(void *, int);}
static void release_Table(void *sipCppV,int)
{
    Py_BEGIN_ALLOW_THREADS

    Table *sipCpp = reinterpret_cast<Table *>(sipCppV);

    if (QThread::currentThread() == sipCpp->thread())
        delete sipCpp;
    else
        sipCpp->deleteLater();

    Py_END_ALLOW_THREADS
}


extern "C" {static void dealloc_Table(sipSimpleWrapper *);}
static void dealloc_Table(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_Table(sipGetAddress(sipSelf),0);
    }
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_Table[] = {{55, 255, 1}};


/* Define this type's Python slots. */
static sipPySlotDef slots_Table[] = {
    {(void *)slot_Table___setitem__, setitem_slot},
    {(void *)slot_Table___getitem__, getitem_slot},
    {(void *)slot_Table___delitem__, delitem_slot},
    {(void *)slot_Table___len__, len_slot},
    {0, (sipPySlotType)0}
};


static PyMethodDef methods_Table[] = {
    {SIP_MLNAME_CAST(sipName_addColumn), meth_Table_addColumn, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_addRow), meth_Table_addRow, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_appendRowData), meth_Table_appendRowData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_cell), meth_Table_cell, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_cellData), meth_Table_cellData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_colData), meth_Table_colData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_colName), meth_Table_colName, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_colNames), meth_Table_colNames, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_comment), meth_Table_comment, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_deleteRows), meth_Table_deleteRows, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_exportASCII), meth_Table_exportASCII, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_firstSelectedColumn), meth_Table_firstSelectedColumn, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_hideColumn), meth_Table_hideColumn, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_importASCII), meth_Table_importASCII, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_insertColumns), meth_Table_insertColumns, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_isColSelected), meth_Table_isColSelected, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_isRowSelected), meth_Table_isRowSelected, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_normalize), meth_Table_normalize, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_notifyChanges), meth_Table_notifyChanges, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_numCols), meth_Table_numCols, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_numRows), meth_Table_numRows, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_numSelectedRows), meth_Table_numSelectedRows, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_recalculate), meth_Table_recalculate, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_removeCol), meth_Table_removeCol, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_rowData), meth_Table_rowData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_scrollToCell), meth_Table_scrollToCell, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_selectedColumn), meth_Table_selectedColumn, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setCell), meth_Table_setCell, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setCellData), meth_Table_setCellData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColData), meth_Table_setColData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColDateFormat), meth_Table_setColDateFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColDayFormat), meth_Table_setColDayFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColMonthFormat), meth_Table_setColMonthFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColName), meth_Table_setColName, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColNames), meth_Table_setColNames, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColNumericFormat), meth_Table_setColNumericFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColTextFormat), meth_Table_setColTextFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColTimeFormat), meth_Table_setColTimeFormat, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColumnRole), meth_Table_setColumnRole, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColumnWidth), meth_Table_setColumnWidth, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setCommand), meth_Table_setCommand, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setComment), meth_Table_setComment, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setDecimalSeparators), meth_Table_setDecimalSeparators, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setNormalRandomValues), meth_Table_setNormalRandomValues, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setNumCols), meth_Table_setNumCols, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setNumRows), meth_Table_setNumRows, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setRandomValues), meth_Table_setRandomValues, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setReadOnlyColumn), meth_Table_setReadOnlyColumn, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setRowData), meth_Table_setRowData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setSelectedCol), meth_Table_setSelectedCol, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setText), meth_Table_setText, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_showAllColumns), meth_Table_showAllColumns, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_showComments), meth_Table_showComments, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_sort), meth_Table_sort, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_sortColumn), meth_Table_sortColumn, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_sortColumns), meth_Table_sortColumns, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_swapColumns), meth_Table_swapColumns, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_text), meth_Table_text, METH_VARARGS, NULL}
};

static sipEnumMemberDef enummembers_Table[] = {
    {sipName_Decimal, Table::Decimal, 98},
    {sipName_Default, Table::Default, 98},
    {sipName_Label, Table::Label, 99},
    {sipName_NewColumns, Table::NewColumns, 97},
    {sipName_NewRows, Table::NewRows, 97},
    {sipName_None, Table::None, 99},
    {sipName_Overwrite, Table::Overwrite, 97},
    {sipName_Scientific, Table::Scientific, 98},
    {sipName_X, Table::X, 99},
    {sipName_Y, Table::Y, 99},
    {sipName_Z, Table::Z, 99},
    {sipName_xErr, Table::xErr, 99},
    {sipName_yErr, Table::yErr, 99},
};


pyqt4ClassTypeDef sipTypeDef_qti_Table = {
{
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_Table,
        {0}
    },
    {
        sipNameNr_Table,
        {0, 0, 1},
        58, methods_Table,
        13, enummembers_Table,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    0,
    -1,
    -1,
    supers_Table,
    slots_Table,
    0,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_Table,
    0,
    0,
    0,
    release_Table,
    cast_Table,
    0,
    0,
    0
},
    &Table::staticMetaObject,
    0,
    0
};
