/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.14.2 on Sat Mar 23 21:54:52 2013
 */

#include "sipAPIqti.h"

#line 1481 "src/scripting/qti.sip"
#include "../src/plot2D/VectorCurve.h"
#line 12 "../tmp/qtiplot/sipqtiVectorCurve.cpp"

#line 83 "src/scripting/qti.sip"
#include "../src/table/Table.h"
#include <QDate>
#include <QTime>
#include <QDateTime>
#include <datetime.h> // python include
#define CHECK_TABLE_COL(arg)\
    int col;\
    if (PyInt_Check(arg)) {\
      col = (int)PyInt_AsLong(arg) - 1;\
		if (col < 0 || col >= sipCpp->numCols()) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_ValueError, "There's no column %d in table %s!", col+1, sipCpp->name().ascii());\
		}\
	 } else {\
      PyObject *tmp = PyObject_Str(arg);\
		if (!tmp) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_TypeError, "Column argument must be either int or string.");\
		} else {\
			col = sipCpp->colIndex(PyString_AsString(tmp));\
			if (col < 0) {\
				sipIsErr = 1;\
				PyErr_Format(PyExc_ValueError, "There's no column named %s in table %s!", PyString_AsString(tmp),\
						sipCpp->name().ascii());\
				Py_DECREF(tmp);\
			}\
		}\
	 }

#define CHECK_TABLE_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in table %s!", row+1, sipCpp->name().ascii());\
	}

static int setCellDataHelper(Table* table, int row, int col, PyObject* item) {
  PyTypeObject* item_type = item->ob_type;
  if (item == Py_None) {
    table->clearCell(row, col);
    return 0;
  }
  switch (table->columnType(col)) {
  case Table::Numeric:
    item = PyNumber_Float(item);
    if (item) {
      table->setCell(row, col, PyFloat_AsDouble(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a float!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Text:
    item = PyObject_Str(item);
    if (item) {
      table->setText(row, col, PyString_AsString(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a string!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Date:
    if (sipCanConvertToType(item, sipType_QDateTime, 0)) {
      int isErr = 0;
      QDateTime* dateTime = reinterpret_cast<QDateTime*>(sipConvertToType(item, sipType_QDateTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, dateTime->toString(table->columnFormat(col)));
      delete dateTime;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a datetime!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Time:
    if (sipCanConvertToType(item, sipType_QTime, 0)) {
      int isErr = 0;
      QTime* time = reinterpret_cast<QTime*>(sipConvertToType(item, sipType_QTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, time->toString(table->columnFormat(col)));
      delete time;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a time!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Month:
    item = PyNumber_Int(item);
    if (item) {
      int m = PyInt_AS_LONG(item) % 12; // no type checking required since we casted above
      if (!m)
        m = 12;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "M")
          table->setText(row, col, QDate::shortMonthName(m).left(1));
      else if (format == "MMM")
          table->setText(row, col, QDate::shortMonthName(m));
      else if (format == "MMMM")
          table->setText(row, col, QDate::longMonthName(m));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Day:
    item = PyNumber_Int(item);
    if (item) {
      int day = PyInt_AS_LONG(item) % 7; // no type checking required since we casted above
      if (!day)
        day = 7;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "d")
          table->setText(row, col, QDate::shortDayName(day).left(1));
      else if (format == "ddd")
          table->setText(row, col, QDate::shortDayName(day));
      else if (format == "dddd")
          table->setText(row, col, QDate::longDayName(day));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  default:
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}

static int cellDataHelper(Table* table, int row, int col, PyObject** item) {
  switch (table->columnType(col)) {
  case Table::Numeric:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else
      *item = PyFloat_FromDouble(table->cell(row, col));
    break;
  case Table::Text:
    *item = PyString_FromString(table->text(row, col));
    break;
  case Table::Date:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QDateTime dateTime = QDateTime::fromString(table->text(row, col), table->columnFormat(col));
      QDate date = dateTime.date();
      QTime time = dateTime.time();
      *item = PyDateTime_FromDateAndTime(date.year(), date.month(), date.day(),
                                         time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Time:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QTime time = QTime::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyTime_FromTime(time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Month:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.month());
    }
    break;
  case Table::Day:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.dayOfWeek());
    }
    break;
  default:
    *item = NULL;
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}
#line 224 "../tmp/qtiplot/sipqtiVectorCurve.cpp"
#line 36 "/usr/share/sip/PyQt4/QtCore/qstring.sip"
#include <qstring.h>
#line 227 "../tmp/qtiplot/sipqtiVectorCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qpen.sip"
#include <qpen.h>
#line 230 "../tmp/qtiplot/sipqtiVectorCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qcolor.sip"
#include <qcolor.h>
#line 233 "../tmp/qtiplot/sipqtiVectorCurve.cpp"
#line 1371 "src/scripting/qti.sip"
#include "../src/plot2D/ErrorBarsCurve.h"
#line 236 "../tmp/qtiplot/sipqtiVectorCurve.cpp"
#line 120 "/usr/share/sip/PyQt4/QtCore/qlist.sip"
#include <qlist.h>
#line 239 "../tmp/qtiplot/sipqtiVectorCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qfont.sip"
#include <qfont.h>
#line 242 "../tmp/qtiplot/sipqtiVectorCurve.cpp"
#line 1160 "src/scripting/qti.sip"
#include <qwt_symbol.h>
#line 245 "../tmp/qtiplot/sipqtiVectorCurve.cpp"
#line 35 "/usr/share/sip/PyQt4/QtGui/qbrush.sip"
#include <qbrush.h>
#line 248 "../tmp/qtiplot/sipqtiVectorCurve.cpp"


extern "C" {static PyObject *meth_VectorCurve_vectorEndXAColName(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_vectorEndXAColName(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_VectorCurve, &sipCpp))
        {
            QString *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QString(sipCpp->vectorEndXAColName());
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_vectorEndXAColName, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_vectorEndYMColName(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_vectorEndYMColName(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_VectorCurve, &sipCpp))
        {
            QString *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QString(sipCpp->vectorEndYMColName());
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_vectorEndYMColName, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_setVectorEnd(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_setVectorEnd(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QString * a0;
        int a0State = 0;
        const QString * a1;
        int a1State = 0;
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1J1", &sipSelf, sipType_VectorCurve, &sipCpp, sipType_QString,&a0, &a0State, sipType_QString,&a1, &a1State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setVectorEnd(*a0,*a1);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a0),sipType_QString,a0State);
            sipReleaseType(const_cast<QString *>(a1),sipType_QString,a1State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_setVectorEnd, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_width(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_width(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_VectorCurve, &sipCpp))
        {
            double sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->width();
            Py_END_ALLOW_THREADS

            return PyFloat_FromDouble(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_width, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_setWidth(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_setWidth(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        double a0;
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bd", &sipSelf, sipType_VectorCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setWidth(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_setWidth, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_color(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_color(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_VectorCurve, &sipCpp))
        {
            QColor *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QColor(sipCpp->color());
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QColor,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_color, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_setColor(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_setColor(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QColor * a0;
        int a0State = 0;
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_VectorCurve, &sipCpp, sipType_QColor, &a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setColor(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QColor *>(a0),sipType_QColor,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_setColor, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_headLength(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_headLength(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_VectorCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->headLength();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_headLength, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_setHeadLength(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_setHeadLength(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_VectorCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setHeadLength(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_setHeadLength, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_headAngle(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_headAngle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_VectorCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->headAngle();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_headAngle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_setHeadAngle(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_setHeadAngle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_VectorCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setHeadAngle(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_setHeadAngle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_filledArrowHead(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_filledArrowHead(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_VectorCurve, &sipCpp))
        {
            bool sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->filledArrowHead();
            Py_END_ALLOW_THREADS

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_filledArrowHead, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_fillArrowHead(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_fillArrowHead(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        bool a0;
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bb", &sipSelf, sipType_VectorCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->fillArrowHead(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_fillArrowHead, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_position(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_position(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_VectorCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->position();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_position, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_setPosition(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_setPosition(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_VectorCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setPosition(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_setPosition, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_vectorStyle(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_vectorStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_VectorCurve, &sipCpp))
        {
            int sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->vectorStyle();
            Py_END_ALLOW_THREADS

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_vectorStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_setVectorStyle(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_setVectorStyle(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        int a0;
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "Bi", &sipSelf, sipType_VectorCurve, &sipCpp, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setVectorStyle(a0);
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_setVectorStyle, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_loadData(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_loadData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_VectorCurve, &sipCpp))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->loadData();
            Py_END_ALLOW_THREADS

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_loadData, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_vectorPen(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_vectorPen(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_VectorCurve, &sipCpp))
        {
            QPen *sipRes;

            Py_BEGIN_ALLOW_THREADS
            sipRes = new QPen(sipCpp->vectorPen());
            Py_END_ALLOW_THREADS

            return sipConvertFromNewType(sipRes,sipType_QPen,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_vectorPen, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_VectorCurve_setVectorPen(PyObject *, PyObject *);}
static PyObject *meth_VectorCurve_setVectorPen(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const QPen * a0;
        int a0State = 0;
        VectorCurve *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "BJ1", &sipSelf, sipType_VectorCurve, &sipCpp, sipType_QPen, &a0, &a0State))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp->setVectorPen(*a0);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QPen *>(a0),sipType_QPen,a0State);

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_VectorCurve, sipName_setVectorPen, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_VectorCurve(void *, const sipTypeDef *);}
static void *cast_VectorCurve(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_VectorCurve)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_DataCurve)->ctd_cast((DataCurve *)(VectorCurve *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_VectorCurve(void *, int);}
static void release_VectorCurve(void *sipCppV,int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast<VectorCurve *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void dealloc_VectorCurve(sipSimpleWrapper *);}
static void dealloc_VectorCurve(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_VectorCurve(sipGetAddress(sipSelf),0);
    }
}


extern "C" {static void *init_VectorCurve(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_VectorCurve(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    VectorCurve *sipCpp = 0;

    {
        VectorCurve::VectorStyle a0;
        Table * a1;
        const QString * a2;
        int a2State = 0;
        const char * a3;
        const QString * a4;
        int a4State = 0;
        const QString * a5;
        int a5State = 0;
        int a6;
        int a7;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "EJ8J1sJ1J1ii", sipType_VectorCurve_VectorStyle, &a0, sipType_Table, &a1, sipType_QString,&a2, &a2State, &a3, sipType_QString,&a4, &a4State, sipType_QString,&a5, &a5State, &a6, &a7))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new VectorCurve(a0,a1,*a2,a3,*a4,*a5,a6,a7);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<QString *>(a2),sipType_QString,a2State);
            sipReleaseType(const_cast<QString *>(a4),sipType_QString,a4State);
            sipReleaseType(const_cast<QString *>(a5),sipType_QString,a5State);

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_VectorCurve[] = {{10, 255, 1}};


static PyMethodDef methods_VectorCurve[] = {
    {SIP_MLNAME_CAST(sipName_color), meth_VectorCurve_color, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_fillArrowHead), meth_VectorCurve_fillArrowHead, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_filledArrowHead), meth_VectorCurve_filledArrowHead, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_headAngle), meth_VectorCurve_headAngle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_headLength), meth_VectorCurve_headLength, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_loadData), meth_VectorCurve_loadData, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_position), meth_VectorCurve_position, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setColor), meth_VectorCurve_setColor, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setHeadAngle), meth_VectorCurve_setHeadAngle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setHeadLength), meth_VectorCurve_setHeadLength, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setPosition), meth_VectorCurve_setPosition, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setVectorEnd), meth_VectorCurve_setVectorEnd, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setVectorPen), meth_VectorCurve_setVectorPen, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setVectorStyle), meth_VectorCurve_setVectorStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_setWidth), meth_VectorCurve_setWidth, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_vectorEndXAColName), meth_VectorCurve_vectorEndXAColName, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_vectorEndYMColName), meth_VectorCurve_vectorEndYMColName, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_vectorPen), meth_VectorCurve_vectorPen, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_vectorStyle), meth_VectorCurve_vectorStyle, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_width), meth_VectorCurve_width, METH_VARARGS, NULL}
};

static sipEnumMemberDef enummembers_VectorCurve[] = {
    {sipName_Head, VectorCurve::Head, 103},
    {sipName_Middle, VectorCurve::Middle, 103},
    {sipName_Tail, VectorCurve::Tail, 103},
    {sipName_XYAM, VectorCurve::XYAM, 104},
    {sipName_XYXY, VectorCurve::XYXY, 104},
};


pyqt4ClassTypeDef sipTypeDef_qti_VectorCurve = {
{
    {
        -1,
        0,
        0,
        SIP_TYPE_CLASS,
        sipNameNr_VectorCurve,
        {0}
    },
    {
        sipNameNr_VectorCurve,
        {0, 0, 1},
        20, methods_VectorCurve,
        5, enummembers_VectorCurve,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    0,
    -1,
    -1,
    supers_VectorCurve,
    0,
    init_VectorCurve,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_VectorCurve,
    0,
    0,
    0,
    release_VectorCurve,
    cast_VectorCurve,
    0,
    0,
    0
},
    0,
    0,
    0
};
