/*
 * Module code.
 *
 * Generated by SIP 4.14.2 on Sat Mar 23 21:54:52 2013
 */

#include "sipAPIqti.h"

#line 34 "/usr/share/sip/PyQt4/QtCore/qobject.sip"
#include <qobject.h>
#line 12 "../tmp/qtiplot/sipqticmodule.cpp"
#line 1752 "src/scripting/qti.sip"
#include "../src/plot2D/Graph.h"
#include "../src/plot2D/LegendWidget.h"
#line 16 "../tmp/qtiplot/sipqticmodule.cpp"
#line 83 "src/scripting/qti.sip"
#include "../src/table/Table.h"
#include <QDate>
#include <QTime>
#include <QDateTime>
#include <datetime.h> // python include
#define CHECK_TABLE_COL(arg)\
    int col;\
    if (PyInt_Check(arg)) {\
      col = (int)PyInt_AsLong(arg) - 1;\
		if (col < 0 || col >= sipCpp->numCols()) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_ValueError, "There's no column %d in table %s!", col+1, sipCpp->name().ascii());\
		}\
	 } else {\
      PyObject *tmp = PyObject_Str(arg);\
		if (!tmp) {\
			sipIsErr = 1;\
			PyErr_Format(PyExc_TypeError, "Column argument must be either int or string.");\
		} else {\
			col = sipCpp->colIndex(PyString_AsString(tmp));\
			if (col < 0) {\
				sipIsErr = 1;\
				PyErr_Format(PyExc_ValueError, "There's no column named %s in table %s!", PyString_AsString(tmp),\
						sipCpp->name().ascii());\
				Py_DECREF(tmp);\
			}\
		}\
	 }

#define CHECK_TABLE_ROW(arg)\
   int row = arg-1;\
	if (row < 0 || row >= sipCpp->numRows()) {\
		sipIsErr = 1;\
		PyErr_Format(PyExc_ValueError, "There's no row %d in table %s!", row+1, sipCpp->name().ascii());\
	}

static int setCellDataHelper(Table* table, int row, int col, PyObject* item) {
  PyTypeObject* item_type = item->ob_type;
  if (item == Py_None) {
    table->clearCell(row, col);
    return 0;
  }
  switch (table->columnType(col)) {
  case Table::Numeric:
    item = PyNumber_Float(item);
    if (item) {
      table->setCell(row, col, PyFloat_AsDouble(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a float!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Text:
    item = PyObject_Str(item);
    if (item) {
      table->setText(row, col, PyString_AsString(item));
      Py_DECREF(item);
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a string!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Date:
    if (sipCanConvertToType(item, sipType_QDateTime, 0)) {
      int isErr = 0;
      QDateTime* dateTime = reinterpret_cast<QDateTime*>(sipConvertToType(item, sipType_QDateTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, dateTime->toString(table->columnFormat(col)));
      delete dateTime;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a datetime!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Time:
    if (sipCanConvertToType(item, sipType_QTime, 0)) {
      int isErr = 0;
      QTime* time = reinterpret_cast<QTime*>(sipConvertToType(item, sipType_QTime,
                            0/*sipTransferObj*/, 0/*flags*/, 0/*state*/, &isErr));
      if (isErr)
        return 1;
      table->setText(row, col, time->toString(table->columnFormat(col)));
      delete time;
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a time!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Month:
    item = PyNumber_Int(item);
    if (item) {
      int m = PyInt_AS_LONG(item) % 12; // no type checking required since we casted above
      if (!m)
        m = 12;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "M")
          table->setText(row, col, QDate::shortMonthName(m).left(1));
      else if (format == "MMM")
          table->setText(row, col, QDate::shortMonthName(m));
      else if (format == "MMMM")
          table->setText(row, col, QDate::longMonthName(m));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  case Table::Day:
    item = PyNumber_Int(item);
    if (item) {
      int day = PyInt_AS_LONG(item) % 7; // no type checking required since we casted above
      if (!day)
        day = 7;
      QString format = table->columnFormat(col);
      Py_DECREF(item);
      if (format == "d")
          table->setText(row, col, QDate::shortDayName(day).left(1));
      else if (format == "ddd")
          table->setText(row, col, QDate::shortDayName(day));
      else if (format == "dddd")
          table->setText(row, col, QDate::longDayName(day));
    }
    else {
      if (PyType_Ready(item_type) == 0)
        PyErr_Format(PyExc_TypeError, "Can't convert <%s> into a number!", item_type->tp_name);
      return 1;
    }
    break;
  default:
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}

static int cellDataHelper(Table* table, int row, int col, PyObject** item) {
  switch (table->columnType(col)) {
  case Table::Numeric:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else
      *item = PyFloat_FromDouble(table->cell(row, col));
    break;
  case Table::Text:
    *item = PyString_FromString(table->text(row, col));
    break;
  case Table::Date:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QDateTime dateTime = QDateTime::fromString(table->text(row, col), table->columnFormat(col));
      QDate date = dateTime.date();
      QTime time = dateTime.time();
      *item = PyDateTime_FromDateAndTime(date.year(), date.month(), date.day(),
                                         time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Time:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      if (!PyDateTimeAPI)
        PyDateTime_IMPORT;
      QTime time = QTime::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyTime_FromTime(time.hour(), time.minute(), time.second(), time.msec()*1000);
    }
    break;
  case Table::Month:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.month());
    }
    break;
  case Table::Day:
    if (table->text(row, col).isEmpty())
      *item = Py_None;
    else {
      QDate date = QDate::fromString(table->text(row, col), table->columnFormat(col));
      *item = PyInt_FromLong(date.dayOfWeek());
    }
    break;
  default:
    *item = NULL;
    PyErr_Format(PyExc_ValueError, "Type %d of column %d in table %s not supported!",
                 table->columnType(col), col+1, table->name().ascii());
    return 1;
    break;
  } // switch column type
  return 0; // everything ok
}
#line 227 "../tmp/qtiplot/sipqticmodule.cpp"
#line 36 "/usr/share/sip/PyQt4/QtCore/qstring.sip"
#include <qstring.h>
#line 230 "../tmp/qtiplot/sipqticmodule.cpp"
#line 36 "/usr/share/sip/PyQt4/QtCore/qstringlist.sip"
#include <qstringlist.h>
#line 233 "../tmp/qtiplot/sipqticmodule.cpp"

/* Define the strings used by this module. */
const char sipStrings_qti[] = {
    'A', 'p', 'p', 'l', 'i', 'c', 'a', 't', 'i', 'o', 'n', 'W', 'i', 'n', 'd', 'o', 'w', ':', ':', 'M', 'a', 't', 'r', 'i', 'x', 'T', 'o', 'T', 'a', 'b', 'l', 'e', 'C', 'o', 'n', 'v', 'e', 'r', 's', 'i', 'o', 'n', 0,
    'I', 'n', 't', 'e', 'r', 'p', 'o', 'l', 'a', 't', 'i', 'o', 'n', ':', ':', 'I', 'n', 't', 'e', 'r', 'p', 'o', 'l', 'a', 't', 'i', 'o', 'n', 'M', 'e', 't', 'h', 'o', 'd', 0,
    'Q', 'w', 't', 'P', 'l', 'o', 't', 'S', 'p', 'e', 'c', 't', 'r', 'o', 'g', 'r', 'a', 'm', ':', ':', 'D', 'i', 's', 'p', 'l', 'a', 'y', 'M', 'o', 'd', 'e', 0,
    'P', 'y', 'Q', 't', '4', '.', 'Q', 't', 'C', 'o', 'r', 'e', '.', 'p', 'y', 'q', 't', 'W', 'r', 'a', 'p', 'p', 'e', 'r', 'T', 'y', 'p', 'e', 0,
    'E', 'r', 'r', 'o', 'r', 'B', 'a', 'r', 's', 'C', 'u', 'r', 'v', 'e', ':', ':', 'O', 'r', 'i', 'e', 'n', 't', 'a', 't', 'i', 'o', 'n', 0,
    'F', 'u', 'n', 'c', 't', 'i', 'o', 'n', 'C', 'u', 'r', 'v', 'e', ':', ':', 'F', 'u', 'n', 'c', 't', 'i', 'o', 'n', 'T', 'y', 'p', 'e', 0,
    'M', 'd', 'i', 'S', 'u', 'b', 'W', 'i', 'n', 'd', 'o', 'w', ':', ':', 'C', 'a', 'p', 't', 'i', 'o', 'n', 'P', 'o', 'l', 'i', 'c', 'y', 0,
    'c', 'r', 'e', 'a', 't', 'e', 'M', 'i', 'm', 'e', 'D', 'a', 't', 'a', 'F', 'r', 'o', 'm', 'S', 'e', 'l', 'e', 'c', 't', 'i', 'o', 'n', 0,
    'S', 'm', 'o', 'o', 't', 'h', 'F', 'i', 'l', 't', 'e', 'r', ':', ':', 'S', 'm', 'o', 'o', 't', 'h', 'M', 'e', 't', 'h', 'o', 'd', 0,
    'U', 'n', 's', 'c', 'a', 'l', 'e', 'd', 'L', 'e', 'v', 'e', 'n', 'b', 'e', 'r', 'g', 'M', 'a', 'r', 'q', 'u', 'a', 'r', 'd', 't', 0,
    'G', 'r', 'a', 'p', 'h', '3', 'D', ':', ':', 'A', 'x', 'i', 's', 'N', 'u', 'm', 'e', 'r', 'i', 'c', 'F', 'o', 'r', 'm', 'a', 't', 0,
    'M', 'u', 'l', 't', 'i', 'L', 'a', 'y', 'e', 'r', ':', ':', 'V', 'e', 'r', 't', 'A', 'l', 'i', 'g', 'n', 'e', 'm', 'e', 'n', 't', 0,
    's', 'h', 'o', 'w', 'D', 'e', 's', 'c', 'r', 'i', 'p', 't', 'i', 'v', 'e', 'S', 't', 'a', 't', 'i', 's', 't', 'i', 'c', 's', 0,
    'M', 'u', 'l', 't', 'i', 'P', 'e', 'a', 'k', 'F', 'i', 't', ':', ':', 'P', 'e', 'a', 'k', 'P', 'r', 'o', 'f', 'i', 'l', 'e', 0,
    'M', 'u', 'l', 't', 'i', 'L', 'a', 'y', 'e', 'r', ':', ':', 'H', 'o', 'r', 'A', 'l', 'i', 'g', 'n', 'e', 'm', 'e', 'n', 't', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 'P', 'e', 'r', 'c', 'e', 'n', 't', 'a', 'g', 'e', 's', 'F', 'o', 'r', 'm', 'a', 't', 0,
    'Q', 'w', 't', 'L', 'i', 'n', 'e', 'a', 'r', 'C', 'o', 'l', 'o', 'r', 'M', 'a', 'p', ':', ':', 'F', 'o', 'r', 'm', 'a', 't', 0,
    'S', 'c', 'a', 'l', 'e', 'd', 'L', 'e', 'v', 'e', 'n', 'b', 'e', 'r', 'g', 'M', 'a', 'r', 'q', 'u', 'a', 'r', 'd', 't', 0,
    's', 'e', 't', 'C', 'a', 'n', 'v', 'a', 's', 'B', 'a', 'c', 'k', 'g', 'r', 'o', 'u', 'n', 'd', 'I', 'm', 'a', 'g', 'e', 0,
    'c', 'a', 'n', 'v', 'a', 's', 'B', 'a', 'c', 'k', 'g', 'r', 'o', 'u', 'n', 'd', 'F', 'i', 'l', 'e', 'N', 'a', 'm', 'e', 0,
    'V', 'e', 'c', 't', 'o', 'r', 'C', 'u', 'r', 'v', 'e', ':', ':', 'V', 'e', 'c', 't', 'o', 'r', 'S', 't', 'y', 'l', 'e', 0,
    'M', 'a', 't', 'r', 'i', 'x', ':', ':', 'R', 'e', 's', 'a', 'm', 'p', 'l', 'i', 'n', 'g', 'M', 'e', 't', 'h', 'o', 'd', 0,
    't', 'a', 'b', 'l', 'e', 'T', 'o', 'M', 'a', 't', 'r', 'i', 'x', 'R', 'e', 'g', 'u', 'l', 'a', 'r', 'X', 'Y', 'Z', 0,
    'M', 'u', 'l', 't', 'i', 'L', 'a', 'y', 'e', 'r', ':', ':', 'A', 'l', 'i', 'g', 'n', 'P', 'o', 'l', 'i', 'c', 'y', 0,
    'l', 'a', 'b', 'e', 'l', 's', 'P', 'e', 'r', 'c', 'e', 'n', 't', 'a', 'g', 'e', 's', 'F', 'o', 'r', 'm', 'a', 't', 0,
    'F', 'r', 'a', 'm', 'e', 'W', 'i', 'd', 'g', 'e', 't', ':', ':', 'F', 'r', 'a', 'm', 'e', 'S', 't', 'y', 'l', 'e', 0,
    'Q', 'w', 't', 'L', 'i', 'n', 'e', 'a', 'r', 'C', 'o', 'l', 'o', 'r', 'M', 'a', 'p', ':', ':', 'M', 'o', 'd', 'e', 0,
    'Q', 'L', 'i', 's', 't', '<', 'E', 'r', 'r', 'o', 'r', 'B', 'a', 'r', 's', 'C', 'u', 'r', 'v', 'e', '*', '>', 0,
    's', 'e', 't', 'S', 'c', 'a', 'l', 'e', 'L', 'a', 'y', 'e', 'r', 's', 'O', 'n', 'R', 'e', 's', 'i', 'z', 'e', 0,
    's', 'e', 't', 'F', 'i', 'x', 'e', 'd', 'L', 'a', 'b', 'e', 'l', 's', 'P', 'o', 's', 'i', 't', 'i', 'o', 'n', 0,
    'M', 'a', 't', 'r', 'i', 'x', ':', ':', 'H', 'e', 'a', 'd', 'e', 'r', 'V', 'i', 'e', 'w', 'T', 'y', 'p', 'e', 0,
    'T', 'a', 'b', 'l', 'e', ':', ':', 'P', 'l', 'o', 't', 'D', 'e', 's', 'i', 'g', 'n', 'a', 't', 'i', 'o', 'n', 0,
    'w', 'i', 'n', 'd', 'o', 'w', 'A', 'c', 't', 'i', 'v', 'a', 't', 'i', 'o', 'n', 'C', 'h', 'a', 'n', 'g', 'e', 0,
    'F', 'F', 'T', 'F', 'i', 'l', 't', 'e', 'r', ':', ':', 'F', 'i', 'l', 't', 'e', 'r', 'T', 'y', 'p', 'e', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'G', 'r', 'a', 'p', 'h', 'i', 'c', 's', 'D', 'i', 's', 'p', 'l', 'a', 'y', 0,
    'g', 'e', 'n', 'e', 'r', 'a', 't', 'e', 'P', 'a', 'r', 'a', 'm', 'e', 't', 'e', 'r', 'L', 'i', 's', 't', 0,
    's', 'e', 't', 'Z', 'A', 'x', 'i', 's', 'N', 'u', 'm', 'e', 'r', 'i', 'c', 'F', 'o', 'r', 'm', 'a', 't', 0,
    's', 'e', 't', 'Y', 'A', 'x', 'i', 's', 'N', 'u', 'm', 'e', 'r', 'i', 'c', 'F', 'o', 'r', 'm', 'a', 't', 0,
    's', 'e', 't', 'X', 'A', 'x', 'i', 's', 'N', 'u', 'm', 'e', 'r', 'i', 'c', 'F', 'o', 'r', 'm', 'a', 't', 0,
    'r', 'e', 'v', 'e', 'r', 's', 'e', 'W', 'a', 't', 'e', 'r', 'f', 'a', 'l', 'l', 'O', 'r', 'd', 'e', 'r', 0,
    's', 'e', 't', 'W', 'a', 't', 'e', 'r', 'f', 'a', 'l', 'l', 'F', 'i', 'l', 'l', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'W', 'a', 't', 'e', 'r', 'f', 'a', 'l', 'l', 'S', 'i', 'd', 'e', 'L', 'i', 'n', 'e', 's', 0,
    's', 'e', 't', 'A', 'x', 'i', 's', 'T', 'i', 't', 'l', 'e', 'A', 'l', 'i', 'g', 'n', 'm', 'e', 'n', 't', 0,
    'a', 'd', 'd', 'P', 'a', 'r', 'a', 'm', 'e', 't', 'r', 'i', 'c', 'F', 'u', 'n', 'c', 't', 'i', 'o', 'n', 0,
    's', 'h', 'o', 'w', 'C', 'o', 'n', 't', 'o', 'u', 'r', 'L', 'i', 'n', 'e', 'L', 'a', 'b', 'e', 'l', 's', 0,
    'V', 'e', 'c', 't', 'o', 'r', 'C', 'u', 'r', 'v', 'e', ':', ':', 'P', 'o', 's', 'i', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 's', 'E', 'd', 'g', 'e', 'D', 'i', 's', 't', 'a', 'n', 'c', 'e', 0,
    'd', 'e', 't', 'a', 'c', 'h', 'F', 'r', 'o', 'm', 'M', 'a', 's', 't', 'e', 'r', 'C', 'u', 'r', 'v', 'e', 0,
    's', 'e', 't', 'N', 'o', 'r', 'm', 'a', 'l', 'R', 'a', 'n', 'd', 'o', 'm', 'V', 'a', 'l', 'u', 'e', 's', 0,
    'c', 'a', 'n', 'I', 'n', 's', 'e', 'r', 't', 'F', 'r', 'o', 'm', 'M', 'i', 'm', 'e', 'D', 'a', 't', 'a', 0,
    'm', 'o', 'u', 's', 'e', 'D', 'o', 'u', 'b', 'l', 'e', 'C', 'l', 'i', 'c', 'k', 'E', 'v', 'e', 'n', 't', 0,
    'Q', 'L', 'i', 's', 't', '<', 'M', 'd', 'i', 'S', 'u', 'b', 'W', 'i', 'n', 'd', 'o', 'w', '*', '>', 0,
    's', 'e', 't', 'S', 'i', 'g', 'n', 'i', 'f', 'i', 'c', 'a', 'n', 'c', 'e', 'L', 'e', 'v', 'e', 'l', 0,
    's', 'e', 't', 'M', 'a', 'x', 'i', 'm', 'u', 'm', 'I', 't', 'e', 'r', 'a', 't', 'i', 'o', 'n', 's', 0,
    's', 'h', 'o', 'w', 'C', 'o', 'n', 'f', 'i', 'd', 'e', 'n', 'c', 'e', 'L', 'i', 'm', 'i', 't', 's', 0,
    's', 'h', 'o', 'w', 'P', 'r', 'e', 'd', 'i', 'c', 't', 'i', 'o', 'n', 'L', 'i', 'm', 'i', 't', 's', 0,
    'F', 'i', 't', ':', ':', 'W', 'e', 'i', 'g', 'h', 't', 'i', 'n', 'g', 'M', 'e', 't', 'h', 'o', 'd', 0,
    'i', 'm', 'p', 'o', 'r', 't', 'O', 'd', 'f', 'S', 'p', 'r', 'e', 'a', 'd', 's', 'h', 'e', 'e', 't', 0,
    'a', 'x', 'i', 's', 'N', 'u', 'm', 'e', 'r', 'i', 'c', 'P', 'r', 'e', 'c', 'i', 's', 'i', 'o', 'n', 0,
    's', 'e', 't', 'P', 'a', 'r', 'a', 'm', 'e', 't', 'r', 'i', 'c', 'S', 'u', 'r', 'f', 'a', 'c', 'e', 0,
    's', 'e', 't', 'A', 'x', 'i', 's', 'N', 'u', 'm', 'e', 'r', 'i', 'c', 'F', 'o', 'r', 'm', 'a', 't', 0,
    's', 'e', 't', 'A', 'x', 'i', 's', 'L', 'a', 'b', 'e', 'l', 'R', 'o', 't', 'a', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'A', 'x', 'i', 's', 'T', 'i', 't', 'l', 'e', 'D', 'i', 's', 't', 'a', 'n', 'c', 'e', 0,
    's', 'e', 't', 'D', 'e', 'f', 'a', 'u', 'l', 't', 'C', 'o', 'n', 't', 'o', 'u', 'r', 'P', 'e', 'n', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 'V', 'a', 'l', 'u', 'e', 's', 'F', 'o', 'r', 'm', 'a', 't', 0,
    's', 'e', 't', 'D', 'e', 'c', 'i', 'm', 'a', 'l', 'S', 'e', 'p', 'a', 'r', 'a', 't', 'o', 'r', 's', 0,
    'T', 'a', 'b', 'l', 'e', ':', ':', 'N', 'u', 'm', 'e', 'r', 'i', 'c', 'F', 'o', 'r', 'm', 'a', 't', 0,
    'Q', 'L', 'i', 's', 't', '<', 'A', 'r', 'r', 'o', 'w', 'M', 'a', 'r', 'k', 'e', 'r', '*', '>', 0,
    's', 'e', 't', 'A', 'n', 'o', 'v', 'a', 'T', 'w', 'o', 'W', 'a', 'y', 'M', 'o', 'd', 'e', 'l', 0,
    'S', 't', 'a', 't', 'i', 's', 't', 'i', 'c', 'T', 'e', 's', 't', ':', ':', 'T', 'a', 'i', 'l', 0,
    'n', 'o', 'r', 'm', 'a', 'l', 'i', 'z', 'e', 'A', 'm', 'p', 'l', 'i', 't', 'u', 'd', 'e', 's', 0,
    's', 'h', 'o', 'w', 'F', 'l', 'o', 'o', 'r', 'P', 'r', 'o', 'j', 'e', 'c', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'E', 'q', 'u', 'a', 'l', 'S', 'i', 'z', 'e', 'd', 'L', 'a', 'y', 'e', 'r', 's', 0,
    's', 'e', 't', 'U', 's', 'e', 'M', 'a', 't', 'r', 'i', 'x', 'F', 'o', 'r', 'm', 'u', 'l', 'a', 0,
    'f', 'i', 'x', 'e', 'd', 'L', 'a', 'b', 'e', 'l', 's', 'P', 'o', 's', 'i', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 's', 'A', 'u', 't', 'o', 'F', 'o', 'r', 'm', 'a', 't', 0,
    's', 'e', 't', 'C', 'o', 'u', 'n', 't', 'e', 'r', 'C', 'l', 'o', 'c', 'k', 'w', 'i', 's', 'e', 0,
    's', 'e', 't', 'H', 'o', 'r', 'i', 'z', 'o', 'n', 't', 'a', 'l', 'O', 'f', 'f', 's', 'e', 't', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 's', 'C', 'o', 'l', 'u', 'm', 'n', 'N', 'a', 'm', 'e', 0,
    's', 'e', 't', 'S', 'k', 'i', 'p', 'S', 'y', 'm', 'b', 'o', 'l', 's', 'C', 'o', 'u', 'n', 't', 0,
    'i', 's', 'A', 'u', 't', 'o', 'U', 'p', 'd', 'a', 't', 'e', 'E', 'n', 'a', 'b', 'l', 'e', 'd', 0,
    's', 'e', 't', 'N', 'u', 'm', 'e', 'r', 'i', 'c', 'P', 'r', 'e', 'c', 'i', 's', 'i', 'o', 'n', 0,
    'f', 'i', 'r', 's', 't', 'S', 'e', 'l', 'e', 'c', 't', 'e', 'd', 'C', 'o', 'l', 'u', 'm', 'n', 0,
    's', 'e', 't', 'C', 'o', 'l', 'N', 'u', 'm', 'e', 'r', 'i', 'c', 'F', 'o', 'r', 'm', 'a', 't', 0,
    's', 'e', 't', 'L', 'o', 'w', 'e', 's', 's', 'P', 'a', 'r', 'a', 'm', 'e', 't', 'e', 'r', 0,
    's', 'e', 't', 'P', 'e', 'a', 'k', 'C', 'u', 'r', 'v', 'e', 's', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'O', 'u', 't', 'p', 'u', 't', 'P', 'r', 'e', 'c', 'i', 's', 'i', 'o', 'n', 0,
    'g', 'u', 'e', 's', 's', 'I', 'n', 'i', 't', 'i', 'a', 'l', 'V', 'a', 'l', 'u', 'e', 's', 0,
    's', 'e', 't', 'Z', 'A', 'x', 'i', 's', 'T', 'i', 'c', 'k', 'L', 'e', 'n', 'g', 't', 'h', 0,
    's', 'e', 't', 'Y', 'A', 'x', 'i', 's', 'T', 'i', 'c', 'k', 'L', 'e', 'n', 'g', 't', 'h', 0,
    's', 'e', 't', 'X', 'A', 'x', 'i', 's', 'T', 'i', 'c', 'k', 'L', 'e', 'n', 'g', 't', 'h', 0,
    's', 'e', 't', 'F', 'i', 'l', 'l', 'e', 'd', 'M', 'e', 's', 'h', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'H', 'i', 'd', 'd', 'e', 'n', 'L', 'i', 'n', 'e', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'W', 'a', 't', 'e', 'r', 'f', 'a', 'l', 'l', 'O', 'f', 'f', 's', 'e', 't', 0,
    's', 'e', 't', 'C', 'o', 'm', 'm', 'o', 'n', 'L', 'a', 'y', 'e', 'r', 'A', 'x', 'e', 's', 0,
    's', 'e', 't', 'L', 'a', 'y', 'e', 'r', 'C', 'a', 'n', 'v', 'a', 's', 'S', 'i', 'z', 'e', 0,
    's', 'e', 't', 'A', 'x', 'i', 's', 'L', 'a', 'b', 'e', 'l', 's', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'A', 'x', 'i', 's', 'T', 'i', 'c', 'k', 's', 'L', 'e', 'n', 'g', 't', 'h', 0,
    'Q', 'w', 't', 'P', 'l', 'o', 't', 'S', 'p', 'e', 'c', 't', 'r', 'o', 'g', 'r', 'a', 'm', 0,
    'B', 'o', 'x', 'C', 'u', 'r', 'v', 'e', ':', ':', 'B', 'o', 'x', 'S', 't', 'y', 'l', 'e', 0,
    'v', 'e', 'c', 't', 'o', 'r', 'E', 'n', 'd', 'Y', 'M', 'C', 'o', 'l', 'N', 'a', 'm', 'e', 0,
    'v', 'e', 'c', 't', 'o', 'r', 'E', 'n', 'd', 'X', 'A', 'C', 'o', 'l', 'N', 'a', 'm', 'e', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 'C', 'a', 't', 'e', 'g', 'o', 'r', 'i', 'e', 's', 0,
    'l', 'a', 'b', 'e', 'l', 's', 'V', 'a', 'l', 'u', 'e', 's', 'F', 'o', 'r', 'm', 'a', 't', 0,
    'l', 'a', 'b', 'e', 'l', 's', 'E', 'd', 'g', 'e', 'D', 'i', 's', 't', 'a', 'n', 'c', 'e', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 's', 'A', 'l', 'i', 'g', 'n', 'm', 'e', 'n', 't', 0,
    's', 'e', 't', 'R', 'a', 'i', 'n', 'b', 'o', 'w', 'C', 'o', 'l', 'o', 'r', 'M', 'a', 'p', 0,
    's', 'e', 't', 'D', 'e', 'f', 'a', 'u', 'l', 't', 'C', 'o', 'l', 'o', 'r', 'M', 'a', 'p', 0,
    'M', 'a', 't', 'r', 'i', 'x', ':', ':', 'I', 'm', 'p', 'o', 'r', 't', 'M', 'o', 'd', 'e', 0,
    'f', 'o', 'c', 'u', 's', 'P', 'r', 'e', 'v', 'i', 'o', 'u', 's', 'C', 'h', 'i', 'l', 'd', 0,
    'i', 'n', 's', 'e', 'r', 't', 'F', 'r', 'o', 'm', 'M', 'i', 'm', 'e', 'D', 'a', 't', 'a', 0,
    's', 'e', 't', 'B', 'a', 'c', 'k', 'g', 'r', 'o', 'u', 'n', 'd', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'V', 'i', 'e', 'w', 'p', 'o', 'r', 't', 'M', 'a', 'r', 'g', 'i', 'n', 's', 0,
    'f', 'o', 'c', 'u', 's', 'N', 'e', 'x', 't', 'P', 'r', 'e', 'v', 'C', 'h', 'i', 'l', 'd', 0,
    's', 'e', 't', 'P', 'a', 'r', 'a', 'm', 'e', 't', 'e', 'r', 'R', 'a', 'n', 'g', 'e', 0,
    'N', 'e', 'l', 'd', 'e', 'r', 'M', 'e', 'a', 'd', 'S', 'i', 'm', 'p', 'l', 'e', 'x', 0,
    'p', 'l', 'o', 't', 'I', 'm', 'a', 'g', 'e', 'P', 'r', 'o', 'f', 'i', 'l', 'e', 's', 0,
    'A', 'p', 'p', 'l', 'i', 'c', 'a', 't', 'i', 'o', 'n', 'W', 'i', 'n', 'd', 'o', 'w', 0,
    'a', 'x', 'i', 's', 'N', 'u', 'm', 'e', 'r', 'i', 'c', 'F', 'o', 'r', 'm', 'a', 't', 0,
    's', 'e', 't', 'W', 'i', 'r', 'e', 'f', 'r', 'a', 'm', 'e', 'S', 't', 'y', 'l', 'e', 0,
    's', 'h', 'o', 'w', 'F', 'l', 'o', 'o', 'r', 'I', 's', 'o', 'l', 'i', 'n', 'e', 's', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 's', 'D', 'i', 's', 't', 'a', 'n', 'c', 'e', 0,
    'G', 'r', 'a', 'p', 'h', '3', 'D', ':', ':', 'P', 'l', 'o', 't', 'T', 'y', 'p', 'e', 0,
    'r', 'e', 'm', 'o', 'v', 'e', 'A', 'c', 't', 'i', 'v', 'e', 'L', 'a', 'y', 'e', 'r', 0,
    's', 'e', 't', 'A', 'u', 't', 'o', 's', 'c', 'a', 'l', 'e', 'F', 'o', 'n', 't', 's', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'A', 'u', 't', 'o', 's', 'c', 'a', 'l', 'i', 'n', 'g', 0,
    's', 'e', 't', 'C', 'a', 'n', 'v', 'a', 's', 'G', 'e', 'o', 'm', 'e', 't', 'r', 'y', 0,
    's', 'e', 't', 'M', 'i', 'n', 'o', 'r', 'T', 'i', 'c', 'k', 's', 'T', 'y', 'p', 'e', 0,
    's', 'e', 't', 'M', 'a', 'j', 'o', 'r', 'T', 'i', 'c', 'k', 's', 'T', 'y', 'p', 'e', 0,
    'd', 'r', 'a', 'w', 'A', 'x', 'e', 's', 'B', 'a', 'c', 'k', 'b', 'o', 'n', 'e', 's', 0,
    'a', 'x', 'i', 's', 'T', 'i', 't', 'l', 'e', 'D', 'i', 's', 't', 'a', 'n', 'c', 'e', 0,
    's', 'e', 't', 'A', 'x', 'i', 's', 'T', 'i', 't', 'l', 'e', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'T', 'i', 't', 'l', 'e', 'A', 'l', 'i', 'g', 'n', 'm', 'e', 'n', 't', 0,
    's', 'e', 't', 'C', 'u', 'r', 'v', 'e', 'L', 'i', 'n', 'e', 'W', 'i', 'd', 't', 'h', 0,
    's', 'e', 't', 'C', 'u', 'r', 'v', 'e', 'L', 'i', 'n', 'e', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'C', 'u', 'r', 'v', 'e', 'L', 'i', 'n', 'e', 'C', 'o', 'l', 'o', 'r', 0,
    'V', 'e', 'r', 't', 'i', 'c', 'a', 'l', 'D', 'r', 'o', 'p', 'L', 'i', 'n', 'e', 's', 0,
    'G', 'r', 'a', 'p', 'h', ':', ':', 'T', 'i', 'c', 'k', 's', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'C', 'o', 'n', 't', 'o', 'u', 'r', 'L', 'i', 'n', 'e', 'P', 'e', 'n', 0,
    's', 'e', 't', 'C', 'u', 's', 't', 'o', 'm', 'C', 'o', 'l', 'o', 'r', 'M', 'a', 'p', 0,
    'w', 'h', 'i', 's', 'k', 'e', 'r', 's', 'R', 'a', 'n', 'g', 'e', 'T', 'y', 'p', 'e', 0,
    's', 't', 'a', 'n', 'd', 'a', 'r', 'd', 'D', 'e', 'v', 'i', 'a', 't', 'i', 'o', 'n', 0,
    'd', 'r', 'a', 'w', 'T', 'h', 'r', 'o', 'u', 'g', 'h', 'S', 'y', 'm', 'b', 'o', 'l', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 's', 'W', 'h', 'i', 't', 'e', 'O', 'u', 't', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 's', 'R', 'o', 't', 'a', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'F', 'r', 'a', 'm', 'e', 'L', 'i', 'n', 'e', 'S', 't', 'y', 'l', 'e', 0,
    'F', 'r', 'a', 'm', 'e', 'W', 'i', 'd', 'g', 'e', 't', ':', ':', 'U', 'n', 'i', 't', 0,
    'e', 'x', 'p', 'o', 'r', 't', 'R', 'a', 's', 't', 'e', 'r', 'I', 'm', 'a', 'g', 'e', 0,
    's', 'e', 't', 'H', 'e', 'a', 'd', 'e', 'r', 'V', 'i', 'e', 'w', 'T', 'y', 'p', 'e', 0,
    'Q', 'w', 't', 'L', 'i', 'n', 'e', 'a', 'r', 'C', 'o', 'l', 'o', 'r', 'M', 'a', 'p', 0,
    's', 'e', 't', 'C', 'o', 'l', 'M', 'o', 'n', 't', 'h', 'F', 'o', 'r', 'm', 'a', 't', 0,
    's', 'e', 't', 'R', 'e', 'a', 'd', 'O', 'n', 'l', 'y', 'C', 'o', 'l', 'u', 'm', 'n', 0,
    'T', 'a', 'b', 'l', 'e', ':', ':', 'I', 'm', 'p', 'o', 'r', 't', 'M', 'o', 'd', 'e', 0,
    'd', 'e', 's', 't', 'r', 'o', 'y', 'S', 'u', 'b', 'W', 'i', 'n', 'd', 'o', 'w', 's', 0,
    'r', 'e', 's', 'e', 't', 'I', 'n', 'p', 'u', 't', 'C', 'o', 'n', 't', 'e', 'x', 't', 0,
    'm', 'o', 'u', 's', 'e', 'R', 'e', 'l', 'e', 'a', 's', 'e', 'E', 'v', 'e', 'n', 't', 0,
    's', 'e', 'n', 'd', 'e', 'r', 'S', 'i', 'g', 'n', 'a', 'l', 'I', 'n', 'd', 'e', 'x', 0,
    's', 'h', 'i', 'f', 't', 'F', 'r', 'e', 'q', 'u', 'e', 'n', 'c', 'i', 'e', 's', 0,
    's', 'e', 't', 'D', 'a', 't', 'a', 'F', 'r', 'o', 'm', 'C', 'u', 'r', 'v', 'e', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'P', 'e', 'a', 'k', 'C', 'u', 'r', 'v', 'e', 's', 0,
    'c', 'o', 'v', 'a', 'r', 'i', 'a', 'n', 'c', 'e', 'M', 'a', 't', 'r', 'i', 'x', 0,
    'g', 'e', 'n', 'e', 'r', 'a', 't', 'e', 'F', 'u', 'n', 'c', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'I', 'n', 'i', 't', 'i', 'a', 'l', 'V', 'a', 'l', 'u', 'e', 's', 0,
    's', 'e', 't', 'D', 'a', 't', 'a', 'F', 'r', 'o', 'm', 'T', 'a', 'b', 'l', 'e', 0,
    's', 'e', 't', 'W', 'e', 'i', 'g', 'h', 't', 'i', 'n', 'g', 'D', 'a', 't', 'a', 0,
    's', 'e', 't', 'M', 'e', 's', 'h', 'L', 'i', 'n', 'e', 'W', 'i', 'd', 't', 'h', 0,
    'b', 'a', 'c', 'k', 'g', 'r', 'o', 'u', 'n', 'd', 'P', 'i', 'x', 'm', 'a', 'p', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'A', 'x', 'i', 's', 'L', 'a', 'b', 'e', 'l', 's', 0,
    's', 'e', 't', 'A', 'x', 'e', 's', 'L', 'i', 'n', 'e', 'w', 'i', 'd', 't', 'h', 0,
    's', 'e', 't', 'A', 'x', 'i', 's', 'T', 'i', 't', 'l', 'e', 'F', 'o', 'n', 't', 0,
    'a', 'd', 'd', 'P', 'o', 'l', 'a', 'r', 'F', 'u', 'n', 'c', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'I', 'n', 'd', 'e', 'x', 'e', 'd', 'C', 'o', 'l', 'o', 'r', 's', 0,
    'c', 'h', 'a', 'n', 'g', 'e', 'C', 'u', 'r', 'v', 'e', 'I', 'n', 'd', 'e', 'x', 0,
    'G', 'r', 'a', 'p', 'h', ':', ':', 'C', 'u', 'r', 'v', 'e', 'T', 'y', 'p', 'e', 0,
    'y', 'Z', 'e', 'r', 'o', 'L', 'i', 'n', 'e', 'E', 'n', 'a', 'b', 'l', 'e', 'd', 0,
    'x', 'Z', 'e', 'r', 'o', 'L', 'i', 'n', 'e', 'E', 'n', 'a', 'b', 'l', 'e', 'd', 0,
    'u', 's', 'e', 'M', 'a', 't', 'r', 'i', 'x', 'F', 'o', 'r', 'm', 'u', 'l', 'a', 0,
    's', 'e', 't', 'C', 'o', 'l', 'o', 'r', 'B', 'a', 'r', 'W', 'i', 'd', 't', 'h', 0,
    's', 'e', 't', 'C', 'o', 'n', 't', 'o', 'u', 'r', 'L', 'e', 'v', 'e', 'l', 's', 0,
    's', 'e', 't', 'W', 'h', 'i', 's', 'k', 'e', 'r', 's', 'R', 'a', 'n', 'g', 'e', 0,
    'l', 'a', 'b', 'e', 'l', 's', 'A', 'u', 't', 'o', 'F', 'o', 'r', 'm', 'a', 't', 0,
    'c', 'o', 'u', 'n', 't', 'e', 'r', 'C', 'l', 'o', 'c', 'k', 'w', 'i', 's', 'e', 0,
    'l', 'a', 'b', 'e', 'l', 's', 'C', 'o', 'l', 'u', 'm', 'n', 'N', 'a', 'm', 'e', 0,
    's', 'k', 'i', 'p', 'S', 'y', 'm', 'b', 'o', 'l', 's', 'C', 'o', 'u', 'n', 't', 0,
    'Q', 'w', 't', 'S', 'y', 'm', 'b', 'o', 'l', ':', ':', 'S', 't', 'y', 'l', 'e', 0,
    'f', 'l', 'i', 'p', 'H', 'o', 'r', 'i', 'z', 'o', 'n', 't', 'a', 'l', 'l', 'y', 0,
    'M', 'a', 't', 'r', 'i', 'x', ':', ':', 'V', 'i', 'e', 'w', 'T', 'y', 'p', 'e', 0,
    's', 'e', 't', 'C', 'o', 'l', 'o', 'r', 'I', 'n', 't', 'e', 'r', 'v', 'a', 'l', 0,
    's', 'e', 't', 'C', 'o', 'l', 'T', 'i', 'm', 'e', 'F', 'o', 'r', 'm', 'a', 't', 0,
    's', 'e', 't', 'C', 'o', 'l', 'D', 'a', 't', 'e', 'F', 'o', 'r', 'm', 'a', 't', 0,
    's', 'e', 't', 'C', 'o', 'l', 'T', 'e', 'x', 't', 'F', 'o', 'r', 'm', 'a', 't', 0,
    's', 'e', 't', 'C', 'a', 'p', 't', 'i', 'o', 'n', 'P', 'o', 'l', 'i', 'c', 'y', 0,
    'd', 'e', 's', 't', 'r', 'o', 'y', 'O', 'l', 'd', 'W', 'i', 'n', 'd', 'o', 'w', 0,
    'i', 'n', 'i', 't', 'i', 'a', 'l', 'i', 'z', 'e', 'W', 'i', 'n', 'd', 'o', 'w', 0,
    'u', 'p', 'd', 'a', 't', 'e', 'M', 'i', 'c', 'r', 'o', 'F', 'o', 'c', 'u', 's', 0,
    's', 'c', 'r', 'o', 'l', 'l', 'C', 'o', 'n', 't', 'e', 'n', 't', 's', 'B', 'y', 0,
    'c', 'o', 'n', 't', 'e', 'x', 't', 'M', 'e', 'n', 'u', 'E', 'v', 'e', 'n', 't', 0,
    'i', 'n', 'p', 'u', 't', 'M', 'e', 't', 'h', 'o', 'd', 'E', 'v', 'e', 'n', 't', 0,
    'i', 'n', 'p', 'u', 't', 'M', 'e', 't', 'h', 'o', 'd', 'Q', 'u', 'e', 'r', 'y', 0,
    'h', 'o', 'r', 'i', 'z', 'o', 'n', 't', 'a', 'l', 'O', 'f', 'f', 's', 'e', 't', 0,
    'd', 'i', 's', 'c', 'o', 'n', 'n', 'e', 'c', 't', 'N', 'o', 't', 'i', 'f', 'y', 0,
    'P', 'y', 't', 'h', 'o', 'n', 'S', 'c', 'r', 'i', 'p', 't', 'i', 'n', 'g', 0,
    'S', 'h', 'a', 'p', 'i', 'r', 'o', 'W', 'i', 'l', 'k', 'T', 'e', 's', 't', 0,
    's', 'e', 't', 'P', 'o', 'l', 'y', 'n', 'o', 'm', 'O', 'r', 'd', 'e', 'r', 0,
    's', 'e', 't', 'S', 'm', 'o', 'o', 't', 'h', 'P', 'o', 'i', 'n', 't', 's', 0,
    'D', 'i', 'f', 'f', 'e', 'r', 'e', 'n', 't', 'i', 'a', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'O', 'u', 't', 'p', 'u', 't', 'P', 'o', 'i', 'n', 't', 's', 0,
    'g', 'e', 'n', 'e', 'r', 'a', 't', 'e', 'F', 'o', 'r', 'm', 'u', 'l', 'a', 0,
    'p', 'a', 'r', 'a', 'm', 'e', 't', 'e', 'r', 's', 'T', 'a', 'b', 'l', 'e', 0,
    'a', 'd', 'j', 'u', 's', 't', 'e', 'd', 'R', 'S', 'q', 'u', 'a', 'r', 'e', 0,
    's', 'e', 't', 'I', 'n', 'i', 't', 'i', 'a', 'l', 'V', 'a', 'l', 'u', 'e', 0,
    's', 'e', 't', 'C', 'r', 'o', 's', 's', 'O', 'p', 't', 'i', 'o', 'n', 's', 0,
    's', 'e', 't', 'P', 'o', 'l', 'y', 'g', 'o', 'n', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'D', 'a', 't', 'a', 'C', 'o', 'l', 'o', 'r', 'M', 'a', 'p', 0,
    's', 'e', 't', 'N', 'u', 'm', 'b', 'e', 'r', 's', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'h', 'o', 'w', 'L', 'i', 'n', 'e', 'N', 'u', 'm', 'b', 'e', 'r', 's', 0,
    's', 'e', 't', 'A', 'n', 't', 'i', 'a', 'l', 'i', 'a', 's', 'i', 'n', 'g', 0,
    'p', 'l', 'o', 't', 'S', 'p', 'e', 'c', 't', 'r', 'o', 'g', 'r', 'a', 'm', 0,
    'd', 'e', 'l', 'e', 't', 'e', 'F', 'i', 't', 'C', 'u', 'r', 'v', 'e', 's', 0,
    'H', 'o', 'r', 'i', 'z', 'o', 'n', 't', 'a', 'l', 'S', 't', 'e', 'p', 's', 0,
    's', 'e', 't', 'Y', 'Z', 'e', 'r', 'o', 'L', 'i', 'n', 'e', 'P', 'e', 'n', 0,
    's', 'e', 't', 'X', 'Z', 'e', 'r', 'o', 'L', 'i', 'n', 'e', 'P', 'e', 'n', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'Z', 'e', 'r', 'o', 'L', 'i', 'n', 'e', 'Y', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'Z', 'e', 'r', 'o', 'L', 'i', 'n', 'e', 'X', 0,
    's', 'e', 't', 'L', 'e', 'v', 'e', 'l', 's', 'N', 'u', 'm', 'b', 'e', 'r', 0,
    'B', 'o', 'x', 'C', 'u', 'r', 'v', 'e', ':', ':', 'R', 'a', 'n', 'g', 'e', 0,
    'f', 'i', 'l', 'l', 'e', 'd', 'A', 'r', 'r', 'o', 'w', 'H', 'e', 'a', 'd', 0,
    'l', 'a', 'b', 'e', 'l', 'C', 'a', 't', 'e', 'g', 'o', 'r', 'i', 'e', 's', 0,
    's', 'e', 't', 'S', 't', 'a', 'r', 't', 'A', 'z', 'i', 'm', 'u', 't', 'h', 0,
    'r', 'e', 'm', 'o', 'v', 'e', 'E', 'r', 'r', 'o', 'r', 'B', 'a', 'r', 's', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 's', 'O', 'f', 'f', 's', 'e', 't', 0,
    'l', 'a', 'b', 'e', 'l', 's', 'A', 'l', 'i', 'g', 'n', 'm', 'e', 'n', 't', 0,
    'p', 'a', 'r', 'a', 'm', 'e', 't', 'e', 'r', 's', 'C', 'o', 'u', 'n', 't', 0,
    's', 'e', 't', 'F', 'u', 'n', 'c', 't', 'i', 'o', 'n', 'T', 'y', 'p', 'e', 0,
    'R', 'e', 'c', 't', 'a', 'n', 'g', 'l', 'e', 'W', 'i', 'd', 'g', 'e', 't', 0,
    'n', 'u', 'm', 'S', 'e', 'l', 'e', 'c', 't', 'e', 'd', 'R', 'o', 'w', 's', 0,
    's', 'e', 't', 'C', 'o', 'l', 'D', 'a', 'y', 'F', 'o', 'r', 'm', 'a', 't', 0,
    's', 'e', 't', 'R', 'a', 'n', 'd', 'o', 'm', 'V', 'a', 'l', 'u', 'e', 's', 0,
    's', 'e', 't', 'T', 'a', 'b', 'S', 't', 'o', 'p', 'W', 'i', 'd', 't', 'h', 0,
    'b', 'a', 'c', 'k', 'g', 'r', 'o', 'u', 'n', 'd', 'C', 'o', 'l', 'o', 'r', 0,
    'm', 'i', 'n', 'i', 'm', 'u', 'm', 'S', 'i', 'z', 'e', 'H', 'i', 'n', 't', 0,
    'm', 'o', 'u', 's', 'e', 'P', 'r', 'e', 's', 's', 'E', 'v', 'e', 'n', 't', 0,
    'k', 'e', 'y', 'R', 'e', 'l', 'e', 'a', 's', 'e', 'E', 'v', 'e', 'n', 't', 0,
    'Q', 'L', 'i', 's', 't', '<', 'F', 'o', 'l', 'd', 'e', 'r', '*', '>', 0,
    's', 'h', 'o', 'w', 'R', 'e', 's', 'u', 'l', 't', 's', 'L', 'o', 'g', 0,
    'E', 'x', 'p', 'o', 'n', 'e', 'n', 't', 'i', 'a', 'l', 'F', 'i', 't', 0,
    'F', 'i', 't', ':', ':', 'A', 'l', 'g', 'o', 'r', 'i', 't', 'h', 'm', 0,
    'i', 'm', 'p', 'o', 'r', 't', 'W', 'a', 'v', 'e', 'F', 'i', 'l', 'e', 0,
    's', 'e', 't', 'P', 'r', 'e', 'f', 'e', 'r', 'e', 'n', 'c', 'e', 's', 0,
    's', 'a', 'v', 'e', 'A', 's', 'T', 'e', 'm', 'p', 'l', 'a', 't', 'e', 0,
    'f', 'i', 'n', 'd', 'B', 'e', 's', 't', 'L', 'a', 'y', 'o', 'u', 't', 0,
    's', 'e', 't', 'C', 'o', 'n', 'e', 'O', 'p', 't', 'i', 'o', 'n', 's', 0,
    'l', 'i', 'n', 'k', 'X', 'L', 'a', 'y', 'e', 'r', 'A', 'x', 'e', 's', 0,
    's', 'e', 't', 'A', 'l', 'i', 'g', 'n', 'P', 'o', 'l', 'i', 'c', 'y', 0,
    's', 'e', 't', 'A', 'c', 't', 'i', 'v', 'e', 'L', 'a', 'y', 'e', 'r', 0,
    's', 'e', 't', 'C', 'a', 'n', 'v', 'a', 's', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'C', 'a', 'n', 'v', 'a', 's', 'F', 'r', 'a', 'm', 'e', 0,
    's', 'e', 't', 'T', 'i', 'c', 'k', 's', 'L', 'e', 'n', 'g', 't', 'h', 0,
    'H', 'o', 'r', 'i', 'z', 'o', 'n', 't', 'a', 'l', 'B', 'a', 'r', 's', 0,
    's', 'e', 't', 'C', 'o', 'l', 'o', 'r', 'M', 'a', 'p', 'P', 'e', 'n', 0,
    's', 'h', 'o', 'w', 'C', 'o', 'l', 'o', 'r', 'S', 'c', 'a', 'l', 'e', 0,
    'c', 'o', 'l', 'o', 'r', 'S', 'c', 'a', 'l', 'e', 'A', 'x', 'i', 's', 0,
    's', 'e', 't', 'D', 'i', 's', 'p', 'l', 'a', 'y', 'M', 'o', 'd', 'e', 0,
    's', 'e', 't', 'A', 'u', 't', 'o', 'B', 'i', 'n', 'n', 'i', 'n', 'g', 0,
    's', 'e', 't', 'V', 'e', 'c', 't', 'o', 'r', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'M', 'a', 's', 't', 'e', 'r', 'C', 'u', 'r', 'v', 'e', 0,
    'E', 'r', 'r', 'o', 'r', 'B', 'a', 'r', 's', 'C', 'u', 'r', 'v', 'e', 0,
    'c', 'l', 'e', 'a', 'r', 'E', 'r', 'r', 'o', 'r', 'B', 'a', 'r', 's', 0,
    'l', 'a', 'b', 'e', 'l', 's', 'W', 'h', 'i', 't', 'e', 'O', 'u', 't', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 's', 'C', 'o', 'l', 'o', 'r', 0,
    'l', 'a', 'b', 'e', 'l', 's', 'R', 'o', 't', 'a', 't', 'i', 'o', 'n', 0,
    'p', 'a', 'r', 'a', 'm', 'e', 't', 'e', 'r', 'V', 'a', 'l', 'u', 'e', 0,
    'f', 'r', 'a', 'm', 'e', 'L', 'i', 'n', 'e', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'O', 'r', 'i', 'g', 'i', 'n', 'C', 'o', 'o', 'r', 'd', 0,
    'd', 'r', 'a', 'w', 'S', 't', 'a', 'r', 't', 'A', 'r', 'r', 'o', 'w', 0,
    'f', 'l', 'i', 'p', 'V', 'e', 'r', 't', 'i', 'c', 'a', 'l', 'l', 'y', 0,
    's', 'e', 't', 'C', 'o', 'o', 'r', 'd', 'i', 'n', 'a', 't', 'e', 's', 0,
    's', 'e', 'l', 'e', 'c', 't', 'e', 'd', 'C', 'o', 'l', 'u', 'm', 'n', 0,
    's', 'e', 't', 'S', 'e', 'l', 'e', 'c', 't', 'e', 'd', 'C', 'o', 'l', 0,
    's', 'h', 'o', 'w', 'A', 'l', 'l', 'C', 'o', 'l', 'u', 'm', 'n', 's', 0,
    's', 'e', 't', 'W', 'i', 'n', 'd', 'o', 'w', 'L', 'a', 'b', 'e', 'l', 0,
    'i', 'n', 's', 'e', 'r', 't', 'F', 'u', 'n', 'c', 't', 'i', 'o', 'n', 0,
    'l', 'a', 'n', 'g', 'u', 'a', 'g', 'e', 'C', 'h', 'a', 'n', 'g', 'e', 0,
    'f', 'o', 'c', 'u', 's', 'N', 'e', 'x', 't', 'C', 'h', 'i', 'l', 'd', 0,
    's', 'e', 't', 'C', 'o', 'l', 'u', 'm', 'n', 'W', 'i', 'd', 't', 'h', 0,
    'h', 'e', 'i', 'g', 'h', 't', 'F', 'o', 'r', 'W', 'i', 'd', 't', 'h', 0,
    'd', 'r', 'a', 'g', 'L', 'e', 'a', 'v', 'e', 'E', 'v', 'e', 'n', 't', 0,
    'd', 'r', 'a', 'g', 'E', 'n', 't', 'e', 'r', 'E', 'v', 'e', 'n', 't', 0,
    'm', 'o', 'u', 's', 'e', 'M', 'o', 'v', 'e', 'E', 'v', 'e', 'n', 't', 0,
    'p', 'a', 'r', 'a', 'm', 'e', 't', 'e', 'r', 'N', 'a', 'm', 'e', 's', 0,
    'Q', 'L', 'i', 's', 't', '<', 'G', 'r', 'a', 'p', 'h', '*', '>', 0,
    'a', 'p', 'p', 'e', 'n', 'd', 'L', 'o', 'g', 'I', 'n', 'f', 'o', 0,
    'C', 'h', 'i', 'S', 'q', 'u', 'a', 'r', 'e', 'T', 'e', 's', 't', 0,
    'S', 't', 'a', 't', 'i', 's', 't', 'i', 'c', 'T', 'e', 's', 't', 0,
    's', 't', 'a', 'n', 'd', 'a', 'r', 'd', 'E', 'r', 'r', 'o', 'r', 0,
    'D', 'e', 'c', 'o', 'n', 'v', 'o', 'l', 'u', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'I', 'n', 'v', 'e', 'r', 's', 'e', 'F', 'F', 'T', 0,
    's', 'e', 't', 'F', 'i', 'l', 't', 'e', 'r', 'T', 'y', 'p', 'e', 0,
    'S', 'a', 'v', 'i', 't', 'z', 'k', 'y', 'G', 'o', 'l', 'a', 'y', 0,
    'I', 'n', 't', 'e', 'r', 'p', 'o', 'l', 'a', 't', 'i', 'o', 'n', 0,
    'P', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', 'F', 'i', 't', 0,
    'n', 'u', 'm', 'P', 'a', 'r', 'a', 'm', 'e', 't', 'e', 'r', 's', 0,
    'r', 'e', 's', 'u', 'l', 't', 'F', 'o', 'r', 'm', 'u', 'l', 'a', 0,
    'm', 'a', 't', 'r', 'i', 'x', 'T', 'o', 'T', 'a', 'b', 'l', 'e', 0,
    't', 'a', 'b', 'l', 'e', 'T', 'o', 'M', 'a', 't', 'r', 'i', 'x', 0,
    's', 'a', 'v', 'e', 'P', 'r', 'o', 'j', 'e', 'c', 't', 'A', 's', 0,
    's', 'e', 't', 'W', 'i', 'n', 'd', 'o', 'w', 'N', 'a', 'm', 'e', 0,
    'a', 'p', 'p', 'e', 'n', 'd', 'P', 'r', 'o', 'j', 'e', 'c', 't', 0,
    'w', 'a', 't', 'e', 'r', 'f', 'a', 'l', 'l', 'P', 'l', 'o', 't', 0,
    'c', 'u', 'r', 'r', 'e', 'n', 't', 'M', 'a', 't', 'r', 'i', 'x', 0,
    's', 'e', 't', 'Z', 'A', 'x', 'i', 's', 'L', 'a', 'b', 'e', 'l', 0,
    's', 'e', 't', 'Y', 'A', 'x', 'i', 's', 'L', 'a', 'b', 'e', 'l', 0,
    's', 'e', 't', 'X', 'A', 'x', 'i', 's', 'L', 'a', 'b', 'e', 'l', 0,
    's', 'e', 't', 'F', 'i', 'l', 'l', 'e', 'd', 'B', 'a', 'r', 's', 0,
    's', 'e', 't', 'D', 'o', 't', 'O', 'p', 't', 'i', 'o', 'n', 's', 0,
    's', 'e', 't', 'C', 'r', 'o', 's', 's', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'E', 'm', 'p', 't', 'y', 'F', 'l', 'o', 'o', 'r', 0,
    's', 'e', 't', 'D', 'a', 't', 'a', 'C', 'o', 'l', 'o', 'r', 's', 0,
    's', 'e', 't', 'O', 'r', 't', 'h', 'o', 'g', 'o', 'n', 'a', 'l', 0,
    'c', 'u', 'r', 'r', 'e', 'n', 't', 'E', 'd', 'i', 't', 'o', 'r', 0,
    'a', 'r', 'r', 'a', 'n', 'g', 'e', 'L', 'a', 'y', 'e', 'r', 's', 0,
    's', 'e', 't', 'A', 'l', 'i', 'g', 'n', 'e', 'm', 'e', 'n', 't', 0,
    'A', 'l', 'i', 'g', 'n', 'C', 'a', 'n', 'v', 'a', 's', 'e', 's', 0,
    's', 'e', 't', 'C', 'a', 'n', 'v', 'a', 's', 'S', 'i', 'z', 'e', 0,
    's', 'e', 't', 'T', 'i', 't', 'l', 'e', 'C', 'o', 'l', 'o', 'r', 0,
    'f', 'u', 'n', 'c', 't', 'i', 'o', 'n', 'C', 'u', 'r', 'v', 'e', 0,
    'V', 'e', 'r', 't', 'i', 'c', 'a', 'l', 'S', 't', 'e', 'p', 's', 0,
    'c', 'o', 'l', 'o', 'r', 'B', 'a', 'r', 'W', 'i', 'd', 't', 'h', 0,
    'h', 'a', 's', 'C', 'o', 'l', 'o', 'r', 'S', 'c', 'a', 'l', 'e', 0,
    'w', 'h', 'i', 's', 'k', 'e', 'r', 's', 'R', 'a', 'n', 'g', 'e', 0,
    's', 'e', 't', 'F', 'i', 'r', 's', 't', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'B', 'r', 'u', 's', 'h', 'S', 't', 'y', 'l', 'e', 0,
    'd', 'r', 'a', 'w', 'M', 'i', 'n', 'u', 's', 'S', 'i', 'd', 'e', 0,
    't', 'h', 'r', 'o', 'u', 'g', 'h', 'S', 'y', 'm', 'b', 'o', 'l', 0,
    'e', 'r', 'r', 'o', 'r', 'B', 'a', 'r', 's', 'L', 'i', 's', 't', 0,
    's', 'e', 't', 'L', 'a', 'b', 'e', 'l', 's', 'F', 'o', 'n', 't', 0,
    'l', 'a', 'b', 'e', 'l', 's', 'Y', 'O', 'f', 'f', 's', 'e', 't', 0,
    'l', 'a', 'b', 'e', 'l', 's', 'X', 'O', 'f', 'f', 's', 'e', 't', 0,
    'p', 'a', 'r', 'a', 'm', 'e', 't', 'e', 'r', 'N', 'a', 'm', 'e', 0,
    'F', 'u', 'n', 'c', 't', 'i', 'o', 'n', 'C', 'u', 'r', 'v', 'e', 0,
    'E', 'l', 'l', 'i', 'p', 's', 'e', 'W', 'i', 'd', 'g', 'e', 't', 0,
    's', 'e', 't', 'A', 'u', 't', 'o', 'U', 'p', 'd', 'a', 't', 'e', 0,
    's', 'e', 't', 'F', 'r', 'a', 'm', 'e', 'W', 'i', 'd', 't', 'h', 0,
    's', 'e', 't', 'F', 'r', 'a', 'm', 'e', 'C', 'o', 'l', 'o', 'r', 0,
    'f', 'i', 'l', 'l', 'A', 'r', 'r', 'o', 'w', 'H', 'e', 'a', 'd', 0,
    's', 'e', 't', 'H', 'e', 'a', 'd', 'L', 'e', 'n', 'g', 't', 'h', 0,
    's', 'e', 't', 'D', 'i', 'm', 'e', 'n', 's', 'i', 'o', 'n', 's', 0,
    'i', 's', 'C', 'o', 'l', 'S', 'e', 'l', 'e', 'c', 't', 'e', 'd', 0,
    's', 'e', 't', 'C', 'o', 'l', 'u', 'm', 'n', 'R', 'o', 'l', 'e', 0,
    'n', 'o', 't', 'i', 'f', 'y', 'C', 'h', 'a', 'n', 'g', 'e', 's', 0,
    'a', 'p', 'p', 'e', 'n', 'd', 'R', 'o', 'w', 'D', 'a', 't', 'a', 0,
    'c', 'a', 'p', 't', 'i', 'o', 'n', 'P', 'o', 'l', 'i', 'c', 'y', 0,
    'c', 'h', 'a', 'n', 'g', 'e', 'd', 'S', 'i', 'g', 'n', 'a', 'l', 0,
    'p', 'a', 'l', 'e', 't', 't', 'e', 'C', 'h', 'a', 'n', 'g', 'e', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'd', 'C', 'h', 'a', 'n', 'g', 'e', 0,
    'd', 'e', 's', 't', 'r', 'o', 'y', 'W', 'i', 'n', 'd', 'o', 'w', 0,
    's', 'e', 't', 'R', 'e', 's', 'o', 'l', 'u', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'P', 'a', 'r', 'a', 'm', 'e', 't', 'e', 'r', 's', 0,
    'i', 's', 'R', 'o', 'w', 'S', 'e', 'l', 'e', 'c', 't', 'e', 'd', 0,
    's', 'e', 't', 'F', 'r', 'a', 'm', 'e', 'S', 't', 'y', 'l', 'e', 0,
    't', 'h', 'r', 'e', 's', 'h', 'o', 'l', 'd', 'T', 'i', 'm', 'e', 0,
    's', 'e', 't', 'u', 'p', 'V', 'i', 'e', 'w', 'p', 'o', 'r', 't', 0,
    'd', 'r', 'a', 'g', 'M', 'o', 'v', 'e', 'E', 'v', 'e', 'n', 't', 0,
    'v', 'i', 'e', 'w', 'p', 'o', 'r', 't', 'E', 'v', 'e', 'n', 't', 0,
    'f', 'o', 'c', 'u', 's', 'O', 'u', 't', 'E', 'v', 'e', 'n', 't', 0,
    'k', 'e', 'y', 'P', 'r', 'e', 's', 's', 'E', 'v', 'e', 'n', 't', 0,
    'i', 'n', 's', 'e', 'r', 't', 'C', 'o', 'l', 'u', 'm', 'n', 's', 0,
    'c', 'l', 'e', 'a', 'r', 'L', 'o', 'g', 'I', 'n', 'f', 'o', 0,
    'P', 'y', 't', 'h', 'o', 'n', 'S', 'c', 'r', 'i', 'p', 't', 0,
    's', 'e', 't', 'T', 'e', 's', 't', 'V', 'a', 'l', 'u', 'e', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'O', 'f', 'f', 's', 'e', 't', 0,
    'S', 'm', 'o', 'o', 't', 'h', 'F', 'i', 'l', 't', 'e', 'r', 0,
    's', 'e', 't', 'T', 'o', 'l', 'e', 'r', 'a', 'n', 'c', 'e', 0,
    'M', 'u', 'l', 't', 'i', 'P', 'e', 'a', 'k', 'F', 'i', 't', 0,
    'N', 'o', 'n', 'L', 'i', 'n', 'e', 'a', 'r', 'F', 'i', 't', 0,
    'S', 'i', 'g', 'm', 'o', 'i', 'd', 'a', 'l', 'F', 'i', 't', 0,
    's', 'e', 't', 'A', 'l', 'g', 'o', 'r', 'i', 't', 'h', 'm', 0,
    'I', 'n', 's', 't', 'r', 'u', 'm', 'e', 'n', 't', 'a', 'l', 0,
    'i', 'n', 'f', 'o', 'L', 'i', 'n', 'e', 'E', 'd', 'i', 't', 0,
    'o', 'p', 'e', 'n', 'T', 'e', 'm', 'p', 'l', 'a', 't', 'e', 0,
    'c', 'h', 'a', 'n', 'g', 'e', 'F', 'o', 'l', 'd', 'e', 'r', 0,
    'd', 'e', 'l', 'e', 't', 'e', 'F', 'o', 'l', 'd', 'e', 'r', 0,
    'a', 'c', 't', 'i', 'v', 'e', 'F', 'o', 'l', 'd', 'e', 'r', 0,
    'c', 'u', 'r', 'r', 'e', 'n', 't', 'G', 'r', 'a', 'p', 'h', 0,
    's', 'e', 't', 'B', 'a', 'r', 'R', 'a', 'd', 'i', 'u', 's', 0,
    's', 'e', 't', 'C', 'o', 'n', 'e', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'F', 'r', 'o', 'n', 't', 'G', 'r', 'i', 'd', 0,
    's', 'e', 't', 'F', 'l', 'o', 'o', 'r', 'G', 'r', 'i', 'd', 0,
    's', 'e', 't', 'R', 'i', 'g', 'h', 't', 'G', 'r', 'i', 'd', 0,
    'c', 'o', 'l', 'o', 'r', 'M', 'a', 'p', 'F', 'i', 'l', 'e', 0,
    's', 'e', 't', 'G', 'r', 'i', 'd', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'A', 'x', 'e', 's', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'M', 'e', 's', 'h', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'N', 'u', 'm', 'L', 'a', 'y', 'e', 'r', 's', 0,
    's', 'e', 't', 'C', 'u', 'r', 'v', 'e', 'A', 'x', 'e', 's', 0,
    's', 'e', 't', 'A', 'u', 't', 'o', 'S', 'c', 'a', 'l', 'e', 0,
    's', 'e', 't', 'A', 'x', 'i', 's', 'T', 'i', 't', 'l', 'e', 0,
    's', 'e', 't', 'A', 'x', 'i', 's', 'C', 'o', 'l', 'o', 'r', 0,
    'a', 'd', 'd', 'T', 'i', 'm', 'e', 'S', 't', 'a', 'm', 'p', 0,
    'r', 'e', 'm', 'o', 'v', 'e', 'L', 'e', 'g', 'e', 'n', 'd', 0,
    's', 'e', 't', 'T', 'i', 't', 'l', 'e', 'F', 'o', 'n', 't', 0,
    'a', 'd', 'd', 'H', 'i', 's', 't', 'o', 'g', 'r', 'a', 'm', 0,
    'a', 'd', 'd', 'E', 'r', 'r', 'o', 'r', 'B', 'a', 'r', 's', 0,
    'V', 'e', 'r', 't', 'i', 'c', 'a', 'l', 'B', 'a', 'r', 's', 0,
    'G', 'r', 'a', 'p', 'h', ':', ':', 'S', 'c', 'a', 'l', 'e', 0,
    'y', 'Z', 'e', 'r', 'o', 'L', 'i', 'n', 'e', 'P', 'e', 'n', 0,
    'x', 'Z', 'e', 'r', 'o', 'L', 'i', 'n', 'e', 'P', 'e', 'n', 0,
    'b', 'o', 'x', 'R', 'a', 'n', 'g', 'e', 'T', 'y', 'p', 'e', 0,
    's', 'e', 't', 'M', 'e', 'a', 'n', 'S', 't', 'y', 'l', 'e', 0,
    'Q', 'w', 't', 'H', 'i', 's', 't', 'o', 'g', 'r', 'a', 'm', 0,
    's', 'e', 't', 'V', 'e', 'c', 't', 'o', 'r', 'P', 'e', 'n', 0,
    's', 'e', 't', 'V', 'e', 'c', 't', 'o', 'r', 'E', 'n', 'd', 0,
    's', 't', 'a', 'r', 't', 'A', 'z', 'i', 'm', 'u', 't', 'h', 0,
    's', 'e', 't', 'T', 'h', 'i', 'c', 'k', 'n', 'e', 's', 's', 0,
    's', 'e', 't', 'V', 'i', 'e', 'w', 'A', 'n', 'g', 'l', 'e', 0,
    'd', 'r', 'a', 'w', 'P', 'l', 'u', 's', 'S', 'i', 'd', 'e', 0,
    's', 'e', 't', 'C', 'a', 'p', 'L', 'e', 'n', 'g', 't', 'h', 0,
    's', 'e', 't', 'F', 'u', 'l', 'l', 'R', 'a', 'n', 'g', 'e', 0,
    'f', 'u', 'n', 'c', 't', 'i', 'o', 'n', 'T', 'y', 'p', 'e', 0,
    'Q', 'w', 't', 'P', 'l', 'o', 't', 'C', 'u', 'r', 'v', 'e', 0,
    'L', 'e', 'g', 'e', 'n', 'd', 'W', 'i', 'd', 'g', 'e', 't', 0,
    's', 'e', 't', 'H', 'e', 'a', 'd', 'A', 'n', 'g', 'l', 'e', 0,
    'd', 'r', 'a', 'w', 'E', 'n', 'd', 'A', 'r', 'r', 'o', 'w', 0,
    'e', 'x', 'p', 'o', 'r', 't', 'V', 'e', 'c', 't', 'o', 'r', 0,
    's', 'e', 't', 'G', 'r', 'a', 'y', 'S', 'c', 'a', 'l', 'e', 0,
    'a', 'd', 'd', 'C', 'o', 'l', 'o', 'r', 'S', 't', 'o', 'p', 0,
    'S', 'c', 'a', 'l', 'e', 'd', 'C', 'o', 'l', 'o', 'r', 's', 0,
    's', 'c', 'r', 'o', 'l', 'l', 'T', 'o', 'C', 'e', 'l', 'l', 0,
    's', 'h', 'o', 'w', 'C', 'o', 'm', 'm', 'e', 'n', 't', 's', 0,
    'c', 'o', 'n', 'f', 'i', 'r', 'm', 'C', 'l', 'o', 's', 'e', 0,
    'M', 'd', 'i', 'S', 'u', 'b', 'W', 'i', 'n', 'd', 'o', 'w', 0,
    'c', 'u', 'r', 'r', 'e', 'n', 't', 'T', 'a', 'b', 'l', 'e', 0,
    's', 'e', 't', 'T', 'e', 'x', 't', 'C', 'o', 'l', 'o', 'r', 0,
    'b', 'o', 'u', 'n', 'd', 'i', 'n', 'g', 'R', 'e', 'c', 't', 0,
    'f', 'o', 'c', 'u', 's', 'I', 'n', 'E', 'v', 'e', 'n', 't', 0,
    's', 'e', 't', 'D', 'i', 'r', 'e', 'c', 't', 'i', 'o', 'n', 0,
    'C', 'o', 'n', 'v', 'o', 'l', 'u', 't', 'i', 'o', 'n', 0,
    'C', 'o', 'r', 'r', 'e', 'l', 'a', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'S', 'a', 'm', 'p', 'l', 'i', 'n', 'g', 0,
    'I', 'n', 't', 'e', 'g', 'r', 'a', 't', 'i', 'o', 'n', 0,
    'r', 'e', 's', 'u', 'l', 't', 'T', 'a', 'b', 'l', 'e', 0,
    's', 'e', 't', 'N', 'u', 'm', 'P', 'e', 'a', 'k', 's', 0,
    'G', 'a', 'u', 's', 's', 'A', 'm', 'p', 'F', 'i', 't', 0,
    'L', 'o', 'g', 'i', 's', 't', 'i', 'c', 'F', 'i', 't', 0,
    'T', 'h', 'r', 'e', 'e', 'E', 'x', 'p', 'F', 'i', 't', 0,
    's', 'c', 'a', 'l', 'e', 'E', 'r', 'r', 'o', 'r', 's', 0,
    'S', 't', 'a', 't', 'i', 's', 't', 'i', 'c', 'a', 'l', 0,
    'N', 'o', 'W', 'e', 'i', 'g', 'h', 't', 'i', 'n', 'g', 0,
    'i', 'm', 'p', 'o', 'r', 't', 'E', 'x', 'c', 'e', 'l', 0,
    'd', 'i', 's', 'p', 'l', 'a', 'y', 'I', 'n', 'f', 'o', 0,
    'c', 'u', 'r', 'r', 'e', 'n', 't', 'N', 'o', 't', 'e', 0,
    's', 'e', 't', 'F', 'u', 'n', 'c', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'B', 'a', 'r', 'L', 'i', 'n', 'e', 's', 0,
    's', 'e', 't', 'B', 'a', 'r', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'D', 'o', 't', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'B', 'a', 'c', 'k', 'G', 'r', 'i', 'd', 0,
    's', 'e', 't', 'C', 'e', 'i', 'l', 'G', 'r', 'i', 'd', 0,
    's', 'e', 't', 'L', 'e', 'f', 't', 'G', 'r', 'i', 'd', 0,
    'E', 'n', 'g', 'i', 'n', 'e', 'e', 'r', 'i', 'n', 'g', 0,
    's', 'e', 't', 'A', 'u', 't', 'o', 'e', 'x', 'e', 'c', 0,
    'r', 'e', 'm', 'o', 'v', 'e', 'L', 'a', 'y', 'e', 'r', 0,
    'a', 'c', 't', 'i', 'v', 'e', 'L', 'a', 'y', 'e', 'r', 0,
    'A', 'l', 'i', 'g', 'n', 'L', 'a', 'y', 'e', 'r', 's', 0,
    'e', 'x', 'p', 'o', 'r', 't', 'I', 'm', 'a', 'g', 'e', 0,
    's', 'e', 't', 'A', 'x', 'i', 's', 'F', 'o', 'n', 't', 0,
    'r', 'e', 'm', 'o', 'v', 'e', 'T', 'i', 't', 'l', 'e', 0,
    'p', 'l', 'o', 't', 'V', 'e', 'c', 't', 'o', 'r', 's', 0,
    's', 'p', 'e', 'c', 't', 'r', 'o', 'g', 'r', 'a', 'm', 0,
    'a', 'd', 'd', 'F', 'u', 'n', 'c', 't', 'i', 'o', 'n', 0,
    'r', 'e', 'm', 'o', 'v', 'e', 'C', 'u', 'r', 'v', 'e', 0,
    'i', 'n', 's', 'e', 'r', 't', 'C', 'u', 'r', 'v', 'e', 0,
    'S', 't', 'a', 'c', 'k', 'C', 'o', 'l', 'u', 'm', 'n', 0,
    'L', 'i', 'n', 'e', 'S', 'y', 'm', 'b', 'o', 'l', 's', 0,
    'G', 'r', 'a', 'p', 'h', ':', ':', 'A', 'x', 'i', 's', 0,
    'P', 'r', 'o', 'b', 'a', 'b', 'i', 'l', 'i', 't', 'y', 0,
    'y', 'M', 'i', 'n', 'E', 'n', 'a', 'b', 'l', 'e', 'd', 0,
    'y', 'M', 'a', 'x', 'E', 'n', 'a', 'b', 'l', 'e', 'd', 0,
    'x', 'M', 'i', 'n', 'E', 'n', 'a', 'b', 'l', 'e', 'd', 0,
    'x', 'M', 'a', 'x', 'E', 'n', 'a', 'b', 'l', 'e', 'd', 0,
    'C', 'o', 'n', 't', 'o', 'u', 'r', 'M', 'o', 'd', 'e', 0,
    's', 'e', 't', 'B', 'o', 'x', 'R', 'a', 'n', 'g', 'e', 0,
    's', 'e', 't', 'B', 'o', 'x', 'W', 'i', 'd', 't', 'h', 0,
    's', 'e', 't', 'B', 'o', 'x', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'P', '9', '9', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'M', 'a', 'x', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'M', 'i', 'n', 'S', 't', 'y', 'l', 'e', 0,
    'v', 'e', 'c', 't', 'o', 'r', 'S', 't', 'y', 'l', 'e', 0,
    'V', 'e', 'c', 't', 'o', 'r', 'C', 'u', 'r', 'v', 'e', 0,
    'm', 'a', 's', 't', 'e', 'r', 'C', 'u', 'r', 'v', 'e', 0,
    'c', 'l', 'e', 'a', 'r', 'L', 'a', 'b', 'e', 'l', 's', 0,
    'i', 's', 'F', 'u', 'l', 'l', 'R', 'a', 'n', 'g', 'e', 0,
    's', 'e', 't', 'R', 'o', 'w', 'R', 'a', 'n', 'g', 'e', 0,
    'l', 'a', 'b', 'e', 'l', 's', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'V', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 0,
    's', 'e', 't', 'F', 'o', 'r', 'm', 'u', 'l', 'a', 's', 0,
    'I', 'm', 'a', 'g', 'e', 'S', 'y', 'm', 'b', 'o', 'l', 0,
    'I', 'm', 'a', 'g', 'e', 'W', 'i', 'd', 'g', 'e', 't', 0,
    's', 'e', 't', 'F', 'r', 'a', 'm', 'e', 'P', 'e', 'n', 0,
    'F', 'r', 'a', 'm', 'e', 'W', 'i', 'd', 'g', 'e', 't', 0,
    'A', 'r', 'r', 'o', 'w', 'M', 'a', 'r', 'k', 'e', 'r', 0,
    'i', 'm', 'p', 'o', 'r', 't', 'I', 'm', 'a', 'g', 'e', 0,
    's', 'e', 't', 'C', 'o', 'l', 'o', 'r', 'M', 'a', 'p', 0,
    's', 'e', 't', 'V', 'i', 'e', 'w', 'T', 'y', 'p', 'e', 0,
    'F', 'i', 'x', 'e', 'd', 'C', 'o', 'l', 'o', 'r', 's', 0,
    's', 'w', 'a', 'p', 'C', 'o', 'l', 'u', 'm', 'n', 's', 0,
    'r', 'e', 'c', 'a', 'l', 'c', 'u', 'l', 'a', 't', 'e', 0,
    's', 'o', 'r', 't', 'C', 'o', 'l', 'u', 'm', 'n', 's', 0,
    'e', 'x', 'p', 'o', 'r', 't', 'A', 'S', 'C', 'I', 'I', 0,
    's', 'e', 't', 'C', 'o', 'l', 'N', 'a', 'm', 'e', 's', 0,
    's', 'e', 't', 'C', 'e', 'l', 'l', 'D', 'a', 't', 'a', 0,
    'w', 'i', 'n', 'd', 'o', 'w', 'L', 'a', 'b', 'e', 'l', 0,
    'i', 'm', 'p', 'o', 'r', 't', 'A', 'S', 'C', 'I', 'I', 0,
    't', 'a', 'b', 'l', 'e', 't', 'E', 'v', 'e', 'n', 't', 0,
    'a', 'c', 't', 'i', 'o', 'n', 'E', 'v', 'e', 'n', 't', 0,
    'd', 'e', 't', 'e', 'r', 'm', 'i', 'n', 'a', 'n', 't', 0,
    'p', 'a', 'i', 'n', 't', 'E', 'n', 'g', 'i', 'n', 'e', 0,
    's', 'e', 't', 'R', 'o', 't', 'a', 't', 'i', 'o', 'n', 0,
    'r', 'e', 's', 'i', 'z', 'e', 'E', 'v', 'e', 'n', 't', 0,
    'c', 'h', 'a', 'n', 'g', 'e', 'E', 'v', 'e', 'n', 't', 0,
    's', 'e', 't', 'I', 'n', 't', 'e', 'r', 'v', 'a', 'l', 0,
    's', 'e', 't', 'P', 'o', 's', 'i', 't', 'i', 'o', 'n', 0,
    '_', '_', 'd', 'e', 'l', 'i', 't', 'e', 'm', '_', '_', 0,
    '_', '_', 's', 'e', 't', 'i', 't', 'e', 'm', '_', '_', 0,
    'c', 'u', 's', 't', 'o', 'm', 'E', 'v', 'e', 'n', 't', 0,
    'e', 'v', 'e', 'n', 't', 'F', 'i', 'l', 't', 'e', 'r', 0,
    '_', '_', 'g', 'e', 't', 'i', 't', 'e', 'm', '_', '_', 0,
    'f', 'i', 'n', 'd', 'W', 'i', 'n', 'd', 'o', 'w', 0,
    's', 'e', 't', 'S', 'a', 'm', 'p', 'l', 'e', '2', 0,
    's', 'e', 't', 'S', 'a', 'm', 'p', 'l', 'e', '1', 0,
    'L', 'o', 'r', 'e', 'n', 't', 'z', 'F', 'i', 't', 0,
    'l', 'e', 'g', 'e', 'n', 'd', 'I', 'n', 'f', 'o', 0,
    'r', 'e', 's', 'u', 'l', 't', 's', 'L', 'o', 'g', 0,
    'c', 'o', 'p', 'y', 'F', 'o', 'l', 'd', 'e', 'r', 0,
    'r', 'o', 'o', 't', 'F', 'o', 'l', 'd', 'e', 'r', 0,
    's', 'a', 'v', 'e', 'F', 'o', 'l', 'd', 'e', 'r', 0,
    's', 'h', 'o', 'w', 'L', 'e', 'g', 'e', 'n', 'd', 0,
    'T', 'r', 'a', 'j', 'e', 'c', 't', 'o', 'r', 'y', 0,
    's', 'w', 'a', 'p', 'L', 'a', 'y', 'e', 'r', 's', 0,
    's', 'e', 't', 'M', 'a', 'r', 'g', 'i', 'n', 's', 0,
    'l', 'a', 'y', 'e', 'r', 's', 'L', 'i', 's', 't', 0,
    'M', 'u', 'l', 't', 'i', 'L', 'a', 'y', 'e', 'r', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'A', 'x', 'i', 's', 0,
    'a', 'r', 'r', 'o', 'w', 's', 'L', 'i', 's', 't', 0,
    'c', 'u', 'r', 'v', 'e', 'T', 'i', 't', 'l', 'e', 0,
    'R', 'e', 'c', 'i', 'p', 'r', 'o', 'c', 'a', 'l', 0,
    's', 'e', 't', 'M', 'i', 'n', 'P', 'e', 'n', 'Y', 0,
    's', 'e', 't', 'M', 'a', 'j', 'P', 'e', 'n', 'Y', 0,
    's', 'e', 't', 'M', 'i', 'n', 'P', 'e', 'n', 'X', 0,
    's', 'e', 't', 'M', 'a', 'j', 'P', 'e', 'n', 'X', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'Y', 'M', 'i', 'n', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'Y', 'M', 'a', 'x', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'X', 'M', 'i', 'n', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'X', 'M', 'a', 'x', 0,
    's', 't', 'a', 't', 'i', 's', 't', 'i', 'c', 's', 0,
    's', 'e', 't', 'P', '1', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'B', 'i', 'n', 'n', 'i', 'n', 'g', 0,
    'h', 'e', 'a', 'd', 'L', 'e', 'n', 'g', 't', 'h', 0,
    'f', 'i', 'r', 's', 't', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'X', 'E', 'r', 'r', 'o', 'r', 's', 0,
    'e', 'r', 'r', 'o', 'r', 'V', 'a', 'l', 'u', 'e', 0,
    'u', 'p', 'd', 'a', 't', 'e', 'D', 'a', 't', 'a', 0,
    'l', 'a', 'b', 'e', 'l', 's', 'F', 'o', 'n', 't', 0,
    's', 't', 'a', 'r', 't', 'R', 'a', 'n', 'g', 'e', 0,
    'P', 'a', 'r', 'a', 'm', 'e', 't', 'r', 'i', 'c', 0,
    'P', 'l', 'o', 't', 'S', 'y', 'm', 'b', 'o', 'l', 0,
    'f', 'r', 'a', 'm', 'e', 'C', 'o', 'l', 'o', 'r', 0,
    'C', 'e', 'n', 't', 'i', 'm', 'e', 't', 'e', 'r', 0,
    's', 'e', 't', 'F', 'o', 'r', 'm', 'u', 'l', 'a', 0,
    's', 'e', 't', 'C', 'o', 'm', 'm', 'e', 'n', 't', 0,
    's', 'e', 't', 'C', 'o', 'm', 'm', 'a', 'n', 'd', 0,
    's', 'e', 't', 'C', 'o', 'l', 'N', 'a', 'm', 'e', 0,
    's', 'e', 't', 'C', 'o', 'l', 'D', 'a', 't', 'a', 0,
    's', 'e', 't', 'R', 'o', 'w', 'D', 'a', 't', 'a', 0,
    'd', 'e', 'l', 'e', 't', 'e', 'R', 'o', 'w', 's', 0,
    's', 'e', 't', 'N', 'u', 'm', 'C', 'o', 'l', 's', 0,
    's', 'e', 't', 'N', 'u', 'm', 'R', 'o', 'w', 's', 0,
    'S', 'c', 'i', 'e', 'n', 't', 'i', 'f', 'i', 'c', 0,
    'N', 'e', 'w', 'C', 'o', 'l', 'u', 'm', 'n', 's', 0,
    'S', 'c', 'r', 'i', 'p', 't', 'E', 'd', 'i', 't', 0,
    'f', 'o', 'n', 't', 'C', 'h', 'a', 'n', 'g', 'e', 0,
    'h', 'i', 'd', 'e', 'C', 'o', 'l', 'u', 'm', 'n', 0,
    's', 'o', 'r', 't', 'C', 'o', 'l', 'u', 'm', 'n', 0,
    'M', 'i', 'l', 'l', 'i', 'm', 'e', 't', 'e', 'r', 0,
    'e', 'n', 't', 'e', 'r', 'E', 'v', 'e', 'n', 't', 0,
    'l', 'e', 'a', 'v', 'e', 'E', 'v', 'e', 'n', 't', 0,
    'c', 'o', 'l', 'u', 'm', 'n', 'S', 'p', 'a', 'n', 0,
    's', 'e', 't', 'O', 'p', 'a', 'c', 'i', 't', 'y', 0,
    'c', 'o', 'n', 's', 't', 'r', 'a', 'i', 'n', 't', 0,
    'f', 'r', 'a', 'm', 'e', 'W', 'i', 'd', 't', 'h', 0,
    's', 'e', 't', 'S', 'p', 'a', 'c', 'i', 'n', 'g', 0,
    's', 'e', 't', 'V', 'i', 's', 'i', 'b', 'l', 'e', 0,
    'c', 'l', 'o', 's', 'e', 'E', 'v', 'e', 'n', 't', 0,
    'r', 'e', 'p', 'e', 'a', 't', 'T', 'i', 'm', 'e', 0,
    'w', 'h', 'e', 'e', 'l', 'E', 'v', 'e', 'n', 't', 0,
    'p', 'a', 'i', 'n', 't', 'E', 'v', 'e', 'n', 't', 0,
    'c', 'h', 'i', 'l', 'd', 'E', 'v', 'e', 'n', 't', 0,
    't', 'i', 'm', 'e', 'r', 'E', 'v', 'e', 'n', 't', 0,
    'H', 'o', 'r', 'i', 'z', 'o', 'n', 't', 'a', 'l', 0,
    'a', 'd', 'd', 'S', 'a', 'm', 'p', 'l', 'e', 0,
    's', 't', 'a', 't', 'i', 's', 't', 'i', 'c', 0,
    's', 'e', 't', 'C', 'u', 't', 'o', 'f', 'f', 0,
    'B', 'a', 'n', 'd', 'B', 'l', 'o', 'c', 'k', 0,
    'F', 'F', 'T', 'F', 'i', 'l', 't', 'e', 'r', 0,
    's', 'e', 't', 'M', 'e', 't', 'h', 'o', 'd', 0,
    'P', 'l', 'u', 'g', 'i', 'n', 'F', 'i', 't', 0,
    'T', 'w', 'o', 'E', 'x', 'p', 'F', 'i', 't', 0,
    'c', 'h', 'i', 'S', 'q', 'u', 'a', 'r', 'e', 0,
    'r', 'e', 's', 'i', 'd', 'u', 'a', 'l', 's', 0,
    'w', 'o', 'r', 'k', 's', 'p', 'a', 'c', 'e', 0,
    'a', 'd', 'd', 'F', 'o', 'l', 'd', 'e', 'r', 0,
    'n', 'e', 'w', 'P', 'l', 'o', 't', '3', 'D', 0,
    'n', 'e', 'w', 'M', 'a', 't', 'r', 'i', 'x', 0,
    's', 'e', 't', 'S', 'c', 'a', 'l', 'e', 's', 0,
    's', 'e', 't', 'N', 'o', 'A', 'x', 'e', 's', 0,
    's', 'e', 't', 'F', 'r', 'a', 'm', 'e', 'd', 0,
    'r', 'e', 'n', 'a', 'm', 'e', 'T', 'a', 'b', 0,
    'n', 'u', 'm', 'L', 'a', 'y', 'e', 'r', 's', 0,
    'e', 'x', 'p', 'o', 'r', 't', 'T', 'e', 'x', 0,
    's', 'e', 't', 'Y', 'T', 'i', 't', 'l', 'e', 0,
    's', 'e', 't', 'X', 'T', 'i', 't', 'l', 'e', 0,
    's', 'e', 't', 'L', 'e', 'g', 'e', 'n', 'd', 0,
    'n', 'e', 'w', 'L', 'e', 'g', 'e', 'n', 'd', 0,
    'n', 'u', 'm', 'A', 'r', 'r', 'o', 'w', 's', 0,
    'd', 'a', 't', 'a', 'C', 'u', 'r', 'v', 'e', 0,
    'n', 'u', 'm', 'C', 'u', 'r', 'v', 'e', 's', 0,
    'a', 'd', 'd', 'C', 'u', 'r', 'v', 'e', 's', 0,
    'p', 'i', 'e', 'L', 'e', 'g', 'e', 'n', 'd', 0,
    'i', 's', 'P', 'i', 'e', 'P', 'l', 'o', 't', 0,
    'I', 'm', 'a', 'g', 'e', 'P', 'l', 'o', 't', 0,
    'I', 'm', 'a', 'g', 'e', 'M', 'o', 'd', 'e', 0,
    'm', 'e', 'a', 'n', 'S', 't', 'y', 'l', 'e', 0,
    'v', 'e', 'c', 't', 'o', 'r', 'P', 'e', 'n', 0,
    'h', 'e', 'a', 'd', 'A', 'n', 'g', 'l', 'e', 0,
    't', 'h', 'i', 'c', 'k', 'n', 'e', 's', 's', 0,
    'v', 'i', 'e', 'w', 'A', 'n', 'g', 'l', 'e', 0,
    'm', 'i', 'n', 'u', 's', 'S', 'i', 'd', 'e', 0,
    'c', 'a', 'p', 'L', 'e', 'n', 'g', 't', 'h', 0,
    'h', 'a', 's', 'L', 'a', 'b', 'e', 'l', 's', 0,
    'D', 'a', 't', 'a', 'C', 'u', 'r', 'v', 'e', 0,
    's', 'e', 't', 'S', 'y', 'm', 'b', 'o', 'l', 0,
    'm', 'a', 'x', 'Y', 'V', 'a', 'l', 'u', 'e', 0,
    'm', 'i', 'n', 'Y', 'V', 'a', 'l', 'u', 'e', 0,
    'm', 'a', 'x', 'X', 'V', 'a', 'l', 'u', 'e', 0,
    'm', 'i', 'n', 'X', 'V', 'a', 'l', 'u', 'e', 0,
    'i', 'm', 'a', 'g', 'e', 'P', 'a', 't', 'h', 0,
    'R', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 0,
    'L', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 0,
    'U', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 0,
    'D', 'T', 'r', 'i', 'a', 'n', 'g', 'l', 'e', 0,
    'Q', 'w', 't', 'S', 'y', 'm', 'b', 'o', 'l', 0,
    'r', 'e', 's', 'e', 't', 'V', 'i', 'e', 'w', 0,
    'i', 'n', 't', 'e', 'g', 'r', 'a', 't', 'e', 0,
    'I', 'm', 'a', 'g', 'e', 'V', 'i', 'e', 'w', 0,
    'T', 'a', 'b', 'l', 'e', 'V', 'i', 'e', 'w', 0,
    'C', 'o', 'l', 'u', 'm', 'n', 'R', 'o', 'w', 0,
    'a', 'd', 'd', 'C', 'o', 'l', 'u', 'm', 'n', 0,
    'r', 'e', 'm', 'o', 'v', 'e', 'C', 'o', 'l', 0,
    'O', 'v', 'e', 'r', 'w', 'r', 'i', 't', 'e', 0,
    'M', 'D', 'I', 'W', 'i', 'n', 'd', 'o', 'w', 0,
    'e', 'x', 'p', 'o', 'r', 't', 'P', 'D', 'F', 0,
    'r', 'e', 'm', 'o', 'v', 'e', 'T', 'a', 'b', 0,
    'R', 'e', 'c', 't', 'a', 'n', 'g', 'l', 'e', 0,
    'n', 'o', 'r', 'm', 'a', 'l', 'i', 'z', 'e', 0,
    's', 'e', 't', 'M', 'a', 'r', 'g', 'i', 'n', 0,
    's', 'e', 't', 'O', 'r', 'i', 'g', 'i', 'n', 0,
    'm', 'o', 'v', 'e', 'E', 'v', 'e', 'n', 't', 0,
    'd', 'r', 'a', 'w', 'F', 'r', 'a', 'm', 'e', 0,
    's', 'e', 't', 'R', 'a', 'd', 'i', 'u', 's', 0,
    's', 'e', 't', 'M', 'a', 't', 'r', 'i', 'x', 0,
    'i', 's', 'V', 'i', 's', 'i', 'b', 'l', 'e', 0,
    's', 'h', 'o', 'w', 'E', 'v', 'e', 'n', 't', 0,
    'h', 'i', 'd', 'e', 'E', 'v', 'e', 'n', 't', 0,
    'd', 'r', 'o', 'p', 'E', 'v', 'e', 'n', 't', 0,
    'a', 'l', 'i', 'g', 'n', 'm', 'e', 'n', 't', 0,
    't', 'r', 'a', 'n', 's', 'p', 'o', 's', 'e', 0,
    'r', 'e', 'c', 'e', 'i', 'v', 'e', 'r', 's', 0,
    'd', 'i', 'r', 'e', 'c', 't', 'i', 'o', 'n', 0,
    'p', 'V', 'a', 'l', 'u', 'e', 'A', 'B', 0,
    'v', 'a', 'r', 'i', 'a', 'n', 'c', 'e', 0,
    'B', 'a', 'n', 'd', 'P', 'a', 's', 's', 0,
    'H', 'i', 'g', 'h', 'P', 'a', 's', 's', 0,
    'G', 'a', 'u', 's', 's', 'F', 'i', 't', 0,
    'n', 'u', 'm', 'P', 'e', 'a', 'k', 's', 0,
    's', 't', 'e', 'm', 'P', 'l', 'o', 't', 0,
    'n', 'e', 'w', 'G', 'r', 'a', 'p', 'h', 0,
    'n', 'e', 'w', 'T', 'a', 'b', 'l', 'e', 0,
    's', 'e', 't', 'B', 'o', 'x', 'e', 'd', 0,
    's', 'e', 't', 'S', 'h', 'i', 'f', 't', 0,
    'a', 'u', 't', 'o', 'e', 'x', 'e', 'c', 0,
    'a', 'd', 'd', 'L', 'a', 'y', 'e', 'r', 0,
    'a', 'd', 'd', 'I', 'm', 'a', 'g', 'e', 0,
    'a', 'd', 'd', 'A', 'r', 'r', 'o', 'w', 0,
    'b', 'o', 'x', 'C', 'u', 'r', 'v', 'e', 0,
    'a', 'd', 'd', 'C', 'u', 'r', 'v', 'e', 0,
    'S', 't', 'a', 'c', 'k', 'B', 'a', 'r', 0,
    'V', 'e', 'c', 't', 'X', 'Y', 'A', 'M', 0,
    'V', 'e', 'c', 't', 'X', 'Y', 'X', 'Y', 0,
    'q', 'u', 'a', 'n', 't', 'i', 'l', 'e', 0,
    'b', 'o', 'x', 'R', 'a', 'n', 'g', 'e', 0,
    'b', 'o', 'x', 'W', 'i', 'd', 't', 'h', 0,
    'b', 'o', 'x', 'S', 't', 'y', 'l', 'e', 0,
    'p', '9', '9', 'S', 't', 'y', 'l', 'e', 0,
    'm', 'a', 'x', 'S', 't', 'y', 'l', 'e', 0,
    'm', 'i', 'n', 'S', 't', 'y', 'l', 'e', 0,
    'B', 'o', 'x', 'C', 'u', 'r', 'v', 'e', 0,
    'P', 'i', 'e', 'C', 'u', 'r', 'v', 'e', 0,
    'p', 'l', 'u', 's', 'S', 'i', 'd', 'e', 0,
    'l', 'o', 'a', 'd', 'D', 'a', 't', 'a', 0,
    'v', 'a', 'r', 'i', 'a', 'b', 'l', 'e', 0,
    'f', 'o', 'r', 'm', 'u', 'l', 'a', 's', 0,
    'e', 'n', 'd', 'R', 'a', 'n', 'g', 'e', 0,
    'd', 'a', 't', 'a', 'S', 'i', 'z', 'e', 0,
    'S', 't', 'y', 'l', 'e', 'C', 'n', 't', 0,
    'N', 'o', 'S', 'y', 'm', 'b', 'o', 'l', 0,
    'f', 'r', 'a', 'm', 'e', 'P', 'e', 'n', 0,
    'c', 'o', 'l', 'o', 'r', 'M', 'a', 'p', 0,
    'r', 'o', 't', 'a', 't', 'e', '9', '0', 0,
    'r', 'e', 's', 'a', 'm', 'p', 'l', 'e', 0,
    'B', 'i', 'l', 'i', 'n', 'e', 'a', 'r', 0,
    's', 't', 'a', 'r', 't', 'R', 'o', 'w', 0,
    'c', 'o', 'l', 'N', 'a', 'm', 'e', 's', 0,
    'c', 'e', 'l', 'l', 'D', 'a', 't', 'a', 0,
    's', 'h', 'o', 'w', 'G', 'r', 'i', 'd', 0,
    's', 'e', 't', 'T', 'i', 't', 'l', 'e', 0,
    's', 'e', 't', 'B', 'r', 'u', 's', 'h', 0,
    's', 'e', 't', 'S', 'c', 'a', 'l', 'e', 0,
    's', 'e', 't', 'S', 't', 'a', 'r', 't', 0,
    's', 'e', 't', 'C', 'o', 'l', 'o', 'r', 0,
    's', 'e', 't', 'S', 't', 'y', 'l', 'e', 0,
    's', 'e', 't', 'F', 'r', 'a', 'm', 'e', 0,
    's', 'e', 't', 'R', 'a', 'n', 'g', 'e', 0,
    's', 'i', 'z', 'e', 'H', 'i', 'n', 't', 0,
    'p', 'o', 's', 'i', 't', 'i', 'o', 'n', 0,
    's', 'e', 't', 'W', 'i', 'd', 't', 'h', 0,
    'p', 'r', 'o', 'p', 'e', 'r', 't', 'y', 0,
    's', 'e', 't', 'A', 'n', 'g', 'l', 'e', 0,
    'f', 'i', 'l', 'e', 'N', 'a', 'm', 'e', 0,
    'V', 'e', 'r', 't', 'i', 'c', 'a', 'l', 0,
    'f', 'o', 'l', 'd', 'e', 'r', 's', 0,
    'p', 'V', 'a', 'l', 'u', 'e', 'B', 0,
    'p', 'V', 'a', 'l', 'u', 'e', 'A', 0,
    'f', 'S', 't', 'a', 't', 'A', 'B', 0,
    's', 'e', 't', 'T', 'a', 'i', 'l', 0,
    'l', 'o', 'g', 'I', 'n', 'f', 'o', 0,
    's', 'e', 't', 'B', 'a', 'n', 'd', 0,
    'L', 'o', 'w', 'P', 'a', 's', 's', 0,
    'A', 'v', 'e', 'r', 'a', 'g', 'e', 0,
    'L', 'o', 'r', 'e', 'n', 't', 'z', 0,
    'r', 'S', 'q', 'u', 'a', 'r', 'e', 0,
    'r', 'e', 's', 'u', 'l', 't', 's', 0,
    'f', 'o', 'r', 'm', 'u', 'l', 'a', 0,
    'D', 'a', 't', 'a', 's', 'e', 't', 0,
    'w', 'i', 'n', 'd', 'o', 'w', 's', 0,
    'n', 'e', 'w', 'N', 'o', 't', 'e', 0,
    'a', 'n', 'i', 'm', 'a', 't', 'e', 0,
    's', 'e', 't', 'Z', 'o', 'o', 'm', 0,
    'G', 'r', 'a', 'p', 'h', '3', 'D', 0,
    's', 'e', 't', 'R', 'o', 'w', 's', 0,
    's', 'e', 't', 'C', 'o', 'l', 's', 0,
    'V', 'C', 'e', 'n', 't', 'e', 'r', 0,
    'H', 'C', 'e', 'n', 't', 'e', 'r', 0,
    'p', 'l', 'o', 't', 'P', 'i', 'e', 0,
    'p', 'l', 'o', 't', 'B', 'o', 'x', 0,
    'C', 'o', 'n', 't', 'o', 'u', 'r', 0,
    'S', 'c', 'a', 't', 't', 'e', 'r', 0,
    'Q', 'w', 't', 'P', 'l', 'o', 't', 0,
    'm', 'i', 'n', 'P', 'e', 'n', 'Y', 0,
    'm', 'a', 'j', 'P', 'e', 'n', 'Y', 0,
    'm', 'i', 'n', 'P', 'e', 'n', 'X', 0,
    'm', 'a', 'j', 'P', 'e', 'n', 'X', 0,
    'p', '1', 'S', 't', 'y', 'l', 'e', 0,
    'U', 's', 'e', 'r', 'D', 'e', 'f', 0,
    'W', 'i', 'n', 'd', 'B', 'o', 'x', 0,
    'b', 'i', 'n', 'S', 'i', 'z', 'e', 0,
    'x', 'E', 'r', 'r', 'o', 'r', 's', 0,
    'H', 'e', 'x', 'a', 'g', 'o', 'n', 0,
    'D', 'i', 'a', 'm', 'o', 'n', 'd', 0,
    'B', 'i', 'c', 'u', 'b', 'i', 'c', 0,
    'I', 'n', 'd', 'e', 'x', 'e', 'd', 0,
    'c', 'o', 'l', 'N', 'a', 'm', 'e', 0,
    'c', 'o', 'l', 'D', 'a', 't', 'a', 0,
    'r', 'o', 'w', 'D', 'a', 't', 'a', 0,
    'D', 'e', 'c', 'i', 'm', 'a', 'l', 0,
    'N', 'e', 'w', 'R', 'o', 'w', 's', 0,
    'd', 'e', 's', 't', 'r', 'o', 'y', 0,
    'n', 'u', 'm', 'C', 'o', 'l', 's', 0,
    'n', 'u', 'm', 'R', 'o', 'w', 's', 0,
    'N', 'o', 'T', 'i', 'c', 'k', 's', 0,
    'E', 'l', 'l', 'i', 'p', 's', 'e', 0,
    'r', 'e', 's', 't', 'o', 'r', 'e', 0,
    'D', 'e', 'f', 'a', 'u', 'l', 't', 0,
    's', 'e', 't', 'M', 'o', 'd', 'e', 0,
    'd', 'e', 'v', 'T', 'y', 'p', 'e', 0,
    'a', 'd', 'd', 'T', 'e', 'x', 't', 0,
    'r', 'o', 'w', 'S', 'p', 'a', 'n', 0,
    's', 'e', 't', 'F', 'o', 'n', 't', 0,
    'm', 'a', 'x', 'i', 'm', 'u', 'm', 0,
    'm', 'i', 'n', 'i', 'm', 'u', 'm', 0,
    'c', 'o', 'm', 'm', 'e', 'n', 't', 0,
    's', 'e', 't', 'R', 'e', 'c', 't', 0,
    's', 'e', 't', 'T', 'e', 'x', 't', 0,
    'e', 'n', 'a', 'b', 'l', 'e', 'd', 0,
    's', 'e', 't', 'C', 'e', 'l', 'l', 0,
    'p', 'a', 't', 't', 'e', 'r', 'n', 0,
    'i', 'n', 'd', 'e', 'x', 'O', 'f', 0,
    '_', '_', 'l', 'e', 'n', '_', '_', 0,
    's', 'e', 't', 'D', 'a', 't', 'a', 0,
    's', 'e', 't', 'S', 'i', 'z', 'e', 0,
    'f', 'S', 't', 'a', 't', 'B', 0,
    'f', 'S', 't', 'a', 't', 'A', 0,
    'p', 'V', 'a', 'l', 'u', 'e', 0,
    'L', 'o', 'w', 'e', 's', 's', 0,
    'e', 'r', 'r', 'o', 'r', 's', 0,
    'p', 'l', 'o', 't', '3', 'D', 0,
    'D', 'i', 'r', 'e', 'c', 't', 0,
    'R', 'i', 'b', 'b', 'o', 'n', 0,
    'r', 'e', 'p', 'l', 'o', 't', 0,
    'l', 'e', 'g', 'e', 'n', 'd', 0,
    'S', 'p', 'l', 'i', 'n', 'e', 0,
    'l', 'e', 'v', 'e', 'l', 's', 0,
    'm', 'e', 'd', 'i', 'a', 'n', 0,
    'M', 'i', 'n', 'M', 'a', 'x', 0,
    'r', '1', '0', '_', '9', '0', 0,
    'r', '2', '5', '_', '7', '5', 0,
    'X', 'C', 'r', 'o', 's', 's', 0,
    'y', 'V', 'a', 'l', 'u', 'e', 0,
    'x', 'V', 'a', 'l', 'u', 'e', 0,
    's', 'e', 't', 'E', 'n', 'd', 0,
    'e', 'x', 'p', 'o', 'r', 't', 0,
    's', 'm', 'o', 'o', 't', 'h', 0,
    'c', 'o', 'l', 'o', 'r', '2', 0,
    'e', 'n', 'd', 'R', 'o', 'w', 0,
    'f', 'o', 'l', 'd', 'e', 'r', 0,
    's', 'a', 'v', 'e', 'A', 's', 0,
    'a', 'd', 'd', 'T', 'a', 'b', 0,
    'B', 'o', 't', 't', 'o', 'm', 0,
    'i', 'n', 'v', 'e', 'r', 't', 0,
    'M', 'i', 'd', 'd', 'l', 'e', 0,
    's', 'e', 't', 'P', 'e', 'n', 0,
    'w', 'i', 'n', 'd', 'o', 'w', 0,
    'S', 'h', 'a', 'd', 'o', 'w', 0,
    'a', 'd', 'd', 'R', 'o', 'w', 0,
    'N', 'o', 'r', 'm', 'a', 'l', 0,
    'r', 'a', 'd', 'i', 'u', 's', 0,
    'y', 'S', 't', 'a', 'r', 't', 0,
    'x', 'S', 't', 'a', 'r', 't', 0,
    'p', 'i', 'x', 'm', 'a', 'p', 0,
    'm', 'a', 't', 'r', 'i', 'x', 0,
    'u', 'p', 'd', 'a', 't', 'e', 0,
    'e', 'd', 'i', 't', 'o', 'r', 0,
    'o', 'p', 't', 'i', 'o', 'n', 0,
    'w', 'i', 'd', 'g', 'e', 't', 0,
    's', 'e', 'n', 'd', 'e', 'r', 0,
    'b', 'o', 't', 't', 'o', 'm', 0,
    's', 'y', 's', 't', 'e', 'm', 0,
    's', 'y', 'm', 'b', 'o', 'l', 0,
    'L', 'i', 'n', 'e', 'a', 'r', 0,
    'c', 'o', 'l', 'u', 'm', 'n', 0,
    'o', 'f', 'f', 's', 'e', 't', 0,
    'c', 'r', 'e', 'a', 't', 'e', 0,
    'r', 'e', 'm', 'o', 'v', 'e', 0,
    'o', 'b', 'j', 'e', 'c', 't', 0,
    'c', 'o', 'l', 'o', 'r', '1', 0,
    'f', 'S', 't', 'a', 't', 0,
    'A', 'n', 'o', 'v', 'a', 0,
    't', 'T', 'e', 's', 't', 0,
    'A', 'k', 'i', 'm', 'a', 0,
    'C', 'u', 'b', 'i', 'c', 0,
    'G', 'a', 'u', 's', 's', 0,
    'p', 'o', 'w', 'e', 'r', 0,
    'l', 'a', 'y', 'e', 'r', 0,
    'I', 'n', 'O', 'u', 't', 0,
    'L', 'o', 'g', 'i', 't', 0,
    'L', 'o', 'g', '1', '0', 0,
    'g', 'r', 'a', 'p', 'h', 0,
    'r', '1', '_', '9', '9', 0,
    'r', '5', '_', '9', '5', 0,
    'N', 'o', 't', 'c', 'h', 0,
    'N', 'o', 'B', 'o', 'x', 0,
    't', 'a', 'b', 'l', 'e', 0,
    'P', 'o', 'l', 'a', 'r', 0,
    'S', 't', 'a', 'r', '2', 0,
    'S', 't', 'a', 'r', '1', 0,
    'P', 'i', 'x', 'e', 'l', 0,
    'p', 'r', 'i', 'n', 't', 0,
    'b', 'e', 'g', 'i', 'n', 0,
    'c', 'l', 'o', 'n', 'e', 0,
    'V', 'L', 'i', 'n', 'e', 0,
    'H', 'L', 'i', 'n', 'e', 0,
    'b', 'r', 'u', 's', 'h', 0,
    'P', 'o', 'i', 'n', 't', 0,
    'c', 'u', 'r', 'v', 'e', 0,
    'c', 'o', 'l', 'o', 'r', 0,
    'i', 'm', 'a', 'g', 'e', 0,
    's', 't', 'y', 'l', 'e', 0,
    'R', 'i', 'g', 'h', 't', 0,
    'r', 'i', 'g', 'h', 't', 0,
    'e', 'v', 'e', 'n', 't', 0,
    'm', 's', 'a', 'b', 0,
    's', 's', 'a', 'b', 0,
    'r', 'm', 's', 'e', 0,
    'n', 'o', 't', 'e', 0,
    'g', 'r', 'i', 'd', 0,
    'A', 'r', 'e', 'a', 0,
    'L', 'o', 'g', '2', 0,
    'm', 'e', 'a', 'n', 0,
    'y', 'E', 'n', 'd', 0,
    'x', 'E', 'n', 'd', 0,
    'y', 'E', 'r', 'r', 0,
    'x', 'E', 'r', 'r', 0,
    'B', 'o', 't', 'h', 0,
    'I', 'n', 'c', 'h', 0,
    'L', 'e', 'f', 't', 0,
    'a', 'r', 'e', 'a', 0,
    't', 'a', 'b', 's', 0,
    's', 'a', 'v', 'e', 0,
    'l', 'o', 'a', 'd', 0,
    'm', 'o', 'd', 'e', 0,
    'n', 'a', 'm', 'e', 0,
    'N', 'o', 'n', 'e', 0,
    'c', 'e', 'l', 'l', 0,
    's', 'o', 'r', 't', 0,
    'p', 'a', 't', 'h', 0,
    'm', 's', 'b', 0,
    'm', 's', 'a', 0,
    's', 's', 'b', 0,
    's', 's', 'a', 0,
    's', 's', 't', 0,
    's', 's', 'e', 0,
    's', 's', 'm', 0,
    'd', 'o', 'f', 0,
    'u', 'c', 'l', 0,
    'l', 'c', 'l', 0,
    'r', 's', 's', 0,
    'Y', 'X', 'Z', 0,
    'f', 'i', 't', 0,
    'R', 'G', 'B', 0,
    'T', 'o', 'p', 0,
    'p', 'e', 'n', 0,
    'r', 'u', 'n', 0,
    'a', 'd', 'd', 0,
    'q', 't', 'i', 0,
    'I', 'n', 0,
    'L', 'n', 0,
    'S', 'E', 0,
    'S', 'D', 0,
    'd', 'y', 0,
    'd', 'x', 0,
};
#line 2473 "src/scripting/qti.sip"
ApplicationWindow *sipqti_app()
{
  int iserr = 0;
  PyObject *me = PyImport_ImportModule("qti");
  PyObject *mydict = PyModule_GetDict(me);
  PyObject *pyapp = PyDict_GetItemString(mydict,"app");
  Py_DECREF(me);
  if (sipCanConvertToInstance(pyapp, sipClass_ApplicationWindow, SIP_NOT_NONE))
    return (ApplicationWindow*) sipConvertToInstance(pyapp, sipClass_ApplicationWindow, NULL, SIP_NOT_NONE, NULL, &iserr);
  else
    return NULL;
}
#line 1199 "../tmp/qtiplot/sipqticmodule.cpp"

double sipVH_qti_0(sip_gilstate_t sipGILState, sipVirtErrorHandlerFunc sipErrorHandler, sipSimpleWrapper *sipPySelf, PyObject *sipMethod)
{
    double sipRes = 0;
    PyObject *sipResObj = sipCallMethod(0, sipMethod, "");

    sipParseResultEx(sipGILState, sipErrorHandler, sipPySelf, sipMethod, sipResObj, "d", &sipRes);

    return sipRes;
}

void sipVH_qti_1(sip_gilstate_t sipGILState, sipVirtErrorHandlerFunc sipErrorHandler, sipSimpleWrapper *sipPySelf, PyObject *sipMethod, bool a0,Graph *a1)
{
    PyObject *sipResObj = sipCallMethod(0, sipMethod, "bD",a0,a1,sipType_Graph,NULL);

    sipParseResultEx(sipGILState, sipErrorHandler, sipPySelf, sipMethod, sipResObj, "Z");
}

bool sipVH_qti_2(sip_gilstate_t sipGILState, sipVirtErrorHandlerFunc sipErrorHandler, sipSimpleWrapper *sipPySelf, PyObject *sipMethod, Table *a0,const QString& a1,const QString& a2,int a3,int a4)
{
    bool sipRes = 0;
    PyObject *sipResObj = sipCallMethod(0, sipMethod, "DNNii",a0,sipType_Table,NULL,new QString(a1),sipType_QString,NULL,new QString(a2),sipType_QString,NULL,a3,a4);

    sipParseResultEx(sipGILState, sipErrorHandler, sipPySelf, sipMethod, sipResObj, "b", &sipRes);

    return sipRes;
}

void sipVH_qti_3(sip_gilstate_t sipGILState, sipVirtErrorHandlerFunc sipErrorHandler, sipSimpleWrapper *sipPySelf, PyObject *sipMethod, const QStringList& a0)
{
    PyObject *sipResObj = sipCallMethod(0, sipMethod, "N",new QStringList(a0),sipType_QStringList,NULL);

    sipParseResultEx(sipGILState, sipErrorHandler, sipPySelf, sipMethod, sipResObj, "Z");
}


/* Convert to a sub-class if possible. */
extern "C" {static const sipTypeDef *sipSubClass_ApplicationWindow(void **);}
static const sipTypeDef *sipSubClass_ApplicationWindow(void **sipCppRet)
{
    QObject *sipCpp = reinterpret_cast<QObject *>(*sipCppRet);
    sipWrapperType *sipClass;

#line 2191 "src/scripting/qti.sip"
// we have to do this to override casting in qt/qobject.sip
 sipClass = sipFindClass(sipCpp->className());
#line 1246 "../tmp/qtiplot/sipqticmodule.cpp"

    return (sipClass ? sipClass->type : 0);
}
static sipEnumTypeDef enumTypes[] = {
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_StatisticTest__Tail, {0}}, sipNameNr_Tail, 93, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_FFTFilter__FilterType, {0}}, sipNameNr_FilterType, 18, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_SmoothFilter__SmoothMethod, {0}}, sipNameNr_SmoothMethod, 90, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Interpolation__InterpolationMethod, {0}}, sipNameNr_InterpolationMethod, 44, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_MultiPeakFit__PeakProfile, {0}}, sipNameNr_PeakProfile, 61, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Fit__WeightingMethod, {0}}, sipNameNr_WeightingMethod, 21, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Fit__Algorithm, {0}}, sipNameNr_Algorithm, 21, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_ApplicationWindow__MatrixToTableConversion, {0}}, sipNameNr_MatrixToTableConversion, 1, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Graph3D__AxisNumericFormat, {0}}, sipNameNr_AxisNumericFormat, 33, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Graph3D__PlotType, {0}}, sipNameNr_PlotType, 33, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_MultiLayer__AlignPolicy, {0}}, sipNameNr_AlignPolicy, 57, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_MultiLayer__VertAlignement, {0}}, sipNameNr_VertAlignement, 57, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_MultiLayer__HorAlignement, {0}}, sipNameNr_HorAlignement, 57, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Graph__CurveType, {0}}, sipNameNr_CurveType, 32, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Graph__TicksStyle, {0}}, sipNameNr_TicksStyle, 32, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Graph__Axis, {0}}, sipNameNr_Axis, 32, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Graph__Scale, {0}}, sipNameNr_Scale, 32, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_QwtPlotSpectrogram__DisplayMode, {0}}, sipNameNr_DisplayMode, 82, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_BoxCurve__Range, {0}}, sipNameNr_Range, 4, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_BoxCurve__BoxStyle, {0}}, sipNameNr_BoxStyle, 4, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_VectorCurve__Position, {0}}, sipNameNr_Position, 102, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_VectorCurve__VectorStyle, {0}}, sipNameNr_VectorStyle, 102, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_ErrorBarsCurve__Orientation, {0}}, sipNameNr_Orientation, 14, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_FunctionCurve__FunctionType, {0}}, sipNameNr_FunctionType, 28, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_QwtSymbol__Style, {0}}, sipNameNr_Style, 84, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_FrameWidget__Unit, {0}}, sipNameNr_Unit, 25, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_FrameWidget__FrameStyle, {0}}, sipNameNr_FrameStyle, 25, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Matrix__ResamplingMethod, {0}}, sipNameNr_ResamplingMethod, 50, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Matrix__ImportMode, {0}}, sipNameNr_ImportMode, 50, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Matrix__ViewType, {0}}, sipNameNr_ViewType, 50, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Matrix__HeaderViewType, {0}}, sipNameNr_HeaderViewType, 50, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_QwtLinearColorMap__Mode, {0}}, sipNameNr_Mode, 77, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_QwtLinearColorMap__Format, {0}}, sipNameNr_Format, 77, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Table__NumericFormat, {0}}, sipNameNr_NumericFormat, 96, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Table__ImportMode, {0}}, sipNameNr_ImportMode, 96, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_Table__PlotDesignation, {0}}, sipNameNr_PlotDesignation, 96, NULL},
    {{-1, 0, 0, SIP_TYPE_ENUM, sipNameNr_MdiSubWindow__CaptionPolicy, {0}}, sipNameNr_CaptionPolicy, 55, NULL},
};


/*
 * This defines each type in this module.
 */
static sipTypeDef *typesTable[] = {
    &sipTypeDef_qti_Anova.super.ctd_base,
    &sipTypeDef_qti_ApplicationWindow.super.ctd_base,
    &enumTypes[7].etd_base,
    &sipTypeDef_qti_ArrowMarker.super.ctd_base,
    &sipTypeDef_qti_BoxCurve.super.ctd_base,
    &enumTypes[19].etd_base,
    &enumTypes[18].etd_base,
    &sipTypeDef_qti_ChiSquareTest.super.ctd_base,
    &sipTypeDef_qti_Convolution.super.ctd_base,
    &sipTypeDef_qti_Correlation.super.ctd_base,
    &sipTypeDef_qti_DataCurve.super.ctd_base,
    &sipTypeDef_qti_Deconvolution.super.ctd_base,
    &sipTypeDef_qti_Differentiation.super.ctd_base,
    &sipTypeDef_qti_EllipseWidget.super.ctd_base,
    &sipTypeDef_qti_ErrorBarsCurve.super.ctd_base,
    &enumTypes[22].etd_base,
    &sipTypeDef_qti_ExponentialFit.super.ctd_base,
    &sipTypeDef_qti_FFT.super.ctd_base,
    &sipTypeDef_qti_FFTFilter.super.ctd_base,
    &enumTypes[1].etd_base,
    &sipTypeDef_qti_Filter.super.ctd_base,
    &sipTypeDef_qti_Fit.super.ctd_base,
    &enumTypes[6].etd_base,
    &enumTypes[5].etd_base,
    &sipTypeDef_qti_Folder.super.ctd_base,
    &sipTypeDef_qti_FrameWidget.super.ctd_base,
    &enumTypes[26].etd_base,
    &enumTypes[25].etd_base,
    &sipTypeDef_qti_FunctionCurve.super.ctd_base,
    &enumTypes[23].etd_base,
    &sipTypeDef_qti_GaussAmpFit.super.ctd_base,
    &sipTypeDef_qti_GaussFit.super.ctd_base,
    &sipTypeDef_qti_Graph.super.ctd_base,
    &sipTypeDef_qti_Graph3D.super.ctd_base,
    &enumTypes[8].etd_base,
    &enumTypes[9].etd_base,
    &enumTypes[15].etd_base,
    &enumTypes[13].etd_base,
    &enumTypes[16].etd_base,
    &enumTypes[14].etd_base,
    &sipTypeDef_qti_Grid.super.ctd_base,
    &sipTypeDef_qti_ImageSymbol.super.ctd_base,
    &sipTypeDef_qti_ImageWidget.super.ctd_base,
    &sipTypeDef_qti_Integration.super.ctd_base,
    &sipTypeDef_qti_Interpolation.super.ctd_base,
    &enumTypes[3].etd_base,
    &sipTypeDef_qti_LegendWidget.super.ctd_base,
    &sipTypeDef_qti_LinearFit.super.ctd_base,
    &sipTypeDef_qti_LogisticFit.super.ctd_base,
    &sipTypeDef_qti_LorentzFit.super.ctd_base,
    &sipTypeDef_qti_Matrix.super.ctd_base,
    &enumTypes[30].etd_base,
    &enumTypes[28].etd_base,
    &enumTypes[27].etd_base,
    &enumTypes[29].etd_base,
    &sipTypeDef_qti_MdiSubWindow.super.ctd_base,
    &enumTypes[36].etd_base,
    &sipTypeDef_qti_MultiLayer.super.ctd_base,
    &enumTypes[10].etd_base,
    &enumTypes[12].etd_base,
    &enumTypes[11].etd_base,
    &sipTypeDef_qti_MultiPeakFit.super.ctd_base,
    &enumTypes[4].etd_base,
    &sipTypeDef_qti_NonLinearFit.super.ctd_base,
    &sipTypeDef_qti_Note.super.ctd_base,
    &sipTypeDef_qti_PieCurve.super.ctd_base,
    &sipTypeDef_qti_PlotCurve.super.ctd_base,
    &sipTypeDef_qti_PluginFit.super.ctd_base,
    &sipTypeDef_qti_PolynomialFit.super.ctd_base,
    &sipTypeDef_qti_PythonScript.super.ctd_base,
    &sipTypeDef_qti_PythonScripting.super.ctd_base,
    &sipTypeDef_qti_QList_0101ArrowMarker.mtd_base,
    &sipTypeDef_qti_QList_0101ErrorBarsCurve.mtd_base,
    &sipTypeDef_qti_QList_0101Folder.mtd_base,
    &sipTypeDef_qti_QList_0101Graph.mtd_base,
    &sipTypeDef_qti_QList_0101MdiSubWindow.mtd_base,
    &sipTypeDef_qti_QwtHistogram.super.ctd_base,
    &sipTypeDef_qti_QwtLinearColorMap.super.ctd_base,
    &enumTypes[32].etd_base,
    &enumTypes[31].etd_base,
    &sipTypeDef_qti_QwtPlot.super.ctd_base,
    &sipTypeDef_qti_QwtPlotCurve.super.ctd_base,
    &sipTypeDef_qti_QwtPlotSpectrogram.super.ctd_base,
    &enumTypes[17].etd_base,
    &sipTypeDef_qti_QwtSymbol.super.ctd_base,
    &enumTypes[24].etd_base,
    &sipTypeDef_qti_RectangleWidget.super.ctd_base,
    &sipTypeDef_qti_ScriptEdit.super.ctd_base,
    &sipTypeDef_qti_ShapiroWilkTest.super.ctd_base,
    &sipTypeDef_qti_SigmoidalFit.super.ctd_base,
    &sipTypeDef_qti_SmoothFilter.super.ctd_base,
    &enumTypes[2].etd_base,
    &sipTypeDef_qti_Spectrogram.super.ctd_base,
    &sipTypeDef_qti_StatisticTest.super.ctd_base,
    &enumTypes[0].etd_base,
    &sipTypeDef_qti_Statistics.super.ctd_base,
    &sipTypeDef_qti_Table.super.ctd_base,
    &enumTypes[34].etd_base,
    &enumTypes[33].etd_base,
    &enumTypes[35].etd_base,
    &sipTypeDef_qti_ThreeExpFit.super.ctd_base,
    &sipTypeDef_qti_TwoExpFit.super.ctd_base,
    &sipTypeDef_qti_VectorCurve.super.ctd_base,
    &enumTypes[20].etd_base,
    &enumTypes[21].etd_base,
    &sipTypeDef_qti_tTest.super.ctd_base,
};


/*
 * This defines the virtual handlers that this module implements and can be
 * used by other modules.
 */
static sipVirtHandlerFunc virtHandlersTable[] = {
    (sipVirtHandlerFunc)sipVH_qti_0,
    (sipVirtHandlerFunc)sipVH_qti_1,
    (sipVirtHandlerFunc)sipVH_qti_2,
    (sipVirtHandlerFunc)sipVH_qti_3,
};


/* This defines the modules that this module needs to import. */
static sipImportedModuleDef importsTable[] = {
    {"PyQt4.QtCore", 1, NULL},
    {"PyQt4.QtGui", -1, NULL},
    {NULL, -1, NULL}
};


/* This defines the class sub-convertors that this module defines. */
static sipSubClassConvertorDef convertorsTable[] = {
    {sipSubClass_ApplicationWindow, {141, 0, 0}, NULL},
    {NULL, {0, 0, 0}, NULL}
};


/* This defines this module. */
sipExportedModuleDef sipModuleAPI_qti = {
    0,
    SIP_API_MINOR_NR,
    sipNameNr_qti,
    0,
    0,
    sipStrings_qti,
    importsTable,
    NULL,
    106,
    typesTable,
    NULL,
    0,
    NULL,
    0,
    NULL,
    virtHandlersTable,
    NULL,
    convertorsTable,
    {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL},
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL
};


/* The SIP API and the APIs of any imported modules. */
const sipAPIDef *sipAPI_qti;
const sipExportedModuleDef *sipModuleAPI_qti_QtCore;
const sipExportedModuleDef *sipModuleAPI_qti_QtGui;

sip_qt_metaobject_func sip_qti_qt_metaobject;
sip_qt_metacall_func sip_qti_qt_metacall;
sip_qt_metacast_func sip_qti_qt_metacast;


/* The Python module initialisation function. */
#if PY_MAJOR_VERSION >= 3
#define SIP_MODULE_ENTRY        PyInit_qti
#define SIP_MODULE_TYPE         PyObject *
#define SIP_MODULE_DISCARD(r)   Py_DECREF(r)
#define SIP_MODULE_RETURN(r)    return (r)
#else
#define SIP_MODULE_ENTRY        initqti
#define SIP_MODULE_TYPE         void
#define SIP_MODULE_DISCARD(r)
#define SIP_MODULE_RETURN(r)    return
#endif

#if defined(SIP_STATIC_MODULE)
extern "C" SIP_MODULE_TYPE SIP_MODULE_ENTRY()
#else
PyMODINIT_FUNC SIP_MODULE_ENTRY()
#endif
{
    static PyMethodDef sip_methods[] = {
        {0, 0, 0, 0}
    };

#if PY_MAJOR_VERSION >= 3
    static PyModuleDef sip_module_def = {
        PyModuleDef_HEAD_INIT,
        "qti",
        NULL,
        -1,
        sip_methods,
        NULL,
        NULL,
        NULL,
        NULL
    };
#endif

    PyObject *sipModule, *sipModuleDict;
    PyObject *sip_sipmod, *sip_capiobj;

    /* Initialise the module and get it's dictionary. */
#if PY_MAJOR_VERSION >= 3
    sipModule = PyModule_Create(&sip_module_def);
#elif PY_VERSION_HEX >= 0x02050000
    sipModule = Py_InitModule(sipName_qti, sip_methods);
#else
    sipModule = Py_InitModule(const_cast<char *>(sipName_qti), sip_methods);
#endif

    if (sipModule == NULL)
        SIP_MODULE_RETURN(NULL);

    sipModuleDict = PyModule_GetDict(sipModule);

    /* Get the SIP module's API. */
#if PY_VERSION_HEX >= 0x02050000
    sip_sipmod = PyImport_ImportModule(SIP_MODULE_NAME);
#else
    sip_sipmod = PyImport_ImportModule(const_cast<char *>(SIP_MODULE_NAME));
#endif

    if (sip_sipmod == NULL)
    {
        SIP_MODULE_DISCARD(sipModule);
        SIP_MODULE_RETURN(NULL);
    }

    sip_capiobj = PyDict_GetItemString(PyModule_GetDict(sip_sipmod), "_C_API");
    Py_DECREF(sip_sipmod);

#if defined(SIP_USE_PYCAPSULE)
    if (sip_capiobj == NULL || !PyCapsule_CheckExact(sip_capiobj))
#else
    if (sip_capiobj == NULL || !PyCObject_Check(sip_capiobj))
#endif
    {
        SIP_MODULE_DISCARD(sipModule);
        SIP_MODULE_RETURN(NULL);
    }

#if defined(SIP_USE_PYCAPSULE)
    sipAPI_qti = reinterpret_cast<const sipAPIDef *>(PyCapsule_GetPointer(sip_capiobj, SIP_MODULE_NAME "._C_API"));
#else
    sipAPI_qti = reinterpret_cast<const sipAPIDef *>(PyCObject_AsVoidPtr(sip_capiobj));
#endif

#if defined(SIP_USE_PYCAPSULE)
    if (sipAPI_qti == NULL)
    {
        SIP_MODULE_DISCARD(sipModule);
        SIP_MODULE_RETURN(NULL);
    }
#endif

    /* Export the module and publish it's API. */
    if (sipExportModule(&sipModuleAPI_qti,SIP_API_MAJOR_NR,SIP_API_MINOR_NR,0) < 0)
    {
        SIP_MODULE_DISCARD(sipModule);
        SIP_MODULE_RETURN(0);
    }

    sip_qti_qt_metaobject = (sip_qt_metaobject_func)sipImportSymbol("qtcore_qt_metaobject");
    sip_qti_qt_metacall = (sip_qt_metacall_func)sipImportSymbol("qtcore_qt_metacall");
    sip_qti_qt_metacast = (sip_qt_metacast_func)sipImportSymbol("qtcore_qt_metacast");

    /* Initialise the module now all its dependencies have been set up. */
    if (sipInitModule(&sipModuleAPI_qti,sipModuleDict) < 0)
    {
        SIP_MODULE_DISCARD(sipModule);
        SIP_MODULE_RETURN(0);
    }

    /* Get the APIs of the modules that this one is dependent on. */
    sipModuleAPI_qti_QtCore = sipModuleAPI_qti.em_imports[0].im_module;
    sipModuleAPI_qti_QtGui = sipModuleAPI_qti.em_imports[1].im_module;

    SIP_MODULE_RETURN(sipModule);
}
